///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainForm.h"
#include "initer.h"
#include "AboutForm.h"
#include "SettsForm.h"
#include "MobFormat.h"
#include "winuser.h"
#include "SearchRepForm.h"
#include "math.h"
#include "KeyChangerForm.h"
#include "MySys.hpp"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SynEdit"
#pragma link "SynEditHighlighter"
#pragma link "SynHighlighterEIScript"
#pragma link "OrientatorFrame"
#pragma link "SynEditMiscClasses"
#pragma link "SynEditSearch"
#pragma resource "*.dfm"
TMainF *MainF;
//---------------------------------------------------------------------------
__fastcall TMainF::TMainF(TComponent* Owner)
        : TForm(Owner)
{
  FirstShowed = false;
  ObjEditorChanging = false;
  ObjEditorActive = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::FormShow(TObject *Sender)
{
  if (FirstShowed == false)
  {
    Caption = MobSurgeon_AppName;
    PLastFocus = NULL;
    BlockingInterfNow = false;

    //      .
    MainF_PK->ActivePage = ScriptSh;

    // ...
    UpdateMainInterf();  //   .
    Set_MC_Interf();    //    .
    if ((VitInfo->Status == VIT_Status_ReleaseCandidat) || (VitInfo->Status == VIT_Status_Release))
    {
      //     -   .
      TestMenuMenu->Visible = false;
    };


    //      ...
    if (ParamCount() > 0)
    {
      //  ,  ...
      OpenMobComm(ParamStr(1));
    };
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainF::ExitMenuClick(TObject *Sender)
{
  Close();  //    -->>   .
}
//---------------------------------------------------------------------------

void __fastcall TMainF::AboutMenuClick(TObject *Sender)
{
  AboutF = new TAboutF(this);
  AboutF->ShowModal();
  delete AboutF;
}
//---------------------------------------------------------------------------

void __fastcall TMainF::TestMenuMenuClick(TObject *Sender)
{
  //     ...

  //.        .
  //   -  
  //    :).
  //ShowMessage(" ....       ?!      ?    ?   -  .... ,   ....");

  //SynEIScriptSyn = TSynEIScriptSyn->Create();
  //SynEIScriptSyn->
  //ScriptEd->Highlighter = SynEIScriptSyn;
  //          :).

  //ShowMessage(IntToStr(MobSignature));

  // ,   ...
  //MobInMm1->LoadMob("startzone.mob");

  // ...
  /*MobInMem1->UsingThread = true;  //   .
  MobInMem1->LogEd = MainF->LogEd;
  MobInMem1->SaveMob(ProgPath+"TestSaveMob.mob");*/

  //__int32 Test = 0;
  //Test = -1;
  //ShowMessage(Test);

  //SUnitObjBlock teststruct;
  //teststruct.Armour = new DynamicArray <String>;
  //teststruct.Armour->Length = 0;

  /*TFileStream *File1;
  File1 = new TFileStream("test1.txt",fmCreate);

  //ShowMessage(MobInMem1->ScriptText.Length());

  //   ...
  File1->Write(&MobInMem1->ScriptText[1],MobInMem1->ScriptText.Length());

  // ...
  delete File1;*/

  //ScriptEd->Enabled = false;
  //ShowMessage(DecimalSeparator);

  //ShowMessage(pow(2,4));

  //ShowMessage(Norm_StrCommaList("1  ,  2  ,3,  4,  5"));

  //this->ValuesEditor->Selection = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TMainF::OpenMobMenuClick(TObject *Sender)
{
  //    .
  OpenMobComm("NULL");
}
//---------------------------------------------------------------------------

void __fastcall TMainF::SaveMob_menuClick(TObject *Sender)
{
  //    .
  if (MobLoaded == true)
  {
    //     ...
    if (ObjEditorActive == true)
    {
      //     -   ....
      this->ValuesEditorExit(Sender);
      ObjEditorActive = true;
    };
    SaveMobComm();
  };
}
//---------------------------------------------------------------------------


void __fastcall TMainF::SaveAsMobMenuClick(TObject *Sender)
{
  //        .
  //     ...
  if (ObjEditorActive == true)
  {
    //     -   ....
    this->ValuesEditorExit(Sender);
    ObjEditorActive = true;
  };
  SaveAsMobComm();
}
//---------------------------------------------------------------------------


void __fastcall TMainF::LogShShow(TObject *Sender)
{
  //   .

  //     ...
  LogEd->SetFocus();
  //  
  LogEd->SelStart = LogEd->Lines->Text.Length()-1;
  //     :)
  LogEd->Perform(WM_VSCROLL,SB_BOTTOM,0);
  
}
//---------------------------------------------------------------------------

void __fastcall TMainF::FormClose(TObject *Sender, TCloseAction &Action)
{
  //   ...

  //.
  bool AllOk; 

  // .
  AllOk = CloseMobComm();

  //    -    .
  if (AllOk == true)
  {
    //   ...
    Save_MC_Interf();  // ...

    // OGL...
    ObjectOrientator->GLDeInitialize();
  }
  else
  {
    //, ,   ).
    Action = caNone;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::ProgSettsMenuClick(TObject *Sender)
{
  SettsF = new TSettsF(this);
  SettsF->ShowModal();
  delete SettsF;
}
//---------------------------------------------------------------------------

void TMainF::BlockInterf()
//  ...
{
  //  -     :).

  BlockingInterfNow = true;

  // 
  ScriptEd->Tag = ScriptEd->Enabled;
  ScriptEd->Enabled = false;
  //
  FileMenu->Tag = FileMenu->Enabled;
  FileMenu->Enabled = false;
  HelpMenu->Tag = HelpMenu->Enabled;
  HelpMenu->Enabled = false;
  //  ...
  ObjectsTree->Tag = ObjectsTree->Enabled;
  ObjectsTree->Enabled = false;
  ValuesEditor->Tag = ValuesEditor->Enabled;
  ValuesEditor->Enabled = false;
  //  
  MC_KR_Param_Name1CB->Tag = MC_KR_Param_Name1CB->Enabled;
  MC_KR_Param_Name1CB->Enabled = false;
  MC_KR_Param_Name1Ed->Tag = MC_KR_Param_Name1Ed->Enabled;
  MC_KR_Param_Name1Ed->Enabled = false;
  MC_KR_Param_Name2CB->Tag = MC_KR_Param_Name2CB->Enabled;
  MC_KR_Param_Name2CB->Enabled = false;
  MC_KR_Param_Name2Ed->Tag = MC_KR_Param_Name2Ed->Enabled;
  MC_KR_Param_Name2Ed->Enabled = false;
  MC_KR_Param_ScriptVariableNameCB->Tag = MC_KR_Param_ScriptVariableNameCB->Enabled;
  MC_KR_Param_ScriptVariableNameCB->Enabled = false;
  MC_KR_Param_ScriptVariableNameEd->Tag = MC_KR_Param_ScriptVariableNameEd->Enabled;
  MC_KR_Param_ScriptVariableNameEd->Enabled = false;
  MC_KR_Param_Model3dCB->Tag = MC_KR_Param_Model3dCB->Enabled;
  MC_KR_Param_Model3dCB->Enabled = false;
  MC_KR_Param_Model3dEd->Tag = MC_KR_Param_Model3dEd->Enabled;
  MC_KR_Param_Model3dEd->Enabled = false;
  MC_KR_Param_FirstTextureCB->Tag = MC_KR_Param_FirstTextureCB->Enabled;
  MC_KR_Param_FirstTextureCB->Enabled = false;
  MC_KR_Param_FirstTextureEd->Tag = MC_KR_Param_FirstTextureEd->Enabled;
  MC_KR_Param_FirstTextureEd->Enabled = false;
  MC_KR_Param_SecondTextureCB->Tag = MC_KR_Param_SecondTextureCB->Enabled;
  MC_KR_Param_SecondTextureCB->Enabled = false;
  MC_KR_Param_SecondTextureEd->Tag = MC_KR_Param_SecondTextureEd->Enabled;
  MC_KR_Param_SecondTextureEd->Enabled = false;
  MC_KR_Param_PlayerNumberCB->Tag = MC_KR_Param_PlayerNumberCB->Enabled;
  MC_KR_Param_PlayerNumberCB->Enabled = false;
  MC_KR_Param_PlayerNumberEd->Tag = MC_KR_Param_PlayerNumberEd->Enabled;
  MC_KR_Param_PlayerNumberEd->Enabled = false;
  MC_KR_Coords_PramouglCB->Tag = MC_KR_Coords_PramouglCB->Enabled;
  MC_KR_Coords_PramouglCB->Enabled = false;
  MC_KR_Coords_Pramougl_X1Ed->Tag = MC_KR_Coords_Pramougl_X1Ed->Enabled;
  MC_KR_Coords_Pramougl_X1Ed->Enabled = false;
  MC_KR_Coords_Pramougl_Y1Ed->Tag = MC_KR_Coords_Pramougl_Y1Ed->Enabled;
  MC_KR_Coords_Pramougl_Y1Ed->Enabled = false;
  MC_KR_Coords_Pramougl_X2Ed->Tag = MC_KR_Coords_Pramougl_X2Ed->Enabled;
  MC_KR_Coords_Pramougl_X2Ed->Enabled = false;
  MC_KR_Coords_Pramougl_Y2Ed->Tag = MC_KR_Coords_Pramougl_Y2Ed->Enabled;
  MC_KR_Coords_Pramougl_Y2Ed->Enabled = false;
  MC_KR_Coords_KrugCB->Tag = MC_KR_Coords_KrugCB->Enabled;
  MC_KR_Coords_KrugCB->Enabled = false;
  MC_KR_Coords_Krug_XEd->Tag = MC_KR_Coords_Krug_XEd->Enabled;
  MC_KR_Coords_Krug_XEd->Enabled = false;
  MC_KR_Coords_Krug_YEd->Tag = MC_KR_Coords_Krug_YEd->Enabled;
  MC_KR_Coords_Krug_YEd->Enabled = false;
  MC_KR_Coords_Krug_RadEd->Tag = MC_KR_Coords_Krug_RadEd->Enabled;
  MC_KR_Coords_Krug_RadEd->Enabled = false;
  MC_KR_Type_UnitCB->Tag = MC_KR_Type_UnitCB->Enabled;
  MC_KR_Type_UnitCB->Enabled = false;
  MC_KR_Type_ObjectCB->Tag = MC_KR_Type_ObjectCB->Enabled;
  MC_KR_Type_ObjectCB->Enabled = false;
  MC_KR_Type_LeverCB->Tag = MC_KR_Type_LeverCB->Enabled;
  MC_KR_Type_LeverCB->Enabled = false;
  MC_KR_Type_TrapCB->Tag = MC_KR_Type_TrapCB->Enabled;
  MC_KR_Type_TrapCB->Enabled = false;
  MC_KR_Type_FlameCB->Tag = MC_KR_Type_FlameCB->Enabled;
  MC_KR_Type_FlameCB->Enabled = false;
  MC_KR_Type_Particle1CB->Tag = MC_KR_Type_Particle1CB->Enabled;
  MC_KR_Type_Particle1CB->Enabled = false;
  MC_KR_Type_Particle2CB->Tag = MC_KR_Type_Particle2CB->Enabled;
  MC_KR_Type_Particle2CB->Enabled = false;
  MC_KR_Type_Particle3CB->Tag = MC_KR_Type_Particle3CB->Enabled;
  MC_KR_Type_Particle3CB->Enabled = false;
  MC_AS_Obj_DelRB->Tag = MC_AS_Obj_DelRB->Enabled;
  MC_AS_Obj_DelRB->Enabled = false;
  MC_AS_Obj_CopyRB->Tag = MC_AS_Obj_CopyRB->Enabled;
  MC_AS_Obj_CopyRB->Enabled = false;
  MC_AS_Obj_MoveRB->Tag = MC_AS_Obj_MoveRB->Enabled;
  MC_AS_Obj_MoveRB->Enabled = false;
  MC_AS_Obj_TargetMobSelBut->Tag = MC_AS_Obj_TargetMobSelBut->Enabled;
  MC_AS_Obj_TargetMobSelBut->Enabled = false;
  MC_AS_Obj_TargetMobEd->Tag = MC_AS_Obj_TargetMobEd->Enabled;
  MC_AS_Obj_TargetMobEd->Enabled = false;
  MC_AS_Obj_ReplaceCB->Tag = MC_AS_Obj_ReplaceCB->Enabled;
  MC_AS_Obj_ReplaceCB->Enabled = false;
  MC_AS_Params_Name1CB->Tag = MC_AS_Params_Name1CB->Enabled;
  MC_AS_Params_Name1CB->Enabled = false;
  MC_AS_Params_Name1Ed->Tag = MC_AS_Params_Name1Ed->Enabled;
  MC_AS_Params_Name1Ed->Enabled = false;
  MC_AS_Params_Name2CB->Tag = MC_AS_Params_Name2CB->Enabled;
  MC_AS_Params_Name2CB->Enabled = false;
  MC_AS_Params_Name2Ed->Tag = MC_AS_Params_Name2Ed->Enabled;
  MC_AS_Params_Name2Ed->Enabled = false;
  MC_AS_Params_ScriptVariableNameCB->Tag = MC_AS_Params_ScriptVariableNameCB->Enabled;
  MC_AS_Params_ScriptVariableNameCB->Enabled = false;
  MC_AS_Params_ScriptVariableNameEd->Tag = MC_AS_Params_ScriptVariableNameEd->Enabled;
  MC_AS_Params_ScriptVariableNameEd->Enabled = false;
  MC_AS_Params_Model3dCB->Tag = MC_AS_Params_Model3dCB->Enabled;
  MC_AS_Params_Model3dCB->Enabled = false;
  MC_AS_Params_Model3dEd->Tag = MC_AS_Params_Model3dEd->Enabled;
  MC_AS_Params_Model3dEd->Enabled = false;
  MC_AS_Params_FirstTextureCB->Tag = MC_AS_Params_FirstTextureCB->Enabled;
  MC_AS_Params_FirstTextureCB->Enabled = false;
  MC_AS_Params_FirstTextureEd->Tag = MC_AS_Params_FirstTextureEd->Enabled;
  MC_AS_Params_FirstTextureEd->Enabled = false;
  MC_AS_Params_SecondTextureCB->Tag = MC_AS_Params_SecondTextureCB->Enabled;
  MC_AS_Params_SecondTextureCB->Enabled = false;
  MC_AS_Params_SecondTextureEd->Tag = MC_AS_Params_SecondTextureEd->Enabled;
  MC_AS_Params_SecondTextureEd->Enabled = false;
  MC_AS_Params_OffsetCB->Tag = MC_AS_Params_OffsetCB->Enabled;
  MC_AS_Params_OffsetCB->Enabled = false;
  MC_AS_Params_OffsetXEd->Tag = MC_AS_Params_OffsetXEd->Enabled;
  MC_AS_Params_OffsetXEd->Enabled = false;
  MC_AS_Params_OffsetYEd->Tag = MC_AS_Params_OffsetYEd->Enabled;
  MC_AS_Params_OffsetYEd->Enabled = false;
  MC_AS_Params_PlayerNumberCB->Tag = MC_AS_Params_PlayerNumberCB->Enabled;
  MC_AS_Params_PlayerNumberCB->Enabled = false;
  MC_AS_Params_PlayerNumberEd->Tag = MC_AS_Params_PlayerNumberEd->Enabled;
  MC_AS_Params_PlayerNumberEd->Enabled = false;
  MC_ResetBut->Tag = MC_ResetBut->Enabled;
  MC_ResetBut->Enabled = false;
  MC_GoBut->Tag = MC_GoBut->Enabled;
  MC_GoBut->Enabled = false;
  MC_AS_Obj_OnlyParamsRB->Tag = MC_AS_Obj_OnlyParamsRB->Enabled;
  MC_AS_Obj_OnlyParamsRB->Enabled = false;

  BlockingInterfNow = false;

};
//---------------------------------------------------------------------------

void TMainF::UnBlockInterf()
//  ...
{
  // 
  ScriptEd->Enabled = ScriptEd->Tag;
  //
  FileMenu->Enabled = FileMenu->Tag;
  HelpMenu->Enabled = HelpMenu->Tag;
  //  ...
  ObjectsTree->Enabled = ObjectsTree->Tag;
  ValuesEditor->Enabled = ValuesEditor->Tag;
  //  
  MC_KR_Param_Name1CB->Enabled = MC_KR_Param_Name1CB->Tag;
  MC_KR_Param_Name1Ed->Enabled = MC_KR_Param_Name1Ed->Tag;
  MC_KR_Param_Name2CB->Enabled = MC_KR_Param_Name2CB->Tag;
  MC_KR_Param_Name2Ed->Enabled = MC_KR_Param_Name2Ed->Tag;
  MC_KR_Param_ScriptVariableNameCB->Enabled = MC_KR_Param_ScriptVariableNameCB->Tag;
  MC_KR_Param_ScriptVariableNameEd->Enabled = MC_KR_Param_ScriptVariableNameEd->Tag;
  MC_KR_Param_Model3dCB->Enabled = MC_KR_Param_Model3dCB->Tag;
  MC_KR_Param_Model3dEd->Enabled = MC_KR_Param_Model3dEd->Tag;
  MC_KR_Param_FirstTextureCB->Enabled = MC_KR_Param_FirstTextureCB->Tag;
  MC_KR_Param_FirstTextureEd->Enabled = MC_KR_Param_FirstTextureEd->Tag;
  MC_KR_Param_SecondTextureCB->Enabled = MC_KR_Param_SecondTextureCB->Tag;
  MC_KR_Param_SecondTextureEd->Enabled = MC_KR_Param_SecondTextureEd->Tag;
  MC_KR_Param_PlayerNumberCB->Enabled = MC_KR_Param_PlayerNumberCB->Tag;
  MC_KR_Param_PlayerNumberEd->Enabled = MC_KR_Param_PlayerNumberEd->Tag;
  MC_KR_Coords_PramouglCB->Enabled = MC_KR_Coords_PramouglCB->Tag;
  MC_KR_Coords_Pramougl_X1Ed->Enabled = MC_KR_Coords_Pramougl_X1Ed->Tag;
  MC_KR_Coords_Pramougl_Y1Ed->Enabled = MC_KR_Coords_Pramougl_Y1Ed->Tag;
  MC_KR_Coords_Pramougl_X2Ed->Enabled = MC_KR_Coords_Pramougl_X2Ed->Tag;
  MC_KR_Coords_Pramougl_Y2Ed->Enabled = MC_KR_Coords_Pramougl_Y2Ed->Tag;
  MC_KR_Coords_KrugCB->Enabled = MC_KR_Coords_KrugCB->Tag;
  MC_KR_Coords_Krug_XEd->Enabled = MC_KR_Coords_Krug_XEd->Tag;
  MC_KR_Coords_Krug_YEd->Enabled = MC_KR_Coords_Krug_YEd->Tag;
  MC_KR_Coords_Krug_RadEd->Enabled = MC_KR_Coords_Krug_RadEd->Tag;
  MC_KR_Type_UnitCB->Enabled = MC_KR_Type_UnitCB->Tag;
  MC_KR_Type_ObjectCB->Enabled = MC_KR_Type_ObjectCB->Tag;
  MC_KR_Type_LeverCB->Enabled = MC_KR_Type_LeverCB->Tag;
  MC_KR_Type_TrapCB->Enabled = MC_KR_Type_TrapCB->Tag;
  MC_KR_Type_FlameCB->Enabled = MC_KR_Type_FlameCB->Tag;
  MC_KR_Type_Particle1CB->Enabled = MC_KR_Type_Particle1CB->Tag;
  MC_KR_Type_Particle2CB->Enabled = MC_KR_Type_Particle2CB->Tag;
  MC_KR_Type_Particle3CB->Enabled = MC_KR_Type_Particle3CB->Tag;
  MC_AS_Obj_DelRB->Enabled = MC_AS_Obj_DelRB->Tag;
  MC_AS_Obj_CopyRB->Enabled = MC_AS_Obj_CopyRB->Tag;
  MC_AS_Obj_MoveRB->Enabled = MC_AS_Obj_MoveRB->Tag;
  MC_AS_Obj_TargetMobSelBut->Enabled = MC_AS_Obj_TargetMobSelBut->Tag;
  MC_AS_Obj_TargetMobEd->Enabled = MC_AS_Obj_TargetMobEd->Tag;
  MC_AS_Obj_ReplaceCB->Enabled = MC_AS_Obj_ReplaceCB->Tag;
  MC_AS_Params_Name1CB->Enabled = MC_AS_Params_Name1CB->Tag;
  MC_AS_Params_Name1Ed->Enabled = MC_AS_Params_Name1Ed->Tag;
  MC_AS_Params_Name2CB->Enabled = MC_AS_Params_Name2CB->Tag;
  MC_AS_Params_Name2Ed->Enabled = MC_AS_Params_Name2Ed->Tag;
  MC_AS_Params_ScriptVariableNameCB->Enabled = MC_AS_Params_ScriptVariableNameCB->Tag;
  MC_AS_Params_ScriptVariableNameEd->Enabled = MC_AS_Params_ScriptVariableNameEd->Tag;
  MC_AS_Params_Model3dCB->Enabled = MC_AS_Params_Model3dCB->Tag;
  MC_AS_Params_Model3dEd->Enabled = MC_AS_Params_Model3dEd->Tag;
  MC_AS_Params_FirstTextureCB->Enabled = MC_AS_Params_FirstTextureCB->Tag;
  MC_AS_Params_FirstTextureEd->Enabled = MC_AS_Params_FirstTextureEd->Tag;
  MC_AS_Params_SecondTextureCB->Enabled = MC_AS_Params_SecondTextureCB->Tag;
  MC_AS_Params_SecondTextureEd->Enabled = MC_AS_Params_SecondTextureEd->Tag;
  MC_AS_Params_OffsetCB->Enabled = MC_AS_Params_OffsetCB->Tag;
  MC_AS_Params_OffsetXEd->Enabled = MC_AS_Params_OffsetXEd->Tag;
  MC_AS_Params_OffsetYEd->Enabled = MC_AS_Params_OffsetYEd->Tag;
  MC_AS_Params_PlayerNumberCB->Enabled = MC_AS_Params_PlayerNumberCB->Tag;
  MC_AS_Params_PlayerNumberEd->Enabled = MC_AS_Params_PlayerNumberEd->Tag;
  MC_ResetBut->Enabled = MC_ResetBut->Tag;
  MC_GoBut->Enabled = MC_GoBut->Tag;
  MC_AS_Obj_OnlyParamsRB->Enabled = MC_AS_Obj_OnlyParamsRB->Tag;

  //      ...
  ReturnFocus();
};
//---------------------------------------------------------------------------

void TMainF::ReturnFocus()
//     :).
{
  //   :).
  if (PLastFocus != NULL)
  {
      PLastFocus->SetFocus();
  };  
};
//---------------------------------------------------------------------------
void __fastcall TMainF::ScriptEdEnter(TObject *Sender)
{
  //   ...
  PLastFocus = ScriptEd;
  UpdateEditMenu();
}
//---------------------------------------------------------------------------

void __fastcall TMainF::ScriptEdExit(TObject *Sender)
{
  if (BlockingInterfNow == false)
  {
    //        ...
    PLastFocus = NULL;   //   .
  };

  UpdateEditMenu();  
}
//---------------------------------------------------------------------------

void TMainF::UpdateMainInterf()
//     .    :).
{
  // ...    -      .
  Caption = MobSurgeon_AppName;
  Application->Title = MobSurgeon_AppName;
  UpdateEditMenu();  // .
  if (MobLoaded == true)
  {
    //  -    ...
    Caption = Caption + ' ' + ExtractFileName(MobFileName);
    if (MobModified == true) Caption = Caption + " *";    //   .
    Application->Title = ExtractFileName(MobFileName);
  };

  // -           ...
  if (MobLoaded == true)
  {
    // .

    // ...
    SaveMob_menu->Enabled = true;
    SaveAsMobMenu->Enabled = true;
    BackupMobMenu->Enabled = true;
    CloseMobMenu->Enabled = true;

    //  ...
    ScriptEd->Enabled = true;
    if (MainF_PK->ActivePage == ScriptSh)
    {
      PLastFocus = ScriptEd;
      ReturnFocus();
      UpdateEditMenu();  // .
    };

    //   ...
    ObjectsTree->Enabled = true;
    ValuesEditor->Enabled = true;

    //    
    MC_KR_Param_Name1CB->Enabled = true;
    MC_KR_Param_Name1Ed->Enabled = true;
    MC_KR_Param_Name2CB->Enabled = true;
    MC_KR_Param_Name2Ed->Enabled = true;
    MC_KR_Param_ScriptVariableNameCB->Enabled = true;
    MC_KR_Param_ScriptVariableNameEd->Enabled = true;
    MC_KR_Param_Model3dCB->Enabled = true;
    MC_KR_Param_Model3dEd->Enabled = true;
    MC_KR_Param_FirstTextureCB->Enabled = true;
    MC_KR_Param_FirstTextureEd->Enabled = true;
    MC_KR_Param_SecondTextureCB->Enabled = true;
    MC_KR_Param_SecondTextureEd->Enabled = true;
    MC_KR_Param_PlayerNumberCB->Enabled = true;
    MC_KR_Param_PlayerNumberEd->Enabled = true;
    MC_KR_Coords_PramouglCB->Enabled = true;
    MC_KR_Coords_Pramougl_X1Ed->Enabled = true;
    MC_KR_Coords_Pramougl_Y1Ed->Enabled = true;
    MC_KR_Coords_Pramougl_X2Ed->Enabled = true;
    MC_KR_Coords_Pramougl_Y2Ed->Enabled = true;
    MC_KR_Coords_KrugCB->Enabled = true;
    MC_KR_Coords_Krug_XEd->Enabled = true;
    MC_KR_Coords_Krug_YEd->Enabled = true;
    MC_KR_Coords_Krug_RadEd->Enabled = true;
    MC_KR_Type_UnitCB->Enabled = true;
    MC_KR_Type_ObjectCB->Enabled = true;
    MC_KR_Type_LeverCB->Enabled = true;
    MC_KR_Type_TrapCB->Enabled = true;
    MC_KR_Type_FlameCB->Enabled = true;
    MC_KR_Type_Particle1CB->Enabled = true;
    MC_KR_Type_Particle2CB->Enabled = true;
    MC_KR_Type_Particle3CB->Enabled = true;
    MC_AS_Obj_DelRB->Enabled = true;
    MC_AS_Obj_CopyRB->Enabled = true;
    MC_AS_Obj_MoveRB->Enabled = true;
    MC_AS_Obj_TargetMobSelBut->Enabled = true;
    MC_AS_Obj_TargetMobEd->Enabled = true;
    MC_AS_Obj_ReplaceCB->Enabled = true;
    MC_AS_Params_Name1CB->Enabled = true;
    MC_AS_Params_Name1Ed->Enabled = true;
    MC_AS_Params_Name2CB->Enabled = true;
    MC_AS_Params_Name2Ed->Enabled = true;
    MC_AS_Params_ScriptVariableNameCB->Enabled = true;
    MC_AS_Params_ScriptVariableNameEd->Enabled = true;
    MC_AS_Params_Model3dCB->Enabled = true;
    MC_AS_Params_Model3dEd->Enabled = true;
    MC_AS_Params_FirstTextureCB->Enabled = true;
    MC_AS_Params_FirstTextureEd->Enabled = true;
    MC_AS_Params_SecondTextureCB->Enabled = true;
    MC_AS_Params_SecondTextureEd->Enabled = true;
    MC_AS_Params_OffsetCB->Enabled = true;
    MC_AS_Params_OffsetXEd->Enabled = true;
    MC_AS_Params_OffsetYEd->Enabled = true;
    MC_AS_Params_PlayerNumberCB->Enabled = true;
    MC_AS_Params_PlayerNumberEd->Enabled = true;
    MC_ResetBut->Enabled = true;
    MC_GoBut->Enabled = true;
    MC_AS_Obj_OnlyParamsRB->Enabled = true;
    MC_AS_UpdDel();  //          .

  }
  else
  {
    //    ().

    // ...
    SaveMob_menu->Enabled = false;
    SaveAsMobMenu->Enabled = false;
    BackupMobMenu->Enabled = false;
    CloseMobMenu->Enabled = false;

    //  ...
    ScriptEd->Enabled = false;

    //   ...
    ObjectsTree->Enabled = false;
    ValuesEditor->Enabled = false;

    //    
    MC_KR_Param_Name1CB->Enabled = false;
    MC_KR_Param_Name1Ed->Enabled = false;
    MC_KR_Param_Name2CB->Enabled = false;
    MC_KR_Param_Name2Ed->Enabled = false;
    MC_KR_Param_ScriptVariableNameCB->Enabled = false;
    MC_KR_Param_ScriptVariableNameEd->Enabled = false;
    MC_KR_Param_Model3dCB->Enabled = false;
    MC_KR_Param_Model3dEd->Enabled = false;
    MC_KR_Param_FirstTextureCB->Enabled = false;
    MC_KR_Param_FirstTextureEd->Enabled = false;
    MC_KR_Param_SecondTextureCB->Enabled = false;
    MC_KR_Param_SecondTextureEd->Enabled = false;
    MC_KR_Param_PlayerNumberCB->Enabled = false;
    MC_KR_Param_PlayerNumberEd->Enabled = false;
    MC_KR_Coords_PramouglCB->Enabled = false;
    MC_KR_Coords_Pramougl_X1Ed->Enabled = false;
    MC_KR_Coords_Pramougl_Y1Ed->Enabled = false;
    MC_KR_Coords_Pramougl_X2Ed->Enabled = false;
    MC_KR_Coords_Pramougl_Y2Ed->Enabled = false;
    MC_KR_Coords_KrugCB->Enabled = false;
    MC_KR_Coords_Krug_XEd->Enabled = false;
    MC_KR_Coords_Krug_YEd->Enabled = false;
    MC_KR_Coords_Krug_RadEd->Enabled = false;
    MC_KR_Type_UnitCB->Enabled = false;
    MC_KR_Type_ObjectCB->Enabled = false;
    MC_KR_Type_LeverCB->Enabled = false;
    MC_KR_Type_TrapCB->Enabled = false;
    MC_KR_Type_FlameCB->Enabled = false;
    MC_KR_Type_Particle1CB->Enabled = false;
    MC_KR_Type_Particle2CB->Enabled = false;
    MC_KR_Type_Particle3CB->Enabled = false;
    MC_AS_Obj_DelRB->Enabled = false;
    MC_AS_Obj_CopyRB->Enabled = false;
    MC_AS_Obj_MoveRB->Enabled = false;
    MC_AS_Obj_TargetMobSelBut->Enabled = false;
    MC_AS_Obj_TargetMobEd->Enabled = false;
    MC_AS_Obj_ReplaceCB->Enabled = false;
    MC_AS_Params_Name1CB->Enabled = false;
    MC_AS_Params_Name1Ed->Enabled = false;
    MC_AS_Params_Name2CB->Enabled = false;
    MC_AS_Params_Name2Ed->Enabled = false;
    MC_AS_Params_ScriptVariableNameCB->Enabled = false;
    MC_AS_Params_ScriptVariableNameEd->Enabled = false;
    MC_AS_Params_Model3dCB->Enabled = false;
    MC_AS_Params_Model3dEd->Enabled = false;
    MC_AS_Params_FirstTextureCB->Enabled = false;
    MC_AS_Params_FirstTextureEd->Enabled = false;
    MC_AS_Params_SecondTextureCB->Enabled = false;
    MC_AS_Params_SecondTextureEd->Enabled = false;
    MC_AS_Params_OffsetCB->Enabled = false;
    MC_AS_Params_OffsetXEd->Enabled = false;
    MC_AS_Params_OffsetYEd->Enabled = false;
    MC_AS_Params_PlayerNumberCB->Enabled = false;
    MC_AS_Params_PlayerNumberEd->Enabled = false;
    MC_ResetBut->Enabled = false;
    MC_GoBut->Enabled = false;
    MC_AS_Obj_OnlyParamsRB->Enabled = false;
    
  };

};
//---------------------------------------------------------------------------


void __fastcall TMainF::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  //   
  if ( (Key == 'S') && ( Shift.Contains(ssCtrl)) && (Shift.Contains(ssShift) == false))
  {
    //   ...
    if (SaveMob_menu->Enabled == true)
    {
      SaveMob_menuClick(Sender);
    };

    //    :)
    Key = NULL;
  };

  if ( (Key == 'S') && ( Shift.Contains(ssCtrl)) && (Shift.Contains(ssShift)) )
  {
    //    ...
    if (SaveAsMobMenu->Enabled == true)
    {
      SaveAsMobMenuClick(Sender);
    };

    //    :)
    Key = NULL;
  };

  if ( (Key == 'O') && ( Shift.Contains(ssCtrl)) )
  {
    //   ...
    if (OpenMobMenu->Enabled == true)
    {
      OpenMobMenuClick(Sender);
    };

    //    :)
    Key = NULL;
  };

  if ( (Key == 'F') && ( Shift.Contains(ssCtrl)) )
  {
    // .
    if (SearchRepMenu->Enabled == true)
    {
      SearchRepMenuClick(Sender);
    };

    //    :)
    Key = NULL;
  };

  if (Key == VK_F3)
  {
    //  .
    if (SearchNextMenu->Enabled == true)
    {
      SearchNextMenuClick(Sender);
    };

    //    :)
    Key = NULL;
  };

  if ( (Key == 'R') && ( Shift.Contains(ssCtrl)) )
  {
    // ...
    if (ReplaceNextMenu->Enabled == true)
    {
      ReplaceNextMenuClick(Sender);
    };

    //    :)
    Key = NULL;
  };

  if ( (Key == 'K') && ( Shift.Contains(ssCtrl)) && (Shift.Contains(ssShift)) && (Shift.Contains(ssAlt)) )
  {
    if (MobLoaded == true)
    {
      //   .
      KeyChangerF = new TKeyChangerF(this);
      KeyChangerF->KeyEditF->Text = IntToStr(MobInMem1->ScriptKey);
      KeyChangerF->ShowModal();
      if (KeyChangerF->ModalResult == mrOk)
      {
        //  -  .
        MobInMem1->ScriptKey = StrToInt(KeyChangerF->KeyEditF->Text);
      };
      delete KeyChangerF;
    };

    //    :)
    Key = NULL;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::BackupMobMenuClick(TObject *Sender)
{
  // 1
  MakeUserBackup(MobFileName);
}
//---------------------------------------------------------------------------

void TMainF::UpdateEditMenu()
//    :).
{
  if (PLastFocus == ScriptEd)
  {
    //    .
    UndoMenu->Enabled = true;
    RedoMenu->Enabled = true;
    CopyMenu->Enabled = true;
    CutMenu->Enabled = true;
    PasteMenu->Enabled = true;
    SelectAllMenu->Enabled = true;
    SearchRepMenu->Enabled = true;
    SearchNextMenu->Enabled = true;
    ReplaceNextMenu->Enabled = true;
  }
  else
  {
    // ...
    UndoMenu->Enabled = false;
    RedoMenu->Enabled = false;
    CopyMenu->Enabled = false;
    CutMenu->Enabled = false;
    PasteMenu->Enabled = false;
    SelectAllMenu->Enabled = false;
    SearchRepMenu->Enabled = false;
    SearchNextMenu->Enabled = false;
    ReplaceNextMenu->Enabled = false;
  };
};
//---------------------------------------------------------------------------

void __fastcall TMainF::SearchRepMenuClick(TObject *Sender)
{
  //   ...
  SearchRepF = new TSearchRepF(this);
  SearchRepF->ShowModal();
  delete SearchRepF;

  //    -    :)
  if (SearchDialCanceled == false)
  {
    if (MakeReplace == false)
    {
      //  .
      MakeASearch();
    }
    else
    {
      //  ...
      MakeAReplace();
    };
  };
}
//---------------------------------------------------------------------------

void TMainF::MakeASearch()
//       
{
  if (SearchStr.Length() != 0)
  {
    //   ...
    TSynSearchOptions SO;
    ScriptEd->SearchReplace(SearchStr,NULL,SO);
  };
};
//---------------------------------------------------------------------------

void TMainF::MakeAReplace()
//       
{
  if ( (SearchStr.Length() != 0) && (RepStr.Length() != 0) && (MakeReplace == true) )
  {
    //   ,      ...
    TSynSearchOptions SO;
    SO << ssoReplace;
    SO << ssoPrompt;
    ScriptEd->SearchReplace(SearchStr,RepStr,SO);
  };
};
//---------------------------------------------------------------------------

void __fastcall TMainF::UndoMenuClick(TObject *Sender)
{
  ScriptEd->Undo();        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::RedoMenuClick(TObject *Sender)
{
  ScriptEd->Redo();        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::CopyMenuClick(TObject *Sender)
{
  ScriptEd->CopyToClipboard();        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::CutMenuClick(TObject *Sender)
{
  ScriptEd->CutToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TMainF::PasteMenuClick(TObject *Sender)
{
  ScriptEd->PasteFromClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TMainF::SelectAllMenuClick(TObject *Sender)
{
  ScriptEd->SelectAll();        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::SearchNextMenuClick(TObject *Sender)
{
  //   ...
  MakeASearch();        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::ReplaceNextMenuClick(TObject *Sender)
{
  //    ...
  MakeAReplace();
}
//---------------------------------------------------------------------------


void __fastcall TMainF::MC_KR_Param_Name1EdChange(TObject *Sender)
{
  //   . 
  if (MC_KR_Param_Name1Ed->Text.Length() == 0)
  {
    MC_KR_Param_Name1CB->Checked = false;
  }
  else
  {
    MC_KR_Param_Name1CB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Param_Name2EdChange(TObject *Sender)
{
  //   . 
  if (MC_KR_Param_Name2Ed->Text.Length() == 0)
  {
    MC_KR_Param_Name2CB->Checked = false;
  }
  else
  {
    MC_KR_Param_Name2CB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Param_ScriptVariableNameEdChange(
      TObject *Sender)
{
  //   . 
  if (MC_KR_Param_ScriptVariableNameEd->Text.Length() == 0)
  {
    MC_KR_Param_ScriptVariableNameCB->Checked = false;
  }
  else
  {
    MC_KR_Param_ScriptVariableNameCB->Checked = true;
  };        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Param_Model3dEdChange(TObject *Sender)
{
  //   . 
  if (MC_KR_Param_Model3dEd->Text.Length() == 0)
  {
    MC_KR_Param_Model3dCB->Checked = false;
  }
  else
  {
    MC_KR_Param_Model3dCB->Checked = true;
  };        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Param_FirstTextureEdChange(TObject *Sender)
{
  //   . 
  if (MC_KR_Param_FirstTextureEd->Text.Length() == 0)
  {
    MC_KR_Param_FirstTextureCB->Checked = false;
  }
  else
  {
    MC_KR_Param_FirstTextureCB->Checked = true;
  };        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Param_SecondTextureEdChange(TObject *Sender)
{
  //   . 
  if (MC_KR_Param_SecondTextureEd->Text.Length() == 0)
  {
    MC_KR_Param_SecondTextureCB->Checked = false;
  }
  else
  {
    MC_KR_Param_SecondTextureCB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Coords_Pramougl_X1EdChange(TObject *Sender)
{
  //   . 
  if ( (MC_KR_Coords_Pramougl_X1Ed->Text.Length() == 0) ||
    (MC_KR_Coords_Pramougl_Y1Ed->Text.Length() == 0) ||
    (MC_KR_Coords_Pramougl_X2Ed->Text.Length() == 0) ||
    (MC_KR_Coords_Pramougl_Y2Ed->Text.Length() == 0) )
  {
    MC_KR_Coords_PramouglCB->Checked = false;
  };
  if ( (MC_KR_Coords_Pramougl_X1Ed->Text.Length() != 0) &&
    (MC_KR_Coords_Pramougl_Y1Ed->Text.Length() != 0) &&
    (MC_KR_Coords_Pramougl_X2Ed->Text.Length() != 0) &&
    (MC_KR_Coords_Pramougl_Y2Ed->Text.Length() != 0) )
  {
    MC_KR_Coords_PramouglCB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Coords_Pramougl_Y1EdChange(TObject *Sender)
{
  MC_KR_Coords_Pramougl_X1EdChange(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Coords_Pramougl_X2EdChange(TObject *Sender)
{
  MC_KR_Coords_Pramougl_X1EdChange(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Coords_Pramougl_Y2EdChange(TObject *Sender)
{
  MC_KR_Coords_Pramougl_X1EdChange(Sender);        
}
//---------------------------------------------------------------------------


void __fastcall TMainF::MC_KR_Coords_Krug_XEdChange(TObject *Sender)
{
  //   . 
  if ( (MC_KR_Coords_Krug_XEd->Text.Length() == 0) ||
    (MC_KR_Coords_Krug_YEd->Text.Length() == 0) ||
    (MC_KR_Coords_Krug_RadEd->Text.Length() == 0) )
  {
    MC_KR_Coords_KrugCB->Checked = false;
  };
  if ( (MC_KR_Coords_Krug_XEd->Text.Length() != 0) &&
    (MC_KR_Coords_Krug_YEd->Text.Length() != 0) &&
    (MC_KR_Coords_Krug_RadEd->Text.Length() != 0) )
  {
    MC_KR_Coords_KrugCB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Coords_Krug_YEdChange(TObject *Sender)
{
  MC_KR_Coords_Krug_XEdChange(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Coords_Krug_RadEdChange(TObject *Sender)
{
  MC_KR_Coords_Krug_XEdChange(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Params_Name1EdChange(TObject *Sender)
{
  //   . 
  if (MC_AS_Params_Name1Ed->Text.Length() == 0)
  {
    MC_AS_Params_Name1CB->Checked = false;
  }
  else
  {
    MC_AS_Params_Name1CB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Params_Name2EdChange(TObject *Sender)
{
  //   . 
  if (MC_AS_Params_Name2Ed->Text.Length() == 0)
  {
    MC_AS_Params_Name2CB->Checked = false;
  }
  else
  {
    MC_AS_Params_Name2CB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Params_ScriptVariableNameEdChange(
      TObject *Sender)
{
  //   . 
  if (MC_AS_Params_ScriptVariableNameEd->Text.Length() == 0)
  {
    MC_AS_Params_ScriptVariableNameCB->Checked = false;
  }
  else
  {
    MC_AS_Params_ScriptVariableNameCB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Params_Model3dEdChange(TObject *Sender)
{
  //   . 
  if (MC_AS_Params_Model3dEd->Text.Length() == 0)
  {
    MC_AS_Params_Model3dCB->Checked = false;
  }
  else
  {
    MC_AS_Params_Model3dCB->Checked = true;
  }; 
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Params_FirstTextureEdChange(TObject *Sender)
{
  //   . 
  if (MC_AS_Params_FirstTextureEd->Text.Length() == 0)
  {
    MC_AS_Params_FirstTextureCB->Checked = false;
  }
  else
  {
    MC_AS_Params_FirstTextureCB->Checked = true;
  };         
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Params_SecondTextureEdChange(TObject *Sender)
{
  //   . 
  if (MC_AS_Params_SecondTextureEd->Text.Length() == 0)
  {
    MC_AS_Params_SecondTextureCB->Checked = false;
  }
  else
  {
    MC_AS_Params_SecondTextureCB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Params_OffsetXEdChange(TObject *Sender)
{
  //   . 
  if ( (MC_AS_Params_OffsetXEd->Text.Length() == 0) ||
    (MC_AS_Params_OffsetYEd->Text.Length() == 0) )
  {
    MC_AS_Params_OffsetCB->Checked = false;
  };
  if ( (MC_AS_Params_OffsetXEd->Text.Length() != 0) &&
    (MC_AS_Params_OffsetYEd->Text.Length() != 0) )
  {
    MC_AS_Params_OffsetCB->Checked = true;
  };
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Params_OffsetYEdChange(TObject *Sender)
{
  MC_AS_Params_OffsetXEdChange(Sender);        
}
//---------------------------------------------------------------------------

void TMainF::MC_AS_UpdDel()
//           
// -  \  .
{
  if (MobLoaded == true)
  {
    //  -1 .
    if (MC_AS_Obj_DelRB->Checked == true)
    {
      //    ...
      MC_AS_Params_Name1CB->Enabled = false;
      MC_AS_Params_Name1Ed->Enabled = false;
      MC_AS_Params_Name2CB->Enabled = false;
      MC_AS_Params_Name2Ed->Enabled = false;
      MC_AS_Params_ScriptVariableNameCB->Enabled = false;
      MC_AS_Params_ScriptVariableNameEd->Enabled = false;
      MC_AS_Params_Model3dCB->Enabled = false;
      MC_AS_Params_Model3dEd->Enabled = false;
      MC_AS_Params_FirstTextureCB->Enabled = false;
      MC_AS_Params_FirstTextureEd->Enabled = false;
      MC_AS_Params_SecondTextureCB->Enabled = false;
      MC_AS_Params_SecondTextureEd->Enabled = false;
      MC_AS_Params_OffsetCB->Enabled = false;
      MC_AS_Params_OffsetXEd->Enabled = false;
      MC_AS_Params_OffsetYEd->Enabled = false;
    }
    else
    {
      //    ...
      MC_AS_Params_Name1CB->Enabled = true;
      MC_AS_Params_Name1Ed->Enabled = true;
      MC_AS_Params_Name2CB->Enabled = true;
      MC_AS_Params_Name2Ed->Enabled = true;
      MC_AS_Params_ScriptVariableNameCB->Enabled = true;
      MC_AS_Params_ScriptVariableNameEd->Enabled = true;
      MC_AS_Params_Model3dCB->Enabled = true;
      MC_AS_Params_Model3dEd->Enabled = true;
      MC_AS_Params_FirstTextureCB->Enabled = true;
      MC_AS_Params_FirstTextureEd->Enabled = true;
      MC_AS_Params_SecondTextureCB->Enabled = true;
      MC_AS_Params_SecondTextureEd->Enabled = true;
      MC_AS_Params_OffsetCB->Enabled = true;
      MC_AS_Params_OffsetXEd->Enabled = true;
      MC_AS_Params_OffsetYEd->Enabled = true;
    };
  };
};

void __fastcall TMainF::MC_AS_Obj_DelRBClick(TObject *Sender)
{
  MC_AS_UpdDel();        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Obj_CopyRBClick(TObject *Sender)
{
  MC_AS_UpdDel();        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Obj_MoveRBClick(TObject *Sender)
{
  MC_AS_UpdDel();        
}
//---------------------------------------------------------------------------

void TMainF::Set_MC_Interf()
// .    ini    .
{
  MC_KR_Param_Name1Ed->Text = MC_KR_Param_Name1Ed_ini;
  MC_KR_Param_Name2Ed->Text = MC_KR_Param_Name2Ed_ini;
  MC_KR_Param_ScriptVariableNameEd->Text = MC_KR_Param_ScriptVariableNameEd_ini;
  MC_KR_Param_Model3dEd->Text = MC_KR_Param_Model3dEd_ini;
  MC_KR_Param_FirstTextureEd->Text = MC_KR_Param_FirstTextureEd_ini;
  MC_KR_Param_SecondTextureEd->Text = MC_KR_Param_SecondTextureEd_ini;
  MC_KR_Param_PlayerNumberEd->Text = MC_KR_Param_PlayerNumberEd_ini;
  MC_KR_Coords_Pramougl_X1Ed->Text = MC_KR_Coords_Pramougl_X1Ed_ini;
  MC_KR_Coords_Pramougl_Y1Ed->Text = MC_KR_Coords_Pramougl_Y1Ed_ini;
  MC_KR_Coords_Pramougl_X2Ed->Text = MC_KR_Coords_Pramougl_X2Ed_ini;
  MC_KR_Coords_Pramougl_Y2Ed->Text = MC_KR_Coords_Pramougl_Y2Ed_ini;
  MC_KR_Coords_Krug_XEd->Text = MC_KR_Coords_Krug_XEd_ini;
  MC_KR_Coords_Krug_YEd->Text = MC_KR_Coords_Krug_YEd_ini;
  MC_KR_Coords_Krug_RadEd->Text = MC_KR_Coords_Krug_RadEd_ini;
  MC_AS_Obj_TargetMobEd->Text = MC_AS_Obj_TargetMobEd_ini;
  MC_AS_Params_Name1Ed->Text = MC_AS_Params_Name1Ed_ini;
  MC_AS_Params_Name2Ed->Text = MC_AS_Params_Name2Ed_ini;
  MC_AS_Params_ScriptVariableNameEd->Text = MC_AS_Params_ScriptVariableNameEd_ini;
  MC_AS_Params_Model3dEd->Text = MC_AS_Params_Model3dEd_ini;
  MC_AS_Params_FirstTextureEd->Text = MC_AS_Params_FirstTextureEd_ini;
  MC_AS_Params_SecondTextureEd->Text = MC_AS_Params_SecondTextureEd_ini;
  MC_AS_Params_OffsetXEd->Text = MC_AS_Params_OffsetXEd_ini;
  MC_AS_Params_OffsetYEd->Text = MC_AS_Params_OffsetYEd_ini;
  MC_AS_Params_PlayerNumberEd->Text = MC_AS_Params_PlayerNumberEd_ini;
  MC_KR_Param_Name1CB->Checked = MC_KR_Param_Name1CB_ini;
  MC_KR_Param_Name2CB->Checked = MC_KR_Param_Name2CB_ini;
  MC_KR_Param_ScriptVariableNameCB->Checked = MC_KR_Param_ScriptVariableNameCB_ini;
  MC_KR_Param_Model3dCB->Checked = MC_KR_Param_Model3dCB_ini;
  MC_KR_Param_FirstTextureCB->Checked = MC_KR_Param_FirstTextureCB_ini;
  MC_KR_Param_SecondTextureCB->Checked = MC_KR_Param_SecondTextureCB_ini;
  MC_KR_Param_PlayerNumberCB->Checked = MC_KR_Param_PlayerNumberCB_ini;
  MC_KR_Coords_PramouglCB->Checked = MC_KR_Coords_PramouglCB_ini;
  MC_KR_Coords_KrugCB->Checked = MC_KR_Coords_KrugCB_ini;
  MC_KR_Type_UnitCB->Checked = MC_KR_Type_UnitCB_ini;
  MC_KR_Type_ObjectCB->Checked = MC_KR_Type_ObjectCB_ini;
  MC_KR_Type_LeverCB->Checked = MC_KR_Type_LeverCB_ini;
  MC_KR_Type_TrapCB->Checked = MC_KR_Type_TrapCB_ini;
  MC_KR_Type_FlameCB->Checked = MC_KR_Type_FlameCB_ini;
  MC_KR_Type_Particle1CB->Checked = MC_KR_Type_Particle1CB_ini;
  MC_KR_Type_Particle2CB->Checked = MC_KR_Type_Particle2CB_ini;
  MC_KR_Type_Particle3CB->Checked = MC_KR_Type_Particle3CB_ini;
  MC_AS_Obj_DelRB->Checked = MC_AS_Obj_DelRB_ini;
  MC_AS_Obj_CopyRB->Checked = MC_AS_Obj_CopyRB_ini;
  MC_AS_Obj_MoveRB->Checked = MC_AS_Obj_MoveRB_ini;
  MC_AS_Obj_ReplaceCB->Checked = MC_AS_Obj_ReplaceCB_ini;
  MC_AS_Params_Name1CB->Checked = MC_AS_Params_Name1CB_ini;
  MC_AS_Params_Name2CB->Checked = MC_AS_Params_Name2CB_ini;
  MC_AS_Params_ScriptVariableNameCB->Checked = MC_AS_Params_ScriptVariableNameCB_ini;
  MC_AS_Params_Model3dCB->Checked = MC_AS_Params_Model3dCB_ini;
  MC_AS_Params_FirstTextureCB->Checked = MC_AS_Params_FirstTextureCB_ini;
  MC_AS_Params_SecondTextureCB->Checked = MC_AS_Params_SecondTextureCB_ini;
  MC_AS_Params_OffsetCB->Checked = MC_AS_Params_OffsetCB_ini;
  MC_AS_Params_PlayerNumberCB->Checked = MC_AS_Params_PlayerNumberCB_ini;
  MC_AS_Obj_OnlyParamsRB->Checked = MC_AS_Obj_OnlyParamsRB_ini;
};

//---------------------------------------------------------------------------
void TMainF::Save_MC_Interf()
//      ini
{
  MC_KR_Param_Name1CB_ini = MC_KR_Param_Name1CB->Checked;
  MC_KR_Param_Name2CB_ini = MC_KR_Param_Name2CB->Checked;
  MC_KR_Param_ScriptVariableNameCB_ini = MC_KR_Param_ScriptVariableNameCB->Checked;
  MC_KR_Param_Model3dCB_ini = MC_KR_Param_Model3dCB->Checked;
  MC_KR_Param_FirstTextureCB_ini = MC_KR_Param_FirstTextureCB->Checked;
  MC_KR_Param_SecondTextureCB_ini = MC_KR_Param_SecondTextureCB->Checked;
  MC_KR_Param_PlayerNumberCB_ini = MC_KR_Param_PlayerNumberCB->Checked;
  MC_KR_Coords_PramouglCB_ini = MC_KR_Coords_PramouglCB->Checked;
  MC_KR_Coords_KrugCB_ini = MC_KR_Coords_KrugCB->Checked;
  MC_KR_Type_UnitCB_ini = MC_KR_Type_UnitCB->Checked;
  MC_KR_Type_ObjectCB_ini = MC_KR_Type_ObjectCB->Checked;
  MC_KR_Type_LeverCB_ini = MC_KR_Type_LeverCB->Checked;
  MC_KR_Type_TrapCB_ini = MC_KR_Type_TrapCB->Checked;
  MC_KR_Type_FlameCB_ini = MC_KR_Type_FlameCB->Checked;
  MC_KR_Type_Particle1CB_ini = MC_KR_Type_Particle1CB->Checked;
  MC_KR_Type_Particle2CB_ini = MC_KR_Type_Particle2CB->Checked;
  MC_KR_Type_Particle3CB_ini = MC_KR_Type_Particle3CB->Checked;
  MC_AS_Obj_DelRB_ini = MC_AS_Obj_DelRB->Checked;
  MC_AS_Obj_CopyRB_ini = MC_AS_Obj_CopyRB->Checked;
  MC_AS_Obj_MoveRB_ini = MC_AS_Obj_MoveRB->Checked;
  MC_AS_Obj_ReplaceCB_ini = MC_AS_Obj_ReplaceCB->Checked;
  MC_AS_Params_Name1CB_ini = MC_AS_Params_Name1CB->Checked;
  MC_AS_Params_Name2CB_ini = MC_AS_Params_Name2CB->Checked;
  MC_AS_Params_ScriptVariableNameCB_ini = MC_AS_Params_ScriptVariableNameCB->Checked;
  MC_AS_Params_Model3dCB_ini = MC_AS_Params_Model3dCB->Checked;
  MC_AS_Params_FirstTextureCB_ini = MC_AS_Params_FirstTextureCB->Checked;
  MC_AS_Params_SecondTextureCB_ini = MC_AS_Params_SecondTextureCB->Checked;
  MC_AS_Params_OffsetCB_ini = MC_AS_Params_OffsetCB->Checked;
  MC_AS_Params_PlayerNumberCB_ini = MC_AS_Params_PlayerNumberCB->Checked;
  MC_AS_Obj_OnlyParamsRB_ini = MC_AS_Obj_OnlyParamsRB->Checked;
  MC_KR_Param_Name1Ed_ini = MC_KR_Param_Name1Ed->Text;
  MC_KR_Param_Name2Ed_ini = MC_KR_Param_Name2Ed->Text;
  MC_KR_Param_ScriptVariableNameEd_ini = MC_KR_Param_ScriptVariableNameEd->Text;
  MC_KR_Param_Model3dEd_ini = MC_KR_Param_Model3dEd->Text;
  MC_KR_Param_FirstTextureEd_ini = MC_KR_Param_FirstTextureEd->Text;
  MC_KR_Param_SecondTextureEd_ini = MC_KR_Param_SecondTextureEd->Text;
  MC_KR_Param_PlayerNumberEd_ini = MC_KR_Param_PlayerNumberEd->Text;
  MC_KR_Coords_Pramougl_X1Ed_ini = MC_KR_Coords_Pramougl_X1Ed->Text;
  MC_KR_Coords_Pramougl_Y1Ed_ini = MC_KR_Coords_Pramougl_Y1Ed->Text;
  MC_KR_Coords_Pramougl_X2Ed_ini = MC_KR_Coords_Pramougl_X2Ed->Text;
  MC_KR_Coords_Pramougl_Y2Ed_ini = MC_KR_Coords_Pramougl_Y2Ed->Text;
  MC_KR_Coords_Krug_XEd_ini = MC_KR_Coords_Krug_XEd->Text;
  MC_KR_Coords_Krug_YEd_ini = MC_KR_Coords_Krug_YEd->Text;
  MC_KR_Coords_Krug_RadEd_ini = MC_KR_Coords_Krug_RadEd->Text;
  MC_AS_Obj_TargetMobEd_ini = MC_AS_Obj_TargetMobEd->Text;
  MC_AS_Params_Name1Ed_ini = MC_AS_Params_Name1Ed->Text;
  MC_AS_Params_Name2Ed_ini = MC_AS_Params_Name2Ed->Text;
  MC_AS_Params_ScriptVariableNameEd_ini = MC_AS_Params_ScriptVariableNameEd->Text;
  MC_AS_Params_Model3dEd_ini = MC_AS_Params_Model3dEd->Text;
  MC_AS_Params_FirstTextureEd_ini = MC_AS_Params_FirstTextureEd->Text;
  MC_AS_Params_SecondTextureEd_ini = MC_AS_Params_SecondTextureEd->Text;
  MC_AS_Params_OffsetXEd_ini = MC_AS_Params_OffsetXEd->Text;
  MC_AS_Params_OffsetYEd_ini = MC_AS_Params_OffsetYEd->Text;
  MC_AS_Params_PlayerNumberEd_ini = MC_AS_Params_PlayerNumberEd->Text;
  SaveProgSetts();  //  :).
};

//---------------------------------------------------------------------------
void TMainF::Reset_MC_Interf()
//     .
{
  MC_KR_Param_Name1CB->Checked = Stand_MC_KR_Param_Name1CB_ini;
  MC_KR_Param_Name2CB->Checked = Stand_MC_KR_Param_Name2CB_ini;
  MC_KR_Param_ScriptVariableNameCB->Checked = Stand_MC_KR_Param_ScriptVariableNameCB_ini;
  MC_KR_Param_Model3dCB->Checked = Stand_MC_KR_Param_Model3dCB_ini;
  MC_KR_Param_FirstTextureCB->Checked = Stand_MC_KR_Param_FirstTextureCB_ini;
  MC_KR_Param_SecondTextureCB->Checked = Stand_MC_KR_Param_SecondTextureCB_ini;
  MC_KR_Param_PlayerNumberCB->Checked = Stand_MC_KR_Param_PlayerNumberCB_ini;
  MC_KR_Coords_PramouglCB->Checked = Stand_MC_KR_Coords_PramouglCB_ini;
  MC_KR_Coords_KrugCB->Checked = Stand_MC_KR_Coords_KrugCB_ini;
  MC_KR_Type_UnitCB->Checked = Stand_MC_KR_Type_UnitCB_ini;
  MC_KR_Type_ObjectCB->Checked = Stand_MC_KR_Type_ObjectCB_ini;
  MC_KR_Type_LeverCB->Checked = Stand_MC_KR_Type_LeverCB_ini;
  MC_KR_Type_TrapCB->Checked = Stand_MC_KR_Type_TrapCB_ini;
  MC_KR_Type_FlameCB->Checked = Stand_MC_KR_Type_FlameCB_ini;
  MC_KR_Type_Particle1CB->Checked = Stand_MC_KR_Type_Particle1CB_ini;
  MC_KR_Type_Particle2CB->Checked = Stand_MC_KR_Type_Particle2CB_ini;
  MC_KR_Type_Particle3CB->Checked = Stand_MC_KR_Type_Particle3CB_ini;
  MC_AS_Obj_DelRB->Checked = Stand_MC_AS_Obj_DelRB_ini;
  MC_AS_Obj_CopyRB->Checked = Stand_MC_AS_Obj_CopyRB_ini;
  MC_AS_Obj_MoveRB->Checked = Stand_MC_AS_Obj_MoveRB_ini;
  MC_AS_Obj_ReplaceCB->Checked = Stand_MC_AS_Obj_ReplaceCB_ini;
  MC_AS_Params_Name1CB->Checked = Stand_MC_AS_Params_Name1CB_ini;
  MC_AS_Params_Name2CB->Checked = Stand_MC_AS_Params_Name2CB_ini;
  MC_AS_Params_ScriptVariableNameCB->Checked = Stand_MC_AS_Params_ScriptVariableNameCB_ini;
  MC_AS_Params_Model3dCB->Checked = Stand_MC_AS_Params_Model3dCB_ini;
  MC_AS_Params_FirstTextureCB->Checked = Stand_MC_AS_Params_FirstTextureCB_ini;
  MC_AS_Params_SecondTextureCB->Checked = Stand_MC_AS_Params_SecondTextureCB_ini;
  MC_AS_Params_OffsetCB->Checked = Stand_MC_AS_Params_OffsetCB_ini;
  MC_AS_Params_PlayerNumberCB->Checked = Stand_MC_AS_Params_PlayerNumberCB_ini;
  MC_AS_Obj_OnlyParamsRB->Checked = Stand_MC_AS_Obj_OnlyParamsRB_ini;
  MC_KR_Param_Name1Ed->Text = Stand_MC_KR_Param_Name1Ed_ini;
  MC_KR_Param_Name2Ed->Text = Stand_MC_KR_Param_Name2Ed_ini;
  MC_KR_Param_ScriptVariableNameEd->Text = Stand_MC_KR_Param_ScriptVariableNameEd_ini;
  MC_KR_Param_Model3dEd->Text = Stand_MC_KR_Param_Model3dEd_ini;
  MC_KR_Param_FirstTextureEd->Text = Stand_MC_KR_Param_FirstTextureEd_ini;
  MC_KR_Param_SecondTextureEd->Text = Stand_MC_KR_Param_SecondTextureEd_ini;
  MC_KR_Param_PlayerNumberEd->Text = Stand_MC_KR_Param_PlayerNumberEd_ini;
  MC_KR_Coords_Pramougl_X1Ed->Text = Stand_MC_KR_Coords_Pramougl_X1Ed_ini;
  MC_KR_Coords_Pramougl_Y1Ed->Text = Stand_MC_KR_Coords_Pramougl_Y1Ed_ini;
  MC_KR_Coords_Pramougl_X2Ed->Text = Stand_MC_KR_Coords_Pramougl_X2Ed_ini;
  MC_KR_Coords_Pramougl_Y2Ed->Text = Stand_MC_KR_Coords_Pramougl_Y2Ed_ini;
  MC_KR_Coords_Krug_XEd->Text = Stand_MC_KR_Coords_Krug_XEd_ini;
  MC_KR_Coords_Krug_YEd->Text = Stand_MC_KR_Coords_Krug_YEd_ini;
  MC_KR_Coords_Krug_RadEd->Text = Stand_MC_KR_Coords_Krug_RadEd_ini;
  MC_AS_Obj_TargetMobEd->Text = Stand_MC_AS_Obj_TargetMobEd_ini;
  MC_AS_Params_Name1Ed->Text = Stand_MC_AS_Params_Name1Ed_ini;
  MC_AS_Params_Name2Ed->Text = Stand_MC_AS_Params_Name2Ed_ini;
  MC_AS_Params_ScriptVariableNameEd->Text = Stand_MC_AS_Params_ScriptVariableNameEd_ini;
  MC_AS_Params_Model3dEd->Text = Stand_MC_AS_Params_Model3dEd_ini;
  MC_AS_Params_FirstTextureEd->Text = Stand_MC_AS_Params_FirstTextureEd_ini;
  MC_AS_Params_SecondTextureEd->Text = Stand_MC_AS_Params_SecondTextureEd_ini;
  MC_AS_Params_OffsetXEd->Text = Stand_MC_AS_Params_OffsetXEd_ini;
  MC_AS_Params_OffsetYEd->Text = Stand_MC_AS_Params_OffsetYEd_ini;
  MC_AS_Params_PlayerNumberEd->Text = Stand_MC_AS_Params_PlayerNumberEd_ini;
  Save_MC_Interf();  //  :).
};

//---------------------------------------------------------------------------

void TMainF::SetMobModified()
//     (  save\load)   .
{
  if (MobModified == false)
  {
    MobModified = true;
    this->UpdateMainInterf();
  }; 
};

//---------------------------------------------------------------------------

void TMainF::SetMobNotModified()
//      (  save\load)   .
{
  if (MobModified == true)
  {
    MobModified = false;
    this->UpdateMainInterf();
  }; 
};
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_ResetButClick(TObject *Sender)
{
  Reset_MC_Interf();
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Obj_TargetMobSelButClick(TObject *Sender)
{
  //   -     :).
  //     ...
  OpenDialog1->InitialDir = WorkPath;
  if (OpenDialog1->Execute())
  {
    //  
    MC_AS_Obj_TargetMobEd->Text = OpenDialog1->FileName;
    //   :).
    WorkPath = ExtractFilePath(OpenDialog1->FileName);
  };
}
//---------------------------------------------------------------------------


void __fastcall TMainF::MC_GoButClick(TObject *Sender)
{
  //    .
  MakeMassChanges();
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Obj_OnlyParamsRBClick(TObject *Sender)
{
  MC_AS_UpdDel();  
}
//---------------------------------------------------------------------------


void __fastcall TMainF::ObjectsShResize(TObject *Sender)
{
  //       ...

  //       ...
  this->ObjectsTree->Height = this->ObjectsSh->Height - 5;
  this->ValuesEditor->Height = this->ObjectsSh->Height - 5;
}
//---------------------------------------------------------------------------


void __fastcall TMainF::ObjectsShShow(TObject *Sender)
{
  if (MainF_PK->ActivePage == ObjectsSh)
  {
    //    ...

    //   -      -   
    //    ...
    this->ObjectsShResize(Sender);
    //this->ObjectOrientator->Draw();
  };
}
//---------------------------------------------------------------------------


void __fastcall TMainF::ObjectsTreeChange(TObject *Sender, TTreeNode *Node)
{
  //               %)
  //,   ,    ,    ...
   if (MainF_PK->ActivePage == ObjectsSh)
  {
    //    ...

    // ,   ...
    if (MobLoaded == true)
    {
      //  ...

      //
      ObjEditorChanging = true;

      //    ....
      this->ValuesEditor->Strings->Clear();

      // ,        ....
      if (this->ObjectsTree->Selected->Parent != NULL)
      {
        //,        ...

        //  -   ""  %)
        TreeMobObject2Editor(this->ObjectsTree->Selected);
      };

      //
      ObjEditorChanging = false;
      
    };
  };
}
//---------------------------------------------------------------------------

void TMainF::MobObjectsChanged()
//         ...
{
  //
  bool NodeFound = false;
  int i;
  TTreeNode *CurrNode, *AddedNode;

  // ...
  this->ObjectsTree->Items->Clear();
  //...  .
  this->ValuesEditor->Strings->Clear();

  //    ...
  if (MobLoaded == true)
  {
    //.

    //       ...

    //...
    CurrNode = this->ObjectsTree->Items->Add(NULL,"");
    CurrNode->Data = &ObjTree_UnitsNode;  //    
    if (CurrNode != NULL)
    {
      // ,  ...
      for (i = 0; i < MobInMem1->UnitObjs.Length; i++)
      {
        //     ...
        AddedNode = MainF->ObjectsTree->Items->AddChild(CurrNode,MobInMem1->UnitObjs[i].Name1);
        if (AddedNode != NULL)
        {
          //          ...
          AddedNode->Data = &MobInMem1->UnitObjs[i];
        };
      };
      CurrNode->AlphaSort(true);  //...
    };

    //...
    CurrNode = this->ObjectsTree->Items->Add(NULL,"");
    CurrNode->Data = &ObjTree_ObjectsNode;  //    
    if (CurrNode != NULL)
    {
      // ,  ...
      for (i = 0; i < MobInMem1->ObjectObjs.Length ; i++)
      {
        //     ...
        AddedNode = MainF->ObjectsTree->Items->AddChild(CurrNode,MobInMem1->ObjectObjs[i].Name2);
        if (AddedNode != NULL)
        {
          //          ...
          AddedNode->Data = &MobInMem1->ObjectObjs[i];
        };
      };
      CurrNode->AlphaSort(true);  //...
    };

    //...
    CurrNode = this->ObjectsTree->Items->Add(NULL,"");
    CurrNode->Data = &ObjTree_LeversNode;  //    
    if (CurrNode != NULL)
    {
      // ,  ...
      for (i = 0; i < MobInMem1->LeverObjs.Length ; i++)
      {
        //     ...
        AddedNode = MainF->ObjectsTree->Items->AddChild(CurrNode,MobInMem1->LeverObjs[i].Name2);
        if (AddedNode != NULL)
        {
          //          ...
          AddedNode->Data = &MobInMem1->LeverObjs[i];
        };
      };
      CurrNode->AlphaSort(true);  //...
    };

    //...
    CurrNode = this->ObjectsTree->Items->Add(NULL,"");
    CurrNode->Data = &ObjTree_TrapsNode;  //    
    if (CurrNode != NULL)
    {
      // ,  ...
      for (i = 0; i < MobInMem1->TrapObjs.Length ; i++)
      {
        //     ...
        AddedNode = MainF->ObjectsTree->Items->AddChild(CurrNode,MobInMem1->TrapObjs[i].Name2);
        if (AddedNode != NULL)
        {
          //          ...
          AddedNode->Data = &MobInMem1->TrapObjs[i];
        };
      };
      CurrNode->AlphaSort(true);  //...
    };

    //...
    CurrNode = this->ObjectsTree->Items->Add(NULL,"");
    CurrNode->Data = &ObjTree_FlamesNode;  //    
    if (CurrNode != NULL)
    {
      // ,  ...
      for (i = 0; i < MobInMem1->FlameObjs.Length ; i++)
      {
        //     ...
        AddedNode = MainF->ObjectsTree->Items->AddChild(CurrNode,MobInMem1->FlameObjs[i].Name2);
        if (AddedNode != NULL)
        {
          //          ...
          AddedNode->Data = &MobInMem1->FlameObjs[i];
        };
      };
      CurrNode->AlphaSort(true);  //...
    };

    // 1 ...
    CurrNode = this->ObjectsTree->Items->Add(NULL," 1 ");
    CurrNode->Data = &ObjTree_Particles1Node;  //    
    if (CurrNode != NULL)
    {
      // ,  ...
      for (i = 0; i < MobInMem1->Particle1Objs.Length ; i++)
      {
        //     ...
        AddedNode = MainF->ObjectsTree->Items->AddChild(CurrNode,MobInMem1->Particle1Objs[i].NameStr);
        if (AddedNode != NULL)
        {
          //          ...
          AddedNode->Data = &MobInMem1->Particle1Objs[i];
        };
      };
      CurrNode->AlphaSort(true);  //...
    };

    // 2 ...
    CurrNode = this->ObjectsTree->Items->Add(NULL," 2 ");
    CurrNode->Data = &ObjTree_Particles2Node;  //    
    if (CurrNode != NULL)
    {
      // ,  ...
      for (i = 0; i < MobInMem1->Particle2Objs.Length ; i++)
      {
        //     ...
        AddedNode = MainF->ObjectsTree->Items->AddChild(CurrNode,MobInMem1->Particle2Objs[i].NameStr);
        if (AddedNode != NULL)
        {
          //          ...
          AddedNode->Data = &MobInMem1->Particle2Objs[i];
        };
      };
      CurrNode->AlphaSort(true);  //...
    };

    // 3 ...
    CurrNode = this->ObjectsTree->Items->Add(NULL," 3 ");
    CurrNode->Data = &ObjTree_Particles3Node;  //    
    if (CurrNode != NULL)
    {
      // ,  ...
      for (i = 0; i < MobInMem1->Particle3Objs.Length ; i++)
      {
        //     ...
        AddedNode = MainF->ObjectsTree->Items->AddChild(CurrNode,MobInMem1->Particle3Objs[i].NameStr);
        if (AddedNode != NULL)
        {
          //          ...
          AddedNode->Data = &MobInMem1->Particle3Objs[i];
        };
      };
      CurrNode->AlphaSort(true);  //...
    };

  };

};
//---------------------------------------------------------------------------

void TMainF::TreeMobObject2Editor(TTreeNode *Node)
//    ,        ...
{
  TUnitObjBlock *test;

  //,   -   ...
  if (Node->Parent->Data == &ObjTree_UnitsNode)
  {
    //  %).
    UnitObject2Editor(PUnitObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_ObjectsNode)
  {
    //  %).
    ObjectObject2Editor(PObjectObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_LeversNode)
  {
    //  %).
    LeverObject2Editor(PLeverObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_TrapsNode)
  {
    //   %).
    TrapObject2Editor(PTrapObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_FlamesNode)
  {
    //  %).
    FlameObject2Editor(PFlameObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_Particles1Node)
  {
    //  1  %).
    Particle1Object2Editor(PParticle1ObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_Particles2Node)
  {
    //  2  %).
    Particle2Object2Editor(PParticle2ObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_Particles3Node)
  {
    //  3  %).
    Particle3Object2Editor(PParticle3ObjBlock(Node->Data));
  };
};
//---------------------------------------------------------------------------

void TMainF::UnitObject2Editor(TUnitObjBlock *MobObject)
//   ,   ...
{
  //,  ...
  
  //UseMobInfo
  this->ValuesEditor->Strings->Add("UseMobInfo="+IntToStr(MobObject->UseMobInfo));
  //Name1
  this->ValuesEditor->Strings->Add("Name1="+MobObject->Name1);
  //Armour
  this->ValuesEditor->Strings->Add("Armour="+StrArray2StrCommaList(MobObject->Armour));
  //Weapon
  this->ValuesEditor->Strings->Add("Weapon="+StrArray2StrCommaList(MobObject->Weapon));
  //Spell
  this->ValuesEditor->Strings->Add("Spell="+StrArray2StrCommaList(MobObject->Spell));
  //UncnDw1
  this->ValuesEditor->Strings->Add("UncnDw1="+IntToStr(MobObject->UncnDw1));
  //Items
  this->ValuesEditor->Strings->Add("Items="+StrArray2StrCommaList(MobObject->Items));

  //   ""  %).
  ObjectObject2Editor(MobObject);
};
//---------------------------------------------------------------------------

void TMainF::ObjectObject2Editor(TObjectObjBlock *MobObject)
//   ,   ...
{
  //,  ...
  
  //BodyTextures
  this->ValuesEditor->Strings->Add("BodyTextures="+StrArray2StrCommaList(MobObject->BodyTextures));
  //PlayerNumber
  this->ValuesEditor->Strings->Add("PlayerNumber="+IntToStr(MobObject->PlayerNumber));
  //ObjectID
  this->ValuesEditor->Strings->Add("ObjectID="+IntToStr(MobObject->ObjectID));
  //ObjectType
  this->ValuesEditor->Strings->Add("ObjectType="+IntToStr(MobObject->ObjectType));
  //ScriptVariableName
  this->ValuesEditor->Strings->Add("ScriptVariableName="+MobObject->ScriptVariableName);
  //ModelName
  this->ValuesEditor->Strings->Add("ModelName="+MobObject->ModelName);
  //Name2
  this->ValuesEditor->Strings->Add("Name2="+MobObject->Name2);
  //FirstTexture
  this->ValuesEditor->Strings->Add("FirstTexture="+MobObject->FirstTexture);
  //SecondTexture
  this->ValuesEditor->Strings->Add("SecondTexture="+MobObject->SecondTexture);
  //UnknownStr1
  this->ValuesEditor->Strings->Add("UnknownStr1="+MobObject->UnknownStr1);
  //LoadX
  this->ValuesEditor->Strings->Add("LoadX="+FloatToStr(MobObject->LoadX));
  //LoadY
  this->ValuesEditor->Strings->Add("LoadY="+FloatToStr(MobObject->LoadY));
  //LoadZ
  this->ValuesEditor->Strings->Add("LoadZ="+FloatToStr(MobObject->LoadZ));
  //RotationW
  this->ValuesEditor->Strings->Add("RotationW="+FloatToStr(MobObject->RotationW));
  //RotationX
  this->ValuesEditor->Strings->Add("RotationX="+FloatToStr(MobObject->RotationX));
  //RotationY
  this->ValuesEditor->Strings->Add("RotationY="+FloatToStr(MobObject->RotationY));
  //RotationZ
  this->ValuesEditor->Strings->Add("RotationZ="+FloatToStr(MobObject->RotationZ));
  //IsQuestUnit
  this->ValuesEditor->Strings->Add("IsQuestUnit="+IntToStr(MobObject->IsQuestUnit));
  //UncnByte1
  this->ValuesEditor->Strings->Add("ShowShadow="+IntToStr(MobObject->ShowShadow));
  //UncnDw2
  this->ValuesEditor->Strings->Add("UncnDw2="+IntToStr(MobObject->UncnDw2));
  //QuestLightStr
  this->ValuesEditor->Strings->Add("QuestLightStr="+MobObject->QuestLightStr);
  //ComplectionStrength
  this->ValuesEditor->Strings->Add("ComplectionStrength="+FloatToStr(MobObject->ComplectionStrength));
  //ComplectionDex
  this->ValuesEditor->Strings->Add("ComplectionDex="+FloatToStr(MobObject->ComplectionDex));
  //ComplectionTall
  this->ValuesEditor->Strings->Add("ComplectionTall="+FloatToStr(MobObject->ComplectionTall));

  //  -      ...
  FillOrientator(MobObject);
  //          %).
  this->OldQuat->QuatW = MobObject->RotationW;
  this->OldQuat->QuatX = MobObject->RotationX;
  this->OldQuat->QuatY = MobObject->RotationY;
  this->OldQuat->QuatZ = MobObject->RotationZ;
};
//---------------------------------------------------------------------------

void TMainF::LeverObject2Editor(TLeverObjBlock *MobObject)
//   ,   ...
{
  //,  ...

  //AsOpen
  this->ValuesEditor->Strings->Add("AsOpen="+IntToStr(MobObject->AsOpen));
  //Key
  this->ValuesEditor->Strings->Add("Key="+IntToStr(MobObject->Key));
  //Sleigth
  this->ValuesEditor->Strings->Add("Sleigth="+IntToStr(MobObject->Sleigth));
  //UncnByte2
  this->ValuesEditor->Strings->Add("UncnByte2="+IntToStr(MobObject->UncnByte2));
  //UncnByte3
  this->ValuesEditor->Strings->Add("UncnByte3="+IntToStr(MobObject->UncnByte3));
  //UncnByte4
  this->ValuesEditor->Strings->Add("UncnByte4="+IntToStr(MobObject->UncnByte4));
  //UncnByte5
  this->ValuesEditor->Strings->Add("UncnByte5="+IntToStr(MobObject->UncnByte5));
  //UncnByte6
  this->ValuesEditor->Strings->Add("UncnByte6="+IntToStr(MobObject->UncnByte6));

  //   ""  %).
  ObjectObject2Editor(MobObject);
};
//---------------------------------------------------------------------------

void TMainF::TrapObject2Editor(TTrapObjBlock *MobObject)
//   ,   ...
{
  //,  ...

  //UnknDw1
  this->ValuesEditor->Strings->Add("UnknDw1="+IntToStr(MobObject->UnknDw1));
  //MagicStr
  this->ValuesEditor->Strings->Add("MagicStr="+MobObject->MagicStr);
  //UnknDw2
  this->ValuesEditor->Strings->Add("UnknDw2="+IntToStr(MobObject->UnknDw2));
  //UnknByte1
  this->ValuesEditor->Strings->Add("UnknByte1="+IntToStr(MobObject->UnknByte1));
  //TrapPoints1
  this->ValuesEditor->Strings->Add("TrapPoints1=Click to edit ----->");
  this->ValuesEditor->ItemProps["TrapPoints1"]->EditStyle = esEllipsis;
  //TrapPoints2
  this->ValuesEditor->Strings->Add("TrapPoints2=Click to edit ----->");
  this->ValuesEditor->ItemProps["TrapPoints2"]->EditStyle = esEllipsis;

  //   ""  %).
  ObjectObject2Editor(MobObject);
};
//---------------------------------------------------------------------------

void TMainF::FlameObject2Editor(TFlameObjBlock *MobObject)
//   ,   ...
{
  //,  ...

  //CoordX
  this->ValuesEditor->Strings->Add("CoordX="+FloatToStr(MobObject->CoordX));
  //CoordY
  this->ValuesEditor->Strings->Add("CoordY="+FloatToStr(MobObject->CoordY));
  //CoordZ
  this->ValuesEditor->Strings->Add("CoordZ="+FloatToStr(MobObject->CoordZ));
  //FlameSize
  this->ValuesEditor->Strings->Add("FlameSize="+FloatToStr(MobObject->FlameSize));
  //SoundStr
  this->ValuesEditor->Strings->Add("SoundStr="+MobObject->SoundStr);

  //   ""  %).
  ObjectObject2Editor(MobObject);
};
//---------------------------------------------------------------------------

void TMainF::Particle1Object2Editor(TParticle1ObjBlock *MobObject)
//    1 ,   ...
{
  //,  ...

  //ID
  this->ValuesEditor->Strings->Add("ID="+IntToStr(MobObject->ID));
  //UnknByte1
  this->ValuesEditor->Strings->Add("UnknByte1="+IntToStr(MobObject->UnknByte1));
  //CoordX
  this->ValuesEditor->Strings->Add("CoordX="+FloatToStr(MobObject->CoordX));
  //CoordY
  this->ValuesEditor->Strings->Add("CoordY="+FloatToStr(MobObject->CoordY));
  //CoordZ
  this->ValuesEditor->Strings->Add("CoordZ="+FloatToStr(MobObject->CoordZ));
  //ColorR
  this->ValuesEditor->Strings->Add("ColorR="+FloatToStr(MobObject->ColorR));
  //ColorG
  this->ValuesEditor->Strings->Add("ColorG="+FloatToStr(MobObject->ColorG));
  //ColorB
  this->ValuesEditor->Strings->Add("ColorB="+FloatToStr(MobObject->ColorB));
  //ParticleSize
  this->ValuesEditor->Strings->Add("ParticleSize="+FloatToStr(MobObject->ParticleSize));
  //NameStr
  this->ValuesEditor->Strings->Add("NameStr="+MobObject->NameStr);
  //UnknStr1
  this->ValuesEditor->Strings->Add("UnknStr1="+MobObject->UnknStr1);
  
};
//---------------------------------------------------------------------------

void TMainF::Particle2Object2Editor(TParticle2ObjBlock *MobObject)
//    2 ,   ...
{
  //,  ...
  
  //SoundStr_s
  this->ValuesEditor->Strings->Add("SoundStr_s="+StrArray2StrCommaList(MobObject->SoundStr_s));
  //ID
  this->ValuesEditor->Strings->Add("ID="+IntToStr(MobObject->ID));
  //CoordX
  this->ValuesEditor->Strings->Add("CoordX="+FloatToStr(MobObject->CoordX));
  //CoordY
  this->ValuesEditor->Strings->Add("CoordY="+FloatToStr(MobObject->CoordY));
  //CoordZ
  this->ValuesEditor->Strings->Add("CoordZ="+FloatToStr(MobObject->CoordZ));
  //UnknDW1
  this->ValuesEditor->Strings->Add("UnknDW1="+IntToStr(MobObject->UnknDW1));
  //UnknDW2
  this->ValuesEditor->Strings->Add("UnknDW2="+IntToStr(MobObject->UnknDW2));
  //NameStr
  this->ValuesEditor->Strings->Add("NameStr="+MobObject->NameStr);
  //UnknStr1
  this->ValuesEditor->Strings->Add("UnknStr1="+MobObject->UnknStr1);
  //UnknDW3
  this->ValuesEditor->Strings->Add("UnknDW3="+IntToStr(MobObject->UnknDW3));
  //UnknDW4
  this->ValuesEditor->Strings->Add("UnknDW4="+IntToStr(MobObject->UnknDW4));
  //UnknByte1
  this->ValuesEditor->Strings->Add("UnknByte1="+IntToStr(MobObject->UnknByte1));
  //UnknByte2
  this->ValuesEditor->Strings->Add("UnknByte2="+IntToStr(MobObject->UnknByte2));

};
//---------------------------------------------------------------------------

void TMainF::Particle3Object2Editor(TParticle3ObjBlock *MobObject)
//    3 ,   ...
{
  //,  ...

  //ID
  this->ValuesEditor->Strings->Add("ID="+IntToStr(MobObject->ID));
  //CoordX
  this->ValuesEditor->Strings->Add("CoordX="+FloatToStr(MobObject->CoordX));
  //CoordY
  this->ValuesEditor->Strings->Add("CoordY="+FloatToStr(MobObject->CoordY));
  //CoordZ
  this->ValuesEditor->Strings->Add("CoordZ="+FloatToStr(MobObject->CoordZ));
  //NameStr
  this->ValuesEditor->Strings->Add("NameStr="+MobObject->NameStr);
  //UnknStr1
  this->ValuesEditor->Strings->Add("UnknStr1="+MobObject->UnknStr1);
  //UnknDw1
  this->ValuesEditor->Strings->Add("UnknDw1="+IntToStr(MobObject->UnknDw1));
  //UnknFloat1
  this->ValuesEditor->Strings->Add("UnknFloat1="+FloatToStr(MobObject->UnknFloat1));

};
//---------------------------------------------------------------------------

void __fastcall TMainF::ValuesEditorValidate(TObject *Sender, int ACol,
      int ARow, const AnsiString KeyName, const AnsiString KeyValue)
{
  //.  -     -      
  // .    -     ....
  // -        -    
  //...
  //ShowMessage(KeyName+"="+KeyValue+" old "+this->ValuesEditor->Values[KeyName]);

  //...
  TTreeNode *Node;

  //  selected...
  Node = this->ObjectsTree->Selected;

  //,   ...
  if (Node->Parent->Data == &ObjTree_UnitsNode)
  {
    //  %).
    Editor2MobUnitObj(KeyName,PUnitObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_ObjectsNode)
  {
    //  %).
    Editor2MobObjectObj(KeyName,PObjectObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_LeversNode)
  {
    //  %).
    Editor2MobLeverObj(KeyName,PLeverObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_TrapsNode)
  {
    //   %).
    Editor2MobTrapObj(KeyName,PTrapObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_FlamesNode)
  {
    //  %).
    Editor2MobFlameObj(KeyName,PFlameObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_Particles1Node)
  {
    //  1  %).
    Editor2MobParticle1Obj(KeyName,PParticle1ObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_Particles2Node)
  {
    //  2  %).
    Editor2MobParticle2Obj(KeyName,PParticle2ObjBlock(Node->Data));
  }
  else if (Node->Parent->Data == &ObjTree_Particles3Node)
  {
    //  3  %).
    Editor2MobParticle3Obj(KeyName,PParticle3ObjBlock(Node->Data));
  };
}
//---------------------------------------------------------------------------

void TMainF::Editor2MobObjectObj(const AnsiString KeyName, TObjectObjBlock *MobObject)
//    ""    ...
{
  //     ,   ...

  if (KeyName == "BodyTextures")
  {
    //DynamicArray <String> *
    // ...
    this->ValuesEditor->Values[KeyName] = Norm_StrCommaList(this->ValuesEditor->Values[KeyName]);
    // -  ...
    if ( Check_StrCommaList(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      StrCommaList2StrArray(this->ValuesEditor->Values[KeyName],MobObject->BodyTextures);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = StrArray2StrCommaList(MobObject->BodyTextures);
    };
  }
  else if (KeyName == "PlayerNumber")
  {
    //byte
    // -  ...
    if ( CheckStrByte(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->PlayerNumber = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->PlayerNumber);
    };
  }
  else if (KeyName == "ObjectID")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ObjectID = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->ObjectID);
    };
  }
  else if (KeyName == "ObjectType")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ObjectType = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->ObjectType);
    };
  }
  else if (KeyName == "ScriptVariableName")
  {
    //String
    // ...     %)
    MobObject->ScriptVariableName = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "ModelName")
  {
    //String
    // ...     %)
    MobObject->ModelName = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "Name2")
  {
    //String
    // ...     %)
    MobObject->Name2 = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "FirstTexture")
  {
    //FirstTexture
    // ...     %)
    MobObject->FirstTexture = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "SecondTexture")
  {
    //String
    // ...     %)
    MobObject->SecondTexture = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "UnknownStr1")
  {
    //String
    // ...     %)
    MobObject->UnknownStr1 = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "LoadX")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->LoadX = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->LoadX);
    };
  }
  else if (KeyName == "LoadY")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->LoadY = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->LoadY);
    };
  }
  else if (KeyName == "LoadZ")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->LoadZ = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->LoadZ);
    };
  }
  else if (KeyName == "RotationW")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->RotationW = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
      // .      ...
      FillOrientator(MobObject);
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->RotationW);
    };
  }
  else if (KeyName == "RotationX")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->RotationX = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
      // .      ...
      FillOrientator(MobObject);
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->RotationX);
    };
  }
  else if (KeyName == "RotationY")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->RotationY = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
      // .      ...
      FillOrientator(MobObject);
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->RotationY);
    };
  }
  else if (KeyName == "RotationZ")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->RotationZ = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
      // .      ...
      FillOrientator(MobObject);
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->RotationZ);
    };
  }
  else if (KeyName == "IsQuestUnit")
  {
    //byte
    // -  ...
    if ( CheckStrByte(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->IsQuestUnit = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->IsQuestUnit);
    };
  }
  else if (KeyName == "ShowShadow")
  {
    //byte
    // -  ...
    if ( CheckStrByte(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ShowShadow = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->ShowShadow);
    };
  }
  else if (KeyName == "UncnDw2")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UncnDw2 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UncnDw2);
    };
  }
  else if (KeyName == "QuestLightStr")
  {
    //String
    // ...     %)
    MobObject->QuestLightStr = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "ComplectionStrength")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ComplectionStrength = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->ComplectionStrength);
    };
  }
  else if (KeyName == "ComplectionDex")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ComplectionDex = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->ComplectionDex);
    };
  }
  else if (KeyName == "ComplectionTall")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ComplectionTall = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->ComplectionTall);
    };
  };

};
//---------------------------------------------------------------------------

void TMainF::Editor2MobUnitObj(const AnsiString KeyName, TUnitObjBlock *MobObject)
//    ""    ...
{

  if (KeyName == "UseMobInfo")
  {
    //byte
    // -  ...
    if ( CheckStrByte(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UseMobInfo = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UseMobInfo);
    };
  }
  else if (KeyName == "Name1")
  {
    //String
    // ...     %)
    MobObject->Name1 = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "Armour")
  {
    //DynamicArray <String> *
    // ...
    this->ValuesEditor->Values[KeyName] = Norm_StrCommaList(this->ValuesEditor->Values[KeyName]);
    // -  ...
    if ( Check_StrCommaList(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      StrCommaList2StrArray(this->ValuesEditor->Values[KeyName],MobObject->Armour);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = StrArray2StrCommaList(MobObject->Armour);
    };
  }
  else if (KeyName == "Weapon")
  {
    //DynamicArray <String> *
    // ...
    this->ValuesEditor->Values[KeyName] = Norm_StrCommaList(this->ValuesEditor->Values[KeyName]);
    // -  ...
    if ( Check_StrCommaList(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      StrCommaList2StrArray(this->ValuesEditor->Values[KeyName],MobObject->Weapon);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = StrArray2StrCommaList(MobObject->Weapon);
    };
  }
  else if (KeyName == "Spell")
  {
    //DynamicArray <String> *
    // ...
    this->ValuesEditor->Values[KeyName] = Norm_StrCommaList(this->ValuesEditor->Values[KeyName]);
    // -  ...
    if ( Check_StrCommaList(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      StrCommaList2StrArray(this->ValuesEditor->Values[KeyName],MobObject->Spell);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = StrArray2StrCommaList(MobObject->Spell);
    };
  }
  else if (KeyName == "UncnDw1")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UncnDw1 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UncnDw1);
    };
  }
  else if (KeyName == "Items")
  {
    //DynamicArray <String> *
    // ...
    this->ValuesEditor->Values[KeyName] = Norm_StrCommaList(this->ValuesEditor->Values[KeyName]);
    // -  ...
    if ( Check_StrCommaList(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      StrCommaList2StrArray(this->ValuesEditor->Values[KeyName],MobObject->Items);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = StrArray2StrCommaList(MobObject->Items);
    };
  }
  else
  {
    //         -    ....
    Editor2MobObjectObj(KeyName,MobObject);
  };

};
//---------------------------------------------------------------------------

void TMainF::Editor2MobLeverObj(const AnsiString KeyName, TLeverObjBlock *MobObject)
//    ""    ...
{

  if (KeyName == "AsOpen")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->AsOpen = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->AsOpen);
    };
  }
  else if (KeyName == "Key")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->Key = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->Key);
    };
  }
  else if (KeyName == "Sleigth")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->Sleigth = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->Sleigth);
    };
  }
  else if (KeyName == "UncnByte2")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UncnByte2 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UncnByte2);
    };
  }
  else if (KeyName == "UncnByte3")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UncnByte3 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UncnByte3);
    };
  }
  else if (KeyName == "UncnByte4")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UncnByte4 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UncnByte4);
    };
  }
  else if (KeyName == "UncnByte5")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UncnByte5 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UncnByte5);
    };
  }
  else if (KeyName == "UncnByte6")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UncnByte6 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UncnByte6);
    };
  }
  else
  {
    //         -    ....
    Editor2MobObjectObj(KeyName,MobObject);
  };

};
//---------------------------------------------------------------------------

void TMainF::Editor2MobTrapObj(const AnsiString KeyName, TTrapObjBlock *MobObject)
//    ""    ...
{

  if (KeyName == "UnknDw1")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknDw1 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknDw1);
    };
  }
  else if (KeyName == "MagicStr")
  {
    //String
    // ...     %)
    MobObject->MagicStr = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "UnknDw2")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknDw2 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknDw2);
    };
  }
  else if (KeyName == "UnknByte1")
  {
    //byte
    // -  ...
    if ( CheckStrByte(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknByte1 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknByte1);
    };
  }
  else
  {
    //         -    ....
    Editor2MobObjectObj(KeyName,MobObject);
  };

};
//---------------------------------------------------------------------------

void TMainF::Editor2MobFlameObj(const AnsiString KeyName, TFlameObjBlock *MobObject)
//    ""    ...
{
  if (KeyName == "CoordX")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordX = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordX);
    };
  }
  else if (KeyName == "CoordY")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordY = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordY);
    };
  }
  else if (KeyName == "CoordZ")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordZ = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordZ);
    };
  }
  else if (KeyName == "FlameSize")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->FlameSize = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->FlameSize);
    };
  }
  else if (KeyName == "SoundStr")
  {
    //String
    // ...     %)
    MobObject->SoundStr = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else
  {
    //         -    ....
    Editor2MobObjectObj(KeyName,MobObject);
  };
};
//---------------------------------------------------------------------------

void TMainF::Editor2MobParticle1Obj(const AnsiString KeyName, TParticle1ObjBlock *MobObject)
//    " 1 "    ...
{
  if (KeyName == "ID")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ID = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->ID);
    };
  }
  else if (KeyName == "UnknByte1")
  {
    //byte
    // -  ...
    if ( CheckStrByte(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknByte1 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknByte1);
    };
  }
  else if (KeyName == "CoordX")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordX = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordX);
    };
  }
  else if (KeyName == "CoordY")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordY = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordY);
    };
  }
  else if (KeyName == "CoordZ")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordZ = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordZ);
    };
  }
  else if (KeyName == "ColorR")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ColorR = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->ColorR);
    };
  }
  else if (KeyName == "ColorG")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ColorG = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->ColorG);
    };
  }
  else if (KeyName == "ColorB")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ColorB = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->ColorB);
    };
  }
  else if (KeyName == "ParticleSize")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ParticleSize = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->ParticleSize);
    };
  }
  else if (KeyName == "NameStr")
  {
    //String
    // ...     %)
    MobObject->NameStr = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "UnknStr1")
  {
    //String
    // ...     %)
    MobObject->UnknStr1 = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  };
};
//---------------------------------------------------------------------------

void TMainF::Editor2MobParticle2Obj(const AnsiString KeyName, TParticle2ObjBlock *MobObject)
//    " 2 "    ...
{
  if (KeyName == "SoundStr_s")
  {
    //DynamicArray <String> *
    // ...
    this->ValuesEditor->Values[KeyName] = Norm_StrCommaList(this->ValuesEditor->Values[KeyName]);
    // -  ...
    if ( Check_StrCommaList(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      StrCommaList2StrArray(this->ValuesEditor->Values[KeyName],MobObject->SoundStr_s);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = StrArray2StrCommaList(MobObject->SoundStr_s);
    };
  }
  else if (KeyName == "ID")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ID = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->ID);
    };
  }
  else if (KeyName == "CoordX")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordX = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordX);
    };
  }
  else if (KeyName == "CoordY")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordY = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordY);
    };
  }
  else if (KeyName == "CoordZ")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordZ = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordZ);
    };
  }
  else if (KeyName == "UnknDW1")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknDW1 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknDW1);
    };
  }
  else if (KeyName == "UnknDW2")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknDW2 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknDW2);
    };
  }
  else if (KeyName == "NameStr")
  {
    //String
    // ...     %)
    MobObject->NameStr = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "UnknStr1")
  {
    //String
    // ...     %)
    MobObject->UnknStr1 = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "UnknDW3")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknDW3 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknDW3);
    };
  }
  else if (KeyName == "UnknDW4")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknDW4 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknDW4);
    };
  }
  else if (KeyName == "UnknByte1")
  {
    //byte
    // -  ...
    if ( CheckStrByte(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknByte1 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknByte1);
    };
  }
  else if (KeyName == "UnknByte2")
  {
    //byte
    // -  ...
    if ( CheckStrByte(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknByte2 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknByte2);
    };
  };
};
//---------------------------------------------------------------------------

void TMainF::Editor2MobParticle3Obj(const AnsiString KeyName, TParticle3ObjBlock *MobObject)
//    " 3 "    ...
{
  if (KeyName == "ID")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->ID = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->ID);
    };
  }
  else if (KeyName == "CoordX")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordX = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordX);
    };
  }
  else if (KeyName == "CoordY")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordY = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordY);
    };
  }
  else if (KeyName == "CoordZ")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->CoordZ = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->CoordZ);
    };
  }
  else if (KeyName == "NameStr")
  {
    //String
    // ...     %)
    MobObject->NameStr = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "UnknStr1")
  {
    //String
    // ...     %)
    MobObject->UnknStr1 = this->ValuesEditor->Values[KeyName];
    this->SetMobModified();
  }
  else if (KeyName == "UnknDw1")
  {
    //DWORD
    // -  ...
    if ( CheckStrInt(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknDw1 = StrToInt(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = IntToStr(MobObject->UnknDw1);
    };
  }
  else if (KeyName == "UnknFloat1")
  {
    //float
    // -  ...
    if ( CheckStrFloat(this->ValuesEditor->Values[KeyName]) == true )
    {
      // ...
      MobObject->UnknFloat1 = StrToFloat(this->ValuesEditor->Values[KeyName]);
      this->SetMobModified();
    }
    else
    {
      //    ...
      this->ValuesEditor->Values[KeyName] = FloatToStr(MobObject->UnknFloat1);
    };
  };
};
//---------------------------------------------------------------------------
void __fastcall TMainF::ValuesEditorExit(TObject *Sender)
{
  //       ...
  if (this->ValuesEditor->RowCount > 2)
  {
    //    - ...
    this->ValuesEditorValidate(Sender,this->ValuesEditor->Col,this->ValuesEditor->Row,this->ValuesEditor->Keys[this->ValuesEditor->Row],this->ValuesEditor->Values[this->ValuesEditor->Keys[this->ValuesEditor->Row]]);
  };

  //      ...
  ObjEditorActive = false;
}
//---------------------------------------------------------------------------

void __fastcall TMainF::ValuesEditorEnter(TObject *Sender)
{
  //    ...
  ObjEditorActive = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainF::FormCreate(TObject *Sender)
{
  //   ...

  // OGL...
  ObjectOrientator->GLInitialize();

  //  ...
  OldQuat = new TQuaternion();
}
//---------------------------------------------------------------------------
void __fastcall TMainF::FormPaint(TObject *Sender)
{
  /*this->ObjectOrientator->GLInitialize();
  this->ObjectOrientator->Draw();
  this->ObjectOrientator->GLDeInitialize();*/
}
//---------------------------------------------------------------------------



void TMainF::FillOrientator(TObjectObjBlock *MobObject)
//     TMob  .
{
  //    %).
  this->ObjectOrientator->ObjectQuat->QuatW = MobObject->RotationW;
  this->ObjectOrientator->ObjectQuat->QuatX = MobObject->RotationX;
  this->ObjectOrientator->ObjectQuat->QuatY = MobObject->RotationY;
  this->ObjectOrientator->ObjectQuat->QuatZ = MobObject->RotationZ;
};
//---------------------------------------------------------------------------
void __fastcall TMainF::FormDestroy(TObject *Sender)
{
  //    ....
  delete OldQuat;        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_KR_Param_PlayerNumberEdChange(TObject *Sender)
{
  //   . 
  if (MC_KR_Param_PlayerNumberEd->Text.Length() == 0)
  {
    MC_KR_Param_PlayerNumberCB->Checked = false;
  }
  else
  {
    MC_KR_Param_PlayerNumberCB->Checked = true;
  };        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::MC_AS_Params_PlayerNumberEdChange(TObject *Sender)
{
  //   . 
  if (MC_AS_Params_PlayerNumberEd->Text.Length() == 0)
  {
    MC_AS_Params_PlayerNumberCB->Checked = false;
  }
  else
  {
    MC_AS_Params_PlayerNumberCB->Checked = true;
  };        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::ReadmeMenuClick(TObject *Sender)
{
  WinExec(AnsiString("notepad.exe "+ProgPath+"Readme.txt").c_str() , SW_SHOWNORMAL);        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::CloseMobMenuClick(TObject *Sender)
{
  // .
  CloseMobComm();        
}
//---------------------------------------------------------------------------

void __fastcall TMainF::ScriptEdChange(TObject *Sender)
{
  //     -    .
  this->SetMobModified();        
}
//---------------------------------------------------------------------------

