///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------

#ifndef MainFormH
#define MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include "SynEdit.hpp"
#include "SynEditHighlighter.hpp"
#include "SynHighlighterPas.hpp"
#include "SynHighlighterEIScript.hpp"
#include <Buttons.hpp>
#include <Grids.hpp>
#include <ValEdit.hpp>

//      ...
#include "MobUnitObj.h"
#include "MobObjectObj.h"
#include "MobLeverObj.h"
#include "MobTrapObj.h"
#include "MobFlameObj.h"
#include "MobParticle1Obj.h"
#include "MobParticle2Obj.h"
#include "MobParticle3Obj.h"
#include "OrientatorFrame.h"
#include "SynEditMiscClasses.hpp"
#include "SynEditSearch.hpp"

//---------------------------------------------------------------------------

class TMainF : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *FileMenu;
        TMenuItem *HelpMenu;
        TMenuItem *OpenMobMenu;
        TMenuItem *ExitMenu;
        TMenuItem *AboutMenu;
        TMenuItem *N3;
        TMenuItem *N4;
        TMenuItem *TestMenuMenu;
        TPageControl *MainF_PK;
        TTabSheet *LogSh;
        TStatusBar *StatusBar1;
        TToolBar *ToolBar1;
        TRichEdit *LogEd;
        TOpenDialog *OpenDialog1;
        TMenuItem *N5;
        TMenuItem *SaveMob_menu;
        TMenuItem *SaveAsMobMenu;
        TSaveDialog *SaveDialog1;
        TTabSheet *ScriptSh;
        TTabSheet *BlocksSh;
        TTabSheet *ObjectsSh;
        TTabSheet *DiplomacySh;
        TTabSheet *MassChangesSh;
        TMenuItem *N6;
        TMenuItem *ProgSettsMenu;
        TMenuItem *N1;
        TMenuItem *BackupMobMenu;
        TSynEdit *ScriptEd;
        TSynEIScriptSyn *SynEIScriptSyn1;
        TMenuItem *EditMenu;
        TMenuItem *SearchRepMenu;
        TMenuItem *N2;
        TMenuItem *CopyMenu;
        TMenuItem *CutMenu;
        TMenuItem *PasteMenu;
        TMenuItem *N7;
        TMenuItem *SelectAllMenu;
        TMenuItem *UndoMenu;
        TMenuItem *RedoMenu;
        TMenuItem *SearchNextMenu;
        TMenuItem *ReplaceNextMenu;
        TPageControl *MassChangePK;
        TTabSheet *MC_KriteriasSh;
        TTabSheet *MC_ActionsSh;
        TPanel *MC_DownPanel;
        TButton *MC_GoBut;
        TGroupBox *MC_KR_ParamGB;
        TCheckBox *MC_KR_Param_Name1CB;
        TEdit *MC_KR_Param_Name1Ed;
        TEdit *MC_KR_Param_Name2Ed;
        TEdit *MC_KR_Param_ScriptVariableNameEd;
        TEdit *MC_KR_Param_Model3dEd;
        TEdit *MC_KR_Param_FirstTextureEd;
        TEdit *MC_KR_Param_SecondTextureEd;
        TCheckBox *MC_KR_Param_Name2CB;
        TCheckBox *MC_KR_Param_ScriptVariableNameCB;
        TCheckBox *MC_KR_Param_Model3dCB;
        TCheckBox *MC_KR_Param_FirstTextureCB;
        TCheckBox *MC_KR_Param_SecondTextureCB;
        TGroupBox *MC_KR_CoordsGB;
        TCheckBox *MC_KR_Coords_PramouglCB;
        TLabel *Label1;
        TEdit *MC_KR_Coords_Pramougl_X1Ed;
        TLabel *Label2;
        TEdit *MC_KR_Coords_Pramougl_Y1Ed;
        TLabel *Label3;
        TEdit *MC_KR_Coords_Pramougl_X2Ed;
        TLabel *Label4;
        TEdit *MC_KR_Coords_Pramougl_Y2Ed;
        TCheckBox *MC_KR_Coords_KrugCB;
        TLabel *Label5;
        TEdit *MC_KR_Coords_Krug_XEd;
        TEdit *MC_KR_Coords_Krug_YEd;
        TLabel *Label6;
        TLabel *Label7;
        TEdit *MC_KR_Coords_Krug_RadEd;
        TGroupBox *MC_KR_TypeGB;
        TCheckBox *MC_KR_Type_UnitCB;
        TCheckBox *MC_KR_Type_ObjectCB;
        TCheckBox *MC_KR_Type_LeverCB;
        TCheckBox *MC_KR_Type_TrapCB;
        TCheckBox *MC_KR_Type_FlameCB;
        TCheckBox *MC_KR_Type_Particle1CB;
        TCheckBox *MC_KR_Type_Particle2CB;
        TCheckBox *MC_KR_Type_Particle3CB;
        TGroupBox *MC_AS_ObjGB;
        TLabel *Label8;
        TEdit *MC_AS_Obj_TargetMobEd;
        TButton *MC_AS_Obj_TargetMobSelBut;
        TRadioButton *MC_AS_Obj_DelRB;
        TRadioButton *MC_AS_Obj_CopyRB;
        TRadioButton *MC_AS_Obj_MoveRB;
        TCheckBox *MC_AS_Obj_ReplaceCB;
        TGroupBox *MC_AS_ParamsGB;
        TCheckBox *MC_AS_Params_Name1CB;
        TEdit *MC_AS_Params_Name1Ed;
        TCheckBox *MC_AS_Params_Name2CB;
        TEdit *MC_AS_Params_Name2Ed;
        TCheckBox *MC_AS_Params_ScriptVariableNameCB;
        TEdit *MC_AS_Params_ScriptVariableNameEd;
        TEdit *MC_AS_Params_Model3dEd;
        TCheckBox *MC_AS_Params_Model3dCB;
        TCheckBox *MC_AS_Params_FirstTextureCB;
        TEdit *MC_AS_Params_FirstTextureEd;
        TCheckBox *MC_AS_Params_SecondTextureCB;
        TEdit *MC_AS_Params_SecondTextureEd;
        TCheckBox *MC_AS_Params_OffsetCB;
        TLabel *Label9;
        TEdit *MC_AS_Params_OffsetXEd;
        TLabel *Label10;
        TEdit *MC_AS_Params_OffsetYEd;
        TButton *MC_ResetBut;
        TRadioButton *MC_AS_Obj_OnlyParamsRB;
        TTreeView *ObjectsTree;
        TValueListEditor *ValuesEditor;
        TOrientatorFr *ObjectOrientator;
        TMemo *OrientatorHelpMemo;
        TCheckBox *MC_KR_Param_PlayerNumberCB;
        TEdit *MC_KR_Param_PlayerNumberEd;
        TCheckBox *MC_AS_Params_PlayerNumberCB;
        TEdit *MC_AS_Params_PlayerNumberEd;
        TMenuItem *ReadmeMenu;
        TSynEditSearch *SynEditSearchEngine;
        TMenuItem *N8;
        TMenuItem *CloseMobMenu;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall ExitMenuClick(TObject *Sender);
        void __fastcall AboutMenuClick(TObject *Sender);
        void __fastcall TestMenuMenuClick(TObject *Sender);
        void __fastcall OpenMobMenuClick(TObject *Sender);
        void __fastcall SaveMob_menuClick(TObject *Sender);
        void __fastcall SaveAsMobMenuClick(TObject *Sender);
        void __fastcall LogShShow(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall ProgSettsMenuClick(TObject *Sender);
        void __fastcall ScriptEdEnter(TObject *Sender);
        void __fastcall ScriptEdExit(TObject *Sender);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall BackupMobMenuClick(TObject *Sender);
        void __fastcall SearchRepMenuClick(TObject *Sender);
        void __fastcall UndoMenuClick(TObject *Sender);
        void __fastcall RedoMenuClick(TObject *Sender);
        void __fastcall CopyMenuClick(TObject *Sender);
        void __fastcall CutMenuClick(TObject *Sender);
        void __fastcall PasteMenuClick(TObject *Sender);
        void __fastcall SelectAllMenuClick(TObject *Sender);
        void __fastcall SearchNextMenuClick(TObject *Sender);
        void __fastcall ReplaceNextMenuClick(TObject *Sender);
        void __fastcall MC_KR_Param_Name1EdChange(TObject *Sender);
        void __fastcall MC_KR_Param_Name2EdChange(TObject *Sender);
        void __fastcall MC_KR_Param_ScriptVariableNameEdChange(
          TObject *Sender);
        void __fastcall MC_KR_Param_Model3dEdChange(TObject *Sender);
        void __fastcall MC_KR_Param_FirstTextureEdChange(TObject *Sender);
        void __fastcall MC_KR_Param_SecondTextureEdChange(TObject *Sender);
        void __fastcall MC_KR_Coords_Pramougl_X1EdChange(TObject *Sender);
        void __fastcall MC_KR_Coords_Pramougl_Y1EdChange(TObject *Sender);
        void __fastcall MC_KR_Coords_Pramougl_X2EdChange(TObject *Sender);
        void __fastcall MC_KR_Coords_Pramougl_Y2EdChange(TObject *Sender);
        void __fastcall MC_KR_Coords_Krug_XEdChange(TObject *Sender);
        void __fastcall MC_KR_Coords_Krug_YEdChange(TObject *Sender);
        void __fastcall MC_KR_Coords_Krug_RadEdChange(TObject *Sender);
        void __fastcall MC_AS_Params_Name1EdChange(TObject *Sender);
        void __fastcall MC_AS_Params_Name2EdChange(TObject *Sender);
        void __fastcall MC_AS_Params_ScriptVariableNameEdChange(
          TObject *Sender);
        void __fastcall MC_AS_Params_Model3dEdChange(TObject *Sender);
        void __fastcall MC_AS_Params_FirstTextureEdChange(TObject *Sender);
        void __fastcall MC_AS_Params_SecondTextureEdChange(
          TObject *Sender);
        void __fastcall MC_AS_Params_OffsetXEdChange(TObject *Sender);
        void __fastcall MC_AS_Params_OffsetYEdChange(TObject *Sender);
        void __fastcall MC_AS_Obj_DelRBClick(TObject *Sender);
        void __fastcall MC_AS_Obj_CopyRBClick(TObject *Sender);
        void __fastcall MC_AS_Obj_MoveRBClick(TObject *Sender);
        void __fastcall MC_ResetButClick(TObject *Sender);
        void __fastcall MC_AS_Obj_TargetMobSelButClick(TObject *Sender);
        void __fastcall MC_GoButClick(TObject *Sender);
        void __fastcall MC_AS_Obj_OnlyParamsRBClick(TObject *Sender);
        void __fastcall ObjectsShResize(TObject *Sender);
        void __fastcall ObjectsShShow(TObject *Sender);
        void __fastcall ObjectsTreeChange(TObject *Sender,
          TTreeNode *Node);
        void __fastcall ValuesEditorValidate(TObject *Sender, int ACol,
          int ARow, const AnsiString KeyName, const AnsiString KeyValue);
        void __fastcall ValuesEditorExit(TObject *Sender);
        void __fastcall ValuesEditorEnter(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormPaint(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall MC_KR_Param_PlayerNumberEdChange(TObject *Sender);
        void __fastcall MC_AS_Params_PlayerNumberEdChange(TObject *Sender);
        void __fastcall ReadmeMenuClick(TObject *Sender);
        void __fastcall CloseMobMenuClick(TObject *Sender);
        void __fastcall ScriptEdChange(TObject *Sender);
private:	// User declarations
        bool FirstShowed;
        bool ObjEditorChanging;
        bool ObjEditorActive;
public:		// User declarations
        byte ObjTree_UnitsNode;           //
        byte ObjTree_ObjectsNode;         //
        byte ObjTree_LeversNode;          //
        byte ObjTree_TrapsNode;           //
        byte ObjTree_FlamesNode;          //
        byte ObjTree_Particles1Node;      // - 
        byte ObjTree_Particles2Node;      //
        byte ObjTree_Particles3Node;      //.        %).
        TWinControl *PLastFocus;   //    .
        TQuaternion *OldQuat;      //    ""  -  .

        bool BlockingInterfNow;  //    ...
        __fastcall TMainF(TComponent* Owner);
        void BlockInterf();    //  ...
        void UnBlockInterf();   //  ...
        void ReturnFocus();  //     :).
        void UpdateMainInterf();  //     .    :).
        void UpdateEditMenu();   //    :).
        void MakeASearch();       //       
        void MakeAReplace();      //       
        void MC_AS_UpdDel();      //             -  \  .
        void Set_MC_Interf();     // .    ini    .
        void Save_MC_Interf();    //      ini
        void Reset_MC_Interf();   //     .
        void SetMobModified();    //     (  save\load)   .
        void SetMobNotModified(); //      (  save\load)   .

        // ...
        void MobObjectsChanged(); //         ...

        //...
        void TreeMobObject2Editor(TTreeNode *Node);  //    ,        ...
        void UnitObject2Editor(TUnitObjBlock *MobObject);   //   ,   ...
        void ObjectObject2Editor(TObjectObjBlock *MobObject);   //   ,   ...
        void LeverObject2Editor(TLeverObjBlock *MobObject);   //   ,   ...
        void TrapObject2Editor(TTrapObjBlock *MobObject);   //   ,   ...
        void FlameObject2Editor(TFlameObjBlock *MobObject);   //   ,   ...
        void Particle1Object2Editor(TParticle1ObjBlock *MobObject);   //    1 ,   ...
        void Particle2Object2Editor(TParticle2ObjBlock *MobObject);   //    2 ,   ...
        void Particle3Object2Editor(TParticle3ObjBlock *MobObject);   //    3 ,   ...

        //....
        void Editor2MobObjectObj(const AnsiString KeyName, TObjectObjBlock *MobObject); //    ""    ...
        void Editor2MobUnitObj(const AnsiString KeyName, TUnitObjBlock *MobObject); //    ""    ...
        void Editor2MobLeverObj(const AnsiString KeyName, TLeverObjBlock *MobObject); //    ""    ...
        void Editor2MobTrapObj(const AnsiString KeyName, TTrapObjBlock *MobObject); //    ""    ...
        void Editor2MobFlameObj(const AnsiString KeyName, TFlameObjBlock *MobObject); //    ""    ...
        void Editor2MobParticle1Obj(const AnsiString KeyName, TParticle1ObjBlock *MobObject); //    " 1 "    ...
        void Editor2MobParticle2Obj(const AnsiString KeyName, TParticle2ObjBlock *MobObject); //    " 2 "    ...
        void Editor2MobParticle3Obj(const AnsiString KeyName, TParticle3ObjBlock *MobObject); //    " 3 "    ...

        //.
        void FillOrientator(TObjectObjBlock *MobObject);  //     .

};
//---------------------------------------------------------------------------
extern PACKAGE TMainF *MainF;
//---------------------------------------------------------------------------
#endif
