///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------


#pragma hdrstop

#include "MobTrapObj.h"
#include "MobFormat.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

///////////////////////////////////
//TTrapObjBlock
///////////////////////////////////

DWORD TTrapObjBlock::GetBlockSize()
//       .
{
  //...
  DWORD Result = 65;
  int i;
  //65 -    .

  //  ...

  //   ,      ...
  Result = Result + MagicStr.Length() + (TrapPoints1->Length*12)
  +(TrapPoints2->Length*8);

  //       
  //  ...
  Result = Result + TObjectObjBlock::GetBlockSize();

  return Result;
};

bool TTrapObjBlock::ReadBlock(byte *Buff, DWORD BuffSize, bool UseLog, TMob *PMobObj)
//     .
{
  // ...
  DWORD TempDW1, MinBlockSgn, MinBlockSize, TempDW2, i;
  bool Result = true;
  __int64 Cursor = 8;

  //PMobObj->StringToLog(" :"+IntToStr(BuffSize));
  //    .
  do
  {
    //  ...
    memcpy(&MinBlockSgn,&Buff[Cursor],4);
    Cursor = Cursor+4;
    //     ...
    if (MinBlockSgn == Trap_Sgn_UnknDw1)
    {
      // DW.
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UnknDw1,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }


    else if (MinBlockSgn == Trap_Sgn_MagicStr)
    {
      //   -   .
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
      MagicStr.SetLength(MinBlockSize-8);

      if ((MinBlockSize-8) != 0)
      {
        // ...
        memcpy(&MagicStr[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        MagicStr = "";
      };
    }

    else if (MinBlockSgn == Trap_Sgn_UnknDw2)
    {
      // DW.
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UnknDw2,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Trap_Sgn_UnknByte1)
    {
      // byte.
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UnknByte1,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Trap_Sgn_TrapPoints1)
    {
      //  1.
      //DynamicArray <STrapPoint1>

      //   .
      TrapPoints1 = new DynamicArray <STrapPoint1>;

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  
      memcpy(&TempDW1,&Buff[Cursor],4);
      Cursor = Cursor+4;

      if (TempDW1 != 0)
      {
        //  ...
        // ...
        TrapPoints1->Length = TempDW1;

        i = -1;
        do
        {
          //   ...
          TempDW1 = TempDW1-1; //  -        
          i = i+1;

          //  ...
          memcpy(&TrapPoints1->operator[](i).CoordX,&Buff[Cursor],4);
          Cursor = Cursor+4;
          memcpy(&TrapPoints1->operator[](i).CoordY,&Buff[Cursor],4);
          Cursor = Cursor+4;
          memcpy(&TrapPoints1->operator[](i).Range,&Buff[Cursor],4);
          Cursor = Cursor+4;
        }
        while (TempDW1 != 0);
      }
      else
      {
        //  ...
        TrapPoints1->Length = 0;
      };
    }

    else if (MinBlockSgn == Trap_Sgn_TrapPoints2)
    {
      //  2.
      //DynamicArray <STrapPoint2>

      //   .
      TrapPoints2 = new DynamicArray <STrapPoint2>;

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  
      memcpy(&TempDW1,&Buff[Cursor],4);
      Cursor = Cursor+4;

      if (TempDW1 != 0)
      {
        //  ...
        // ...
        TrapPoints2->Length = TempDW1;

        i = -1;
        do
        {
          //   ...
          TempDW1 = TempDW1-1; //  -        
          i = i+1;

          //  ...
          memcpy(&TrapPoints2->operator[](i).CoordX,&Buff[Cursor],4);
          Cursor = Cursor+4;
          memcpy(&TrapPoints2->operator[](i).CoordY,&Buff[Cursor],4);
          Cursor = Cursor+4;
        }
        while (TempDW1 != 0);
      }
      else
      {
        //  ...
        TrapPoints2->Length = 0;
      };
    }

    else if (MinBlockSgn == Obj_Sgn_BodyTextures)
    {
      //  -       ...
      //-      ....     :).
      MinBlockSize = GetNMobBlocksSize(Buff,Cursor-4,17);  //    
      TObjectObjBlock::ReadBlock(&Buff[Cursor-12],MinBlockSize+8,UseLog,PMobObj);
      Cursor = Cursor+MinBlockSize-4;  //   . ...
    };

  }
  while (Cursor != BuffSize);

  //PMobObj->StringToLog("    :"+IntToStr(GetBlockSize()));

  StopLoadUnitBlock:        //     .
  ;
  return Result;
};

byte* TTrapObjBlock::GenBlock(DWORD& BlockSize)
// ...
{
  //
  byte* Result = NULL;
  int i = 0; //
  DWORD ChetireBaita, BlockSignature;
  DWORD Cursor = 0;

  //, .      ...
  BlockSize = GetBlockSize();
  Result = new byte[BlockSize];

  // ...
  memcpy(&Result[Cursor],&OB_Sgn_Trap,4);
  Cursor = Cursor+4;

  // .
  memcpy(&Result[Cursor],&BlockSize,4);
  Cursor = Cursor+4;

  // DW.
  //DWORD
  // 
  memcpy(&Result[Cursor],&Trap_Sgn_UnknDw1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknDw1,4);
  Cursor = Cursor+4;

  //   -   .
  //String
  // 
  memcpy(&Result[Cursor],&Trap_Sgn_MagicStr,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+MagicStr.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&MagicStr[1],MagicStr.Length());
    Cursor = Cursor+MagicStr.Length();
  };

  // DW.
  //DWORD
  // 
  memcpy(&Result[Cursor],&Trap_Sgn_UnknDw2,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknDw2,4);
  Cursor = Cursor+4;

  // byte.
  //byte
  // 
  memcpy(&Result[Cursor],&Trap_Sgn_UnknByte1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknByte1,4);
  Cursor = Cursor+1;

  //  1
  //DynamicArray <STrapPoint1>
  // 
  memcpy(&Result[Cursor],&Trap_Sgn_TrapPoints1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = (TrapPoints1->Length*12) + 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //   ...
  ChetireBaita = TrapPoints1->Length;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  // ...
  for (i = 0; i < TrapPoints1->Length; i++)
  {
    memcpy(&Result[Cursor],&TrapPoints1->operator[](i).CoordX,4);
    Cursor = Cursor+4;
    memcpy(&Result[Cursor],&TrapPoints1->operator[](i).CoordY,4);
    Cursor = Cursor+4;
    memcpy(&Result[Cursor],&TrapPoints1->operator[](i).Range,4);
    Cursor = Cursor+4;
  };  

  //  2
  //DynamicArray <STrapPoint2>
  // 
  memcpy(&Result[Cursor],&Trap_Sgn_TrapPoints2,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = (TrapPoints2->Length*8) + 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //   ...
  ChetireBaita = TrapPoints2->Length;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  // ...
  for (i = 0; i < TrapPoints2->Length; i++)
  {
    memcpy(&Result[Cursor],&TrapPoints2->operator[](i).CoordX,4);
    Cursor = Cursor+4;
    memcpy(&Result[Cursor],&TrapPoints2->operator[](i).CoordY,4);
    Cursor = Cursor+4;
  };  

  //    ...
  TObjectObjBlock::GenBasePart(&Result[Cursor]);
  Cursor = Cursor+TObjectObjBlock::GetBlockSize()-8;

  //  ...
  return Result;
};
