{-------------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

Code template generated with SynGen.
The original code is: SynHighlighterEIScript.pas, released 2005-06-18.
Description: Evil Islands Script highlighter
The initial author of this file is Sagrer.
Copyright (c) 2005, all rights reserved.

Contributors to the SynEdit and mwEdit projects are listed in the
Contributors.txt file.

Alternatively, the contents of this file may be used under the terms of the
GNU General Public License Version 2 or later (the "GPL"), in which case
the provisions of the GPL are applicable instead of those above.
If you wish to allow use of your version of this file only under the terms
of the GPL and not to allow others to use your version of this file
under the MPL, indicate your decision by deleting the provisions above and
replace them with the notice and other provisions required by the GPL.
If you do not delete the provisions above, a recipient may use your version
of this file under either the MPL or the GPL.

$Id: $

You may retrieve the latest version of this file at the SynEdit home page,
located at http://SynEdit.SourceForge.net

-------------------------------------------------------------------------------}

unit SynHighlighterEIScript;

{$I SynEdit.inc}

interface

uses
  SysUtils,
  Classes,
{$IFDEF SYN_CLX}
  QControls,
  QGraphics,
{$ELSE}
  Windows,
  Controls,
  Graphics,
{$ENDIF}
  SynEditTypes,
  SynEditHighlighter;

type
  TtkTokenKind = (
    tkComment,
    tkDateTypes,
    tkFunctions,
    tkIdentifier,
    tkKey,
    tkNull,
    tkNumber,
    tkSkobki,
    tkStringValues,
    tkUnknown);

  TRangeState = (rsUnKnown, rsCommentProc, rsStringValuesProc);

  TProcTableProc = procedure of object;

  PIdentFuncTableFunc = ^TIdentFuncTableFunc;
  TIdentFuncTableFunc = function: TtkTokenKind of object;

const
  MaxKey = 291;

type
  TSynEIScriptSyn = class(TSynCustomHighlighter)
  private
    fLine: PChar;
    fLineNumber: Integer;
    fProcTable: array[#0..#255] of TProcTableProc;
    fRange: TRangeState;
    Run: LongInt;
    fStringLen: Integer;
    fToIdent: PChar;
    fTokenPos: Integer;
    fTokenID: TtkTokenKind;
    fIdentFuncTable: array[0 .. MaxKey] of TIdentFuncTableFunc;
    fCommentAttri: TSynHighlighterAttributes;
    fDateTypesAttri: TSynHighlighterAttributes;
    fFunctionsAttri: TSynHighlighterAttributes;
    fIdentifierAttri: TSynHighlighterAttributes;
    fKeyAttri: TSynHighlighterAttributes;
    fNumberAttri: TSynHighlighterAttributes;
    fSkobkiAttri: TSynHighlighterAttributes;
    fStringValuesAttri: TSynHighlighterAttributes;
    function KeyHash(ToHash: PChar): Integer;
    function KeyComp(const aKey: string): Boolean;
    function Func9: TtkTokenKind;
    function Func15: TtkTokenKind;
    function Func24: TtkTokenKind;
    function Func26: TtkTokenKind;
    function Func29: TtkTokenKind;
    function Func30: TtkTokenKind;
    function Func35: TtkTokenKind;
    function Func39: TtkTokenKind;
    function Func40: TtkTokenKind;
    function Func42: TtkTokenKind;
    function Func43: TtkTokenKind;
    function Func46: TtkTokenKind;
    function Func47: TtkTokenKind;
    function Func49: TtkTokenKind;
    function Func51: TtkTokenKind;
    function Func53: TtkTokenKind;
    function Func54: TtkTokenKind;
    function Func55: TtkTokenKind;
    function Func56: TtkTokenKind;
    function Func57: TtkTokenKind;
    function Func58: TtkTokenKind;
    function Func59: TtkTokenKind;
    function Func62: TtkTokenKind;
    function Func63: TtkTokenKind;
    function Func64: TtkTokenKind;
    function Func65: TtkTokenKind;
    function Func67: TtkTokenKind;
    function Func69: TtkTokenKind;
    function Func71: TtkTokenKind;
    function Func73: TtkTokenKind;
    function Func75: TtkTokenKind;
    function Func76: TtkTokenKind;
    function Func77: TtkTokenKind;
    function Func78: TtkTokenKind;
    function Func81: TtkTokenKind;
    function Func82: TtkTokenKind;
    function Func83: TtkTokenKind;
    function Func84: TtkTokenKind;
    function Func85: TtkTokenKind;
    function Func86: TtkTokenKind;
    function Func87: TtkTokenKind;
    function Func88: TtkTokenKind;
    function Func89: TtkTokenKind;
    function Func90: TtkTokenKind;
    function Func92: TtkTokenKind;
    function Func93: TtkTokenKind;
    function Func94: TtkTokenKind;
    function Func95: TtkTokenKind;
    function Func96: TtkTokenKind;
    function Func99: TtkTokenKind;
    function Func100: TtkTokenKind;
    function Func101: TtkTokenKind;
    function Func102: TtkTokenKind;
    function Func104: TtkTokenKind;
    function Func105: TtkTokenKind;
    function Func106: TtkTokenKind;
    function Func107: TtkTokenKind;
    function Func108: TtkTokenKind;
    function Func109: TtkTokenKind;
    function Func110: TtkTokenKind;
    function Func111: TtkTokenKind;
    function Func114: TtkTokenKind;
    function Func115: TtkTokenKind;
    function Func116: TtkTokenKind;
    function Func117: TtkTokenKind;
    function Func118: TtkTokenKind;
    function Func119: TtkTokenKind;
    function Func120: TtkTokenKind;
    function Func121: TtkTokenKind;
    function Func123: TtkTokenKind;
    function Func125: TtkTokenKind;
    function Func126: TtkTokenKind;
    function Func127: TtkTokenKind;
    function Func128: TtkTokenKind;
    function Func129: TtkTokenKind;
    function Func130: TtkTokenKind;
    function Func132: TtkTokenKind;
    function Func133: TtkTokenKind;
    function Func135: TtkTokenKind;
    function Func136: TtkTokenKind;
    function Func137: TtkTokenKind;
    function Func138: TtkTokenKind;
    function Func140: TtkTokenKind;
    function Func141: TtkTokenKind;
    function Func142: TtkTokenKind;
    function Func143: TtkTokenKind;
    function Func144: TtkTokenKind;
    function Func145: TtkTokenKind;
    function Func147: TtkTokenKind;
    function Func148: TtkTokenKind;
    function Func149: TtkTokenKind;
    function Func150: TtkTokenKind;
    function Func151: TtkTokenKind;
    function Func152: TtkTokenKind;
    function Func153: TtkTokenKind;
    function Func154: TtkTokenKind;
    function Func155: TtkTokenKind;
    function Func156: TtkTokenKind;
    function Func157: TtkTokenKind;
    function Func158: TtkTokenKind;
    function Func159: TtkTokenKind;
    function Func162: TtkTokenKind;
    function Func163: TtkTokenKind;
    function Func164: TtkTokenKind;
    function Func165: TtkTokenKind;
    function Func167: TtkTokenKind;
    function Func168: TtkTokenKind;
    function Func170: TtkTokenKind;
    function Func171: TtkTokenKind;
    function Func172: TtkTokenKind;
    function Func173: TtkTokenKind;
    function Func174: TtkTokenKind;
    function Func175: TtkTokenKind;
    function Func177: TtkTokenKind;
    function Func180: TtkTokenKind;
    function Func181: TtkTokenKind;
    function Func182: TtkTokenKind;
    function Func185: TtkTokenKind;
    function Func188: TtkTokenKind;
    function Func189: TtkTokenKind;
    function Func192: TtkTokenKind;
    function Func194: TtkTokenKind;
    function Func195: TtkTokenKind;
    function Func199: TtkTokenKind;
    function Func202: TtkTokenKind;
    function Func203: TtkTokenKind;
    function Func204: TtkTokenKind;
    function Func207: TtkTokenKind;
    function Func209: TtkTokenKind;
    function Func213: TtkTokenKind;
    function Func216: TtkTokenKind;
    function Func217: TtkTokenKind;
    function Func218: TtkTokenKind;
    function Func220: TtkTokenKind;
    function Func222: TtkTokenKind;
    function Func223: TtkTokenKind;
    function Func225: TtkTokenKind;
    function Func231: TtkTokenKind;
    function Func232: TtkTokenKind;
    function Func233: TtkTokenKind;
    function Func235: TtkTokenKind;
    function Func236: TtkTokenKind;
    function Func238: TtkTokenKind;
    function Func252: TtkTokenKind;
    function Func268: TtkTokenKind;
    function Func272: TtkTokenKind;
    function Func274: TtkTokenKind;
    function Func281: TtkTokenKind;
    function Func291: TtkTokenKind;
    procedure IdentProc;
    procedure NumberProc;
    procedure SkobkiProc;
    procedure UnknownProc;
    function AltFunc: TtkTokenKind;
    procedure InitIdent;
    function IdentKind(MayBe: PChar): TtkTokenKind;
    procedure MakeMethodTables;
    procedure NullProc;
    procedure CRProc;
    procedure LFProc;
    procedure CommentProcOpenProc;
    procedure CommentProcProc;
    procedure StringValuesProcOpenProc;
    procedure StringValuesProcProc;
  protected
    function GetIdentChars: TSynIdentChars; override;
    function GetSampleSource: string; override;
    function IsFilterStored: Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    {$IFNDEF SYN_CPPB_1} class {$ENDIF}
    function GetLanguageName: string; override;
    function GetRange: Pointer; override;
    procedure ResetRange; override;
    procedure SetRange(Value: Pointer); override;
    function GetDefaultAttribute(Index: integer): TSynHighlighterAttributes; override;
    function GetEol: Boolean; override;
    function GetKeyWords: string;
    function GetTokenID: TtkTokenKind;
    procedure SetLine(NewValue: String; LineNumber: Integer); override;
    function GetToken: String; override;
    function GetTokenAttribute: TSynHighlighterAttributes; override;
    function GetTokenKind: integer; override;
    function GetTokenPos: Integer; override;
    procedure Next; override;
  published
    property CommentAttri: TSynHighlighterAttributes read fCommentAttri write fCommentAttri;
    property DateTypesAttri: TSynHighlighterAttributes read fDateTypesAttri write fDateTypesAttri;
    property FunctionsAttri: TSynHighlighterAttributes read fFunctionsAttri write fFunctionsAttri;
    property IdentifierAttri: TSynHighlighterAttributes read fIdentifierAttri write fIdentifierAttri;
    property KeyAttri: TSynHighlighterAttributes read fKeyAttri write fKeyAttri;
    property NumberAttri: TSynHighlighterAttributes read fNumberAttri write fNumberAttri;
    property SkobkiAttri: TSynHighlighterAttributes read fSkobkiAttri write fSkobkiAttri;
    property StringValuesAttri: TSynHighlighterAttributes read fStringValuesAttri write fStringValuesAttri;
  end;

implementation

uses
  SynEditStrConst;

{$IFDEF SYN_COMPILER_3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}
  SYNS_FilterEvilIslandsscript = 'Mob files (*.mob)|*.mob';
  SYNS_LangEvilIslandsscript = 'Evil Islands script';
  SYNS_AttrDateTypes = 'DateTypes';
  SYNS_AttrFunctions = 'Functions';
  SYNS_AttrSkobki = 'Skobki';
  SYNS_AttrStringValues = 'StringValues';

var
  Identifiers: array[#0..#255] of ByteBool;
  mHashTable : array[#0..#255] of Integer;

procedure MakeIdentTable;
var
  I, J: Char;
begin
  for I := #0 to #255 do
  begin
    case I of
      '_', 'a'..'z', 'A'..'Z': Identifiers[I] := True;
    else
      Identifiers[I] := False;
    end;
    J := UpCase(I);
    case I in ['_', 'A'..'Z', 'a'..'z'] of
      True: mHashTable[I] := Ord(J) - 64
    else
      mHashTable[I] := 0;
    end;
  end;
end;

procedure TSynEIScriptSyn.InitIdent;
var
  I: Integer;
  pF: PIdentFuncTableFunc;
begin
  pF := PIdentFuncTableFunc(@fIdentFuncTable);
  for I := Low(fIdentFuncTable) to High(fIdentFuncTable) do
  begin
    pF^ := AltFunc;
    Inc(pF);
  end;
  fIdentFuncTable[9] := Func9;
  fIdentFuncTable[15] := Func15;
  fIdentFuncTable[24] := Func24;
  fIdentFuncTable[26] := Func26;
  fIdentFuncTable[29] := Func29;
  fIdentFuncTable[30] := Func30;
  fIdentFuncTable[35] := Func35;
  fIdentFuncTable[39] := Func39;
  fIdentFuncTable[40] := Func40;
  fIdentFuncTable[42] := Func42;
  fIdentFuncTable[43] := Func43;
  fIdentFuncTable[46] := Func46;
  fIdentFuncTable[47] := Func47;
  fIdentFuncTable[49] := Func49;
  fIdentFuncTable[51] := Func51;
  fIdentFuncTable[53] := Func53;
  fIdentFuncTable[54] := Func54;
  fIdentFuncTable[55] := Func55;
  fIdentFuncTable[56] := Func56;
  fIdentFuncTable[57] := Func57;
  fIdentFuncTable[58] := Func58;
  fIdentFuncTable[59] := Func59;
  fIdentFuncTable[62] := Func62;
  fIdentFuncTable[63] := Func63;
  fIdentFuncTable[64] := Func64;
  fIdentFuncTable[65] := Func65;
  fIdentFuncTable[67] := Func67;
  fIdentFuncTable[69] := Func69;
  fIdentFuncTable[71] := Func71;
  fIdentFuncTable[73] := Func73;
  fIdentFuncTable[75] := Func75;
  fIdentFuncTable[76] := Func76;
  fIdentFuncTable[77] := Func77;
  fIdentFuncTable[78] := Func78;
  fIdentFuncTable[81] := Func81;
  fIdentFuncTable[82] := Func82;
  fIdentFuncTable[83] := Func83;
  fIdentFuncTable[84] := Func84;
  fIdentFuncTable[85] := Func85;
  fIdentFuncTable[86] := Func86;
  fIdentFuncTable[87] := Func87;
  fIdentFuncTable[88] := Func88;
  fIdentFuncTable[89] := Func89;
  fIdentFuncTable[90] := Func90;
  fIdentFuncTable[92] := Func92;
  fIdentFuncTable[93] := Func93;
  fIdentFuncTable[94] := Func94;
  fIdentFuncTable[95] := Func95;
  fIdentFuncTable[96] := Func96;
  fIdentFuncTable[99] := Func99;
  fIdentFuncTable[100] := Func100;
  fIdentFuncTable[101] := Func101;
  fIdentFuncTable[102] := Func102;
  fIdentFuncTable[104] := Func104;
  fIdentFuncTable[105] := Func105;
  fIdentFuncTable[106] := Func106;
  fIdentFuncTable[107] := Func107;
  fIdentFuncTable[108] := Func108;
  fIdentFuncTable[109] := Func109;
  fIdentFuncTable[110] := Func110;
  fIdentFuncTable[111] := Func111;
  fIdentFuncTable[114] := Func114;
  fIdentFuncTable[115] := Func115;
  fIdentFuncTable[116] := Func116;
  fIdentFuncTable[117] := Func117;
  fIdentFuncTable[118] := Func118;
  fIdentFuncTable[119] := Func119;
  fIdentFuncTable[120] := Func120;
  fIdentFuncTable[121] := Func121;
  fIdentFuncTable[123] := Func123;
  fIdentFuncTable[125] := Func125;
  fIdentFuncTable[126] := Func126;
  fIdentFuncTable[127] := Func127;
  fIdentFuncTable[128] := Func128;
  fIdentFuncTable[129] := Func129;
  fIdentFuncTable[130] := Func130;
  fIdentFuncTable[132] := Func132;
  fIdentFuncTable[133] := Func133;
  fIdentFuncTable[135] := Func135;
  fIdentFuncTable[136] := Func136;
  fIdentFuncTable[137] := Func137;
  fIdentFuncTable[138] := Func138;
  fIdentFuncTable[140] := Func140;
  fIdentFuncTable[141] := Func141;
  fIdentFuncTable[142] := Func142;
  fIdentFuncTable[143] := Func143;
  fIdentFuncTable[144] := Func144;
  fIdentFuncTable[145] := Func145;
  fIdentFuncTable[147] := Func147;
  fIdentFuncTable[148] := Func148;
  fIdentFuncTable[149] := Func149;
  fIdentFuncTable[150] := Func150;
  fIdentFuncTable[151] := Func151;
  fIdentFuncTable[152] := Func152;
  fIdentFuncTable[153] := Func153;
  fIdentFuncTable[154] := Func154;
  fIdentFuncTable[155] := Func155;
  fIdentFuncTable[156] := Func156;
  fIdentFuncTable[157] := Func157;
  fIdentFuncTable[158] := Func158;
  fIdentFuncTable[159] := Func159;
  fIdentFuncTable[162] := Func162;
  fIdentFuncTable[163] := Func163;
  fIdentFuncTable[164] := Func164;
  fIdentFuncTable[165] := Func165;
  fIdentFuncTable[167] := Func167;
  fIdentFuncTable[168] := Func168;
  fIdentFuncTable[170] := Func170;
  fIdentFuncTable[171] := Func171;
  fIdentFuncTable[172] := Func172;
  fIdentFuncTable[173] := Func173;
  fIdentFuncTable[174] := Func174;
  fIdentFuncTable[175] := Func175;
  fIdentFuncTable[177] := Func177;
  fIdentFuncTable[180] := Func180;
  fIdentFuncTable[181] := Func181;
  fIdentFuncTable[182] := Func182;
  fIdentFuncTable[185] := Func185;
  fIdentFuncTable[188] := Func188;
  fIdentFuncTable[189] := Func189;
  fIdentFuncTable[192] := Func192;
  fIdentFuncTable[194] := Func194;
  fIdentFuncTable[195] := Func195;
  fIdentFuncTable[199] := Func199;
  fIdentFuncTable[202] := Func202;
  fIdentFuncTable[203] := Func203;
  fIdentFuncTable[204] := Func204;
  fIdentFuncTable[207] := Func207;
  fIdentFuncTable[209] := Func209;
  fIdentFuncTable[213] := Func213;
  fIdentFuncTable[216] := Func216;
  fIdentFuncTable[217] := Func217;
  fIdentFuncTable[218] := Func218;
  fIdentFuncTable[220] := Func220;
  fIdentFuncTable[222] := Func222;
  fIdentFuncTable[223] := Func223;
  fIdentFuncTable[225] := Func225;
  fIdentFuncTable[231] := Func231;
  fIdentFuncTable[232] := Func232;
  fIdentFuncTable[233] := Func233;
  fIdentFuncTable[235] := Func235;
  fIdentFuncTable[236] := Func236;
  fIdentFuncTable[238] := Func238;
  fIdentFuncTable[252] := Func252;
  fIdentFuncTable[268] := Func268;
  fIdentFuncTable[272] := Func272;
  fIdentFuncTable[274] := Func274;
  fIdentFuncTable[281] := Func281;
  fIdentFuncTable[291] := Func291;
end;

function TSynEIScriptSyn.KeyHash(ToHash: PChar): Integer;
begin
  Result := 0;
  while ToHash^ in ['_', 'a'..'z', 'A'..'Z'] do
  begin
    inc(Result, mHashTable[ToHash^]);
    inc(ToHash);
  end;
  fStringLen := ToHash - fToIdent;
end;

function TSynEIScriptSyn.KeyComp(const aKey: String): Boolean;
var
  I: Integer;
  Temp: PChar;
begin
  Temp := fToIdent;
  if Length(aKey) = fStringLen then
  begin
    Result := True;
    for i := 1 to fStringLen do
    begin
      if mHashTable[Temp^] <> mHashTable[aKey[i]] then
      begin
        Result := False;
        break;
      end;
      inc(Temp);
    end;
  end
  else
    Result := False;
end;

function TSynEIScriptSyn.Func9: TtkTokenKind;
begin
  if KeyComp('Add') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func15: TtkTokenKind;
begin
  if KeyComp('if') then Result := tkKey else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func24: TtkTokenKind;
begin
  if KeyComp('HP') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func26: TtkTokenKind;
begin
  if KeyComp('Lie') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func29: TtkTokenKind;
begin
  if KeyComp('Mana') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func30: TtkTokenKind;
begin
  if KeyComp('Idle') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func35: TtkTokenKind;
begin
  if KeyComp('Div') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func39: TtkTokenKind;
begin
  if KeyComp('For') then Result := tkKey else
    if KeyComp('AddMob') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func40: TtkTokenKind;
begin
  if KeyComp('Any') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func42: TtkTokenKind;
begin
  if KeyComp('IsDead') then Result := tkFunctions else
    if KeyComp('UMAg') then Result := tkFunctions else
      if KeyComp('Sub') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func43: TtkTokenKind;
begin
  if KeyComp('Cast') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func46: TtkTokenKind;
begin
  if KeyComp('Mul') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func47: TtkTokenKind;
begin
  if KeyComp('then') then Result := tkKey else
    if KeyComp('Walk') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func49: TtkTokenKind;
begin
  if KeyComp('Not') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func51: TtkTokenKind;
begin
  if KeyComp('Guard') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func53: TtkTokenKind;
begin
  if KeyComp('Run') then Result := tkFunctions else
    if KeyComp('Sum') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func54: TtkTokenKind;
begin
  if KeyComp('float') then Result := tkDateTypes else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func55: TtkTokenKind;
begin
  if KeyComp('object') then Result := tkDateTypes else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func56: TtkTokenKind;
begin
  if KeyComp('Attack') then Result := tkFunctions else
    if KeyComp('GetX') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func57: TtkTokenKind;
begin
  if KeyComp('Crawl') then Result := tkFunctions else
    if KeyComp('GetY') then Result := tkFunctions else
      if KeyComp('Sleep') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func58: TtkTokenKind;
begin
  if KeyComp('GetZ') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func59: TtkTokenKind;
begin
  if KeyComp('NULL') then Result := tkKey else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func62: TtkTokenKind;
begin
  if KeyComp('MaxHP') then Result := tkFunctions else
    if KeyComp('Rest') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func63: TtkTokenKind;
begin
  if KeyComp('SetCP') then Result := tkFunctions else
    if KeyComp('GodMode') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func64: TtkTokenKind;
begin
  if KeyComp('UMFear') then Result := tkFunctions else
    if KeyComp('AddObject') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func65: TtkTokenKind;
begin
  if KeyComp('Random') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func67: TtkTokenKind;
begin
  if KeyComp('MaxMana') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func69: TtkTokenKind;
begin
  if KeyComp('QObjArea') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func71: TtkTokenKind;
begin
  if KeyComp('AddLoot') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func73: TtkTokenKind;
begin
  if KeyComp('UMClear') then Result := tkFunctions else
    if KeyComp('IsAlarm') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func75: TtkTokenKind;
begin
  if KeyComp('Every') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func76: TtkTokenKind;
begin
  if KeyComp('IsInArea') then Result := tkFunctions else
    if KeyComp('DeleteArea') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func77: TtkTokenKind;
begin
  if KeyComp('IsAlive') then Result := tkFunctions else
    if KeyComp('GetLeader') then Result := tkFunctions else
      if KeyComp('group') then Result := tkDateTypes else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func78: TtkTokenKind;
begin
  if KeyComp('Standt') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func81: TtkTokenKind;
begin
  if KeyComp('HideObject') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func82: TtkTokenKind;
begin
  if KeyComp('CreateFX') then Result := tkFunctions else
    if KeyComp('Qfinish') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func83: TtkTokenKind;
begin
  if KeyComp('Follow') then Result := tkFunctions else
    if KeyComp('HaveItem') then Result := tkFunctions else
      if KeyComp('IsLess') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func84: TtkTokenKind;
begin
  if KeyComp('PlayFX') then Result := tkFunctions else
    if KeyComp('IsEqual') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func85: TtkTokenKind;
begin
  if KeyComp('UMGuard') then Result := tkFunctions else
    if KeyComp('Script') then Result := tkKey else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func86: TtkTokenKind;
begin
  if KeyComp('GroupAdd') then Result := tkFunctions else
    if KeyComp('IsNight') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func87: TtkTokenKind;
begin
  if KeyComp('GetObject') then Result := tkFunctions else
    if KeyComp('string') then Result := tkDateTypes else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func88: TtkTokenKind;
begin
  if KeyComp('GSDelVar') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func89: TtkTokenKind;
begin
  if KeyComp('QObjUse') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func90: TtkTokenKind;
begin
  if KeyComp('GiveItem') then Result := tkFunctions else
    if KeyComp('IsEnemy') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func92: TtkTokenKind;
begin
  if KeyComp('AlarmTime') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func93: TtkTokenKind;
begin
  if KeyComp('UnitSee') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func94: TtkTokenKind;
begin
  if KeyComp('SetWind') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func95: TtkTokenKind;
begin
  if KeyComp('QStart') then Result := tkFunctions else
    if KeyComp('PlayCamera') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func96: TtkTokenKind;
begin
  if KeyComp('GetAIClass') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func99: TtkTokenKind;
begin
  if KeyComp('GSGetVar') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func100: TtkTokenKind;
begin
  if KeyComp('GetObjectID') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func101: TtkTokenKind;
begin
  if KeyComp('Sentry') then Result := tkFunctions else
    if KeyComp('EnableLever') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func102: TtkTokenKind;
begin
  if KeyComp('IsGreater') then Result := tkFunctions else
    if KeyComp('SetScience') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func104: TtkTokenKind;
begin
  if KeyComp('InflictDamage') then Result := tkFunctions else
    if KeyComp('GetMoney') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func105: TtkTokenKind;
begin
  if KeyComp('GroupHas') then Result := tkFunctions else
    if KeyComp('FixItems') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func106: TtkTokenKind;
begin
  if KeyComp('GroupSee') then Result := tkFunctions else
    if KeyComp('GiveSkill') then Result := tkFunctions else
      if KeyComp('PlayerSee') then Result := tkFunctions else
        if KeyComp('SetEnemy') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func107: TtkTokenKind;
begin
  if KeyComp('BlockUnit') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func108: TtkTokenKind;
begin
  if KeyComp('SendEvent') then Result := tkFunctions else
    if KeyComp('KillUnit') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func109: TtkTokenKind;
begin
  if KeyComp('GetPlayer') then Result := tkFunctions else
    if KeyComp('GlobalVars') then Result := tkKey else
      if KeyComp('SetCPFast') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func110: TtkTokenKind;
begin
  if KeyComp('UMRevenge') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func111: TtkTokenKind;
begin
  if KeyComp('GSSetVar') then Result := tkFunctions else
    if KeyComp('UMPlayer') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func114: TtkTokenKind;
begin
  if KeyComp('WasLooted') then Result := tkFunctions else
    if KeyComp('RotateTo') then Result := tkFunctions else
      if KeyComp('UMGuardEx') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func115: TtkTokenKind;
begin
  if KeyComp('AddRectToArea') then Result := tkFunctions else
    if KeyComp('GiveMoney') then Result := tkFunctions else
      if KeyComp('UMStandard') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func116: TtkTokenKind;
begin
  if KeyComp('UMPatrol') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func117: TtkTokenKind;
begin
  if KeyComp('UMFollow') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func118: TtkTokenKind;
begin
  if KeyComp('PlayMovie') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func119: TtkTokenKind;
begin
  if KeyComp('PlayMusic') then Result := tkFunctions else
    if KeyComp('GetZValue') then Result := tkFunctions else
      if KeyComp('AlarmPosX') then Result := tkFunctions else
        if KeyComp('GroupSub') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func120: TtkTokenKind;
begin
  if KeyComp('AlarmPosY') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func121: TtkTokenKind;
begin
  if KeyComp('SetPlayer') then Result := tkFunctions else
    if KeyComp('CopyLoot') then Result := tkFunctions else
      if KeyComp('InvokeAlarm') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func123: TtkTokenKind;
begin
  if KeyComp('QObjGetItem') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func125: TtkTokenKind;
begin
  if KeyComp('CopyItems') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func126: TtkTokenKind;
begin
  if KeyComp('ShowBitmap') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func127: TtkTokenKind;
begin
  if KeyComp('GetObjectByID') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func128: TtkTokenKind;
begin
  if KeyComp('QObjSeeObject') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func129: TtkTokenKind;
begin
  if KeyComp('KillScript') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func130: TtkTokenKind;
begin
  if KeyComp('GetDiplomacy') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func132: TtkTokenKind;
begin
  if KeyComp('CreateParty') then Result := tkFunctions else
    if KeyComp('IsInSquare') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func133: TtkTokenKind;
begin
  if KeyComp('RemoveObject') then Result := tkFunctions else
    if KeyComp('DeclareScript') then Result := tkKey else
      if KeyComp('SleepUntil') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func135: TtkTokenKind;
begin
  if KeyComp('UMSentry') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func136: TtkTokenKind;
begin
  if KeyComp('GroupSize') then Result := tkFunctions else
    if KeyComp('ActivateTrap') then Result := tkFunctions else
      if KeyComp('WaitSegment') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func137: TtkTokenKind;
begin
  if KeyComp('ConsoleFloat') then Result := tkFunctions else
    if KeyComp('QObjSeeUnit') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func138: TtkTokenKind;
begin
  if KeyComp('ResetTarget') then Result := tkFunctions else
    if KeyComp('CopyStats') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func140: TtkTokenKind;
begin
  if KeyComp('LeaveToZone') then Result := tkFunctions else
    if KeyComp('GetBSZValue') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func141: TtkTokenKind;
begin
  if KeyComp('AddRoundToArea') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func142: TtkTokenKind;
begin
  if KeyComp('SetDiplomacy') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func143: TtkTokenKind;
begin
  if KeyComp('ShowCredits') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func144: TtkTokenKind;
begin
  if KeyComp('IsUnitBlocked') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func145: TtkTokenKind;
begin
  if KeyComp('MoveToObject') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func147: TtkTokenKind;
begin
  if KeyComp('GetObjectByName') then Result := tkFunctions else
    if KeyComp('GetFutureX') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func148: TtkTokenKind;
begin
  if KeyComp('GetFutureY') then Result := tkFunctions else
    if KeyComp('UMAggression') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func149: TtkTokenKind;
begin
  if KeyComp('GSSetVarMax') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func150: TtkTokenKind;
begin
  if KeyComp('PlayAnimation') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func151: TtkTokenKind;
begin
  if KeyComp('GroupCross') then Result := tkFunctions else
    if KeyComp('GetWorldTime') then Result := tkFunctions else
      if KeyComp('DeleteLightning') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func152: TtkTokenKind;
begin
  if KeyComp('QObjKillUnit') then Result := tkFunctions else
    if KeyComp('CreateLightning') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func153: TtkTokenKind;
begin
  if KeyComp('IsCameraPlaying') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func154: TtkTokenKind;
begin
  if KeyComp('GiveStrength') then Result := tkFunctions else
    if KeyComp('SetSunLight') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func155: TtkTokenKind;
begin
  if KeyComp('UMPatrolClear') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func156: TtkTokenKind;
begin
  if KeyComp('AttachParticles') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func157: TtkTokenKind;
begin
  if KeyComp('WorldScript') then Result := tkKey else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func158: TtkTokenKind;
begin
  if KeyComp('RemoveParty') then Result := tkFunctions else
    if KeyComp('FixWorldTime') then Result := tkFunctions else
      if KeyComp('GiveIntelligence') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func159: TtkTokenKind;
begin
  if KeyComp('GetLeverState') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func162: TtkTokenKind;
begin
  if KeyComp('DeleteFXSource') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func163: TtkTokenKind;
begin
  if KeyComp('CreateFXSource') then Result := tkFunctions else
    if KeyComp('GetMercsNumber') then Result := tkFunctions else
      if KeyComp('SleepUntilIdle') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func164: TtkTokenKind;
begin
  if KeyComp('MoveToPoint') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func165: TtkTokenKind;
begin
  if KeyComp('QObjKillGroup') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func167: TtkTokenKind;
begin
  if KeyComp('SetWaterLevel') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func168: TtkTokenKind;
begin
  if KeyComp('UnitInSquare') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func170: TtkTokenKind;
begin
  if KeyComp('RecalcMercBriefings') then Result := tkFunctions else
    if KeyComp('IsUnitVisible') then Result := tkFunctions else
      if KeyComp('ConsoleString') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func171: TtkTokenKind;
begin
  if KeyComp('CastSpellUnit') then Result := tkFunctions else
    if KeyComp('IsEqualString') then Result := tkFunctions else
      if KeyComp('QuestComplete') then Result := tkFunctions else
        if KeyComp('GiveUnitSpell') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func172: TtkTokenKind;
begin
  if KeyComp('GiveQuestItem') then Result := tkFunctions else
    if KeyComp('RunWorldTime') then Result := tkFunctions else
      if KeyComp('WaitEndAnimation') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func173: TtkTokenKind;
begin
  if KeyComp('GiveDexterity') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func174: TtkTokenKind;
begin
  if KeyComp('StartAnimation') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func175: TtkTokenKind;
begin
  if KeyComp('UMSuspection') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func177: TtkTokenKind;
begin
  if KeyComp('EraseQuestItem') then Result := tkFunctions else
    if KeyComp('IsPlayerInDanger') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func180: TtkTokenKind;
begin
  if KeyComp('RedeployParty') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func181: TtkTokenKind;
begin
  if KeyComp('CastSpellPoint') then Result := tkFunctions else
    if KeyComp('DeletePointLight') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func182: TtkTokenKind;
begin
  if KeyComp('CreatePointLight') then Result := tkFunctions else
    if KeyComp('IsUnitInWater') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func185: TtkTokenKind;
begin
  if KeyComp('MovePointLight') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func188: TtkTokenKind;
begin
  if KeyComp('AddUnitToParty') then Result := tkFunctions else
    if KeyComp('UMCorpseWatcher') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func189: TtkTokenKind;
begin
  if KeyComp('SetBackgroudColor') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func192: TtkTokenKind;
begin
  if KeyComp('GetPlayerUnits') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func194: TtkTokenKind;
begin
  if KeyComp('GetUnitOfPlayer') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func195: TtkTokenKind;
begin
  if KeyComp('AddUnitToServer') then Result := tkFunctions else
    if KeyComp('SendStringEvent') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func199: TtkTokenKind;
begin
  if KeyComp('UMPatrolAddPoint') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func202: TtkTokenKind;
begin
  if KeyComp('SetCameraPosition') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func203: TtkTokenKind;
begin
  if KeyComp('DistanceUnitUnit') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func204: TtkTokenKind;
begin
  if KeyComp('IsPlayerInSafety') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func207: TtkTokenKind;
begin
  if KeyComp('RemoveQuestItem') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func209: TtkTokenKind;
begin
  if KeyComp('SwitchLeverState') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func213: TtkTokenKind;
begin
  if KeyComp('DistanceUnitPoint') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func216: TtkTokenKind;
begin
  if KeyComp('DeleteParticleSource') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func217: TtkTokenKind;
begin
  if KeyComp('CreateParticleSource') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func218: TtkTokenKind;
begin
  if KeyComp('AttachParticleSource') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func220: TtkTokenKind;
begin
  if KeyComp('MoveParticleSource') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func222: TtkTokenKind;
begin
  if KeyComp('SetSpellAggression') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func223: TtkTokenKind;
begin
  if KeyComp('SetCurrentParty') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func225: TtkTokenKind;
begin
  if KeyComp('SetCameraOrientation') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func231: TtkTokenKind;
begin
  if KeyComp('SetDirectionToObject') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func232: TtkTokenKind;
begin
  if KeyComp('AddUnitUnderControl') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func233: TtkTokenKind;
begin
  if KeyComp('GetLootItemsCount') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func235: TtkTokenKind;
begin
  if KeyComp('SetPlayerAggression') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func236: TtkTokenKind;
begin
  if KeyComp('GiveUnitQuestItem') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func238: TtkTokenKind;
begin
  if KeyComp('SwitchLeverStateEx') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func252: TtkTokenKind;
begin
  if KeyComp('UMPatrolAddPointLook') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func268: TtkTokenKind;
begin
  if KeyComp('SetParticleSourceSize') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func272: TtkTokenKind;
begin
  if KeyComp('CreateRandomizedFXSource') then Result := tkFunctions else
    if KeyComp('RemoveObjectFromServer') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func274: TtkTokenKind;
begin
  if KeyComp('RemoveUnitFromParty') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func281: TtkTokenKind;
begin
  if KeyComp('RemoveUnitFromServer') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.Func291: TtkTokenKind;
begin
  if KeyComp('RemoveUnitFromControl') then Result := tkFunctions else Result := tkIdentifier;
end;

function TSynEIScriptSyn.AltFunc: TtkTokenKind;
begin
  Result := tkIdentifier;
end;

function TSynEIScriptSyn.IdentKind(MayBe: PChar): TtkTokenKind;
var
  HashKey: Integer;
begin
  fToIdent := MayBe;
  HashKey := KeyHash(MayBe);
  if HashKey <= MaxKey then
    Result := fIdentFuncTable[HashKey]
  else
    Result := tkIdentifier;
end;

procedure TSynEIScriptSyn.MakeMethodTables;
var
  I: Char;
begin
  for I := #0 to #255 do
    case I of
      #0: fProcTable[I] := NullProc;
      #10: fProcTable[I] := LFProc;
      #13: fProcTable[I] := CRProc;
      '/': fProcTable[I] := CommentProcOpenProc;
      '"': fProcTable[I] := StringValuesProcOpenProc;
      'A'..'Z', 'a'..'z', '_': fProcTable[I] := IdentProc;
      '0'..'9', '.': fProcTable[I] := NumberProc;
      '(', ')': fProcTable[I] := SkobkiProc;
    else
      fProcTable[I] := UnknownProc;
    end;
end;

procedure TSynEIScriptSyn.NullProc;
begin
  fTokenID := tkNull;
end;

procedure TSynEIScriptSyn.CRProc;
begin
  fTokenID := tkUnknown;
  inc(Run);
  if fLine[Run] = #10 then
    inc(Run);
end;

procedure TSynEIScriptSyn.LFProc;
begin
  fTokenID := tkUnknown;
  inc(Run);
end;

procedure TSynEIScriptSyn.CommentProcOpenProc;
begin
  Inc(Run);
  if (fLine[Run] = '/') then
  begin
    fRange := rsCommentProc;
    CommentProcProc;
    fTokenID := tkComment;
  end
  else
    fTokenID := tkIdentifier;
end;

procedure TSynEIScriptSyn.CommentProcProc;
begin
  fTokenID := tkComment;
  repeat
    {if  then
    begin
      Inc(Run, 0);
      fRange := rsUnKnown;
      Break;
    end;}
    if not (fLine[Run] in [#0, #10, #13]) then
      Inc(Run);
  until fLine[Run] in [#0, #10, #13];
end;

procedure TSynEIScriptSyn.StringValuesProcOpenProc;
begin
  Inc(Run);
  fRange := rsStringValuesProc;
  StringValuesProcProc;
  fTokenID := tkStringValues;
end;

procedure TSynEIScriptSyn.StringValuesProcProc;
begin
  fTokenID := tkStringValues;
  repeat
    if (fLine[Run] = '"') then
    begin
      Inc(Run, 1);
      fRange := rsUnKnown;
      Break;
    end;
    if not (fLine[Run] in [#0, #10, #13]) then
      Inc(Run);
  until fLine[Run] in [#0, #10, #13];
end;

constructor TSynEIScriptSyn.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fCommentAttri := TSynHighLighterAttributes.Create(SYNS_AttrComment);
  fCommentAttri.Style := [fsItalic];
  fCommentAttri.Foreground := clNavy;
  AddAttribute(fCommentAttri);

  fDateTypesAttri := TSynHighLighterAttributes.Create(SYNS_AttrDateTypes);
  fDateTypesAttri.Style := [fsBold];
  fDateTypesAttri.Foreground := clMaroon;
  AddAttribute(fDateTypesAttri);

  fFunctionsAttri := TSynHighLighterAttributes.Create(SYNS_AttrFunctions);
  fFunctionsAttri.Style := [fsBold];
  fFunctionsAttri.Foreground := clBlue ;
  AddAttribute(fFunctionsAttri);

  fIdentifierAttri := TSynHighLighterAttributes.Create(SYNS_AttrIdentifier);
  AddAttribute(fIdentifierAttri);

  fKeyAttri := TSynHighLighterAttributes.Create(SYNS_AttrReservedWord);
  fKeyAttri.Style := [fsBold];
  AddAttribute(fKeyAttri);

  fNumberAttri := TSynHighLighterAttributes.Create(SYNS_AttrNumber);
  fNumberAttri.Style := [fsBold];
  fNumberAttri.Foreground := clFuchsia;
  AddAttribute(fNumberAttri);

  fSkobkiAttri := TSynHighLighterAttributes.Create(SYNS_AttrSkobki);
  fSkobkiAttri.Style := [fsBold];
  fSkobkiAttri.Foreground := clRed;
  AddAttribute(fSkobkiAttri);

  fStringValuesAttri := TSynHighLighterAttributes.Create(SYNS_AttrStringValues);
  fStringValuesAttri.Style := [fsBold];
  fStringValuesAttri.Foreground := clGreen;
  AddAttribute(fStringValuesAttri);

  SetAttributesOnChange(DefHighlightChange);
  InitIdent;
  MakeMethodTables;
  fDefaultFilter := SYNS_FilterEvilIslandsscript;
  fRange := rsUnknown;
end;

procedure TSynEIScriptSyn.SetLine(NewValue: String; LineNumber: Integer);
begin
  fLine := PChar(NewValue);
  Run := 0;
  fLineNumber := LineNumber;
  Next;
end;

procedure TSynEIScriptSyn.IdentProc;
begin
  fTokenID := IdentKind((fLine + Run));
  inc(Run, fStringLen);
  //while Identifiers[fLine[Run]] do
  while FLine[Run] in ['A'..'Z', 'a'..'z', '_', '0'..'9'] do
    Inc(Run);
end;

procedure TSynEIScriptSyn.NumberProc;
begin
  Inc(Run);
  fTokenID := tkNumber;
  while FLine[Run] in ['0'..'9', '.'] do
  begin
    Inc(Run);
  end;
end;

procedure TSynEIScriptSyn.SkobkiProc;
begin
  Inc(Run);
  fTokenID := tkSkobki;
  while FLine[Run] in ['(', ')'] do
  begin
    Inc(Run);
  end;
end;

procedure TSynEIScriptSyn.UnknownProc;
begin
{$IFDEF SYN_MBCSSUPPORT}
  if FLine[Run] in LeadBytes then
    Inc(Run,2)
  else
{$ENDIF}
  inc(Run);
  fTokenID := tkUnknown;
end;

procedure TSynEIScriptSyn.Next;
begin
  fTokenPos := Run;
  //case fRange of
  //else
    begin
      fRange := rsUnknown;
      fProcTable[fLine[Run]];
    end;
  //end;
end;

function TSynEIScriptSyn.GetDefaultAttribute(Index: integer): TSynHighLighterAttributes;
begin
  case Index of
    SYN_ATTR_COMMENT    : Result := fCommentAttri;
    SYN_ATTR_IDENTIFIER : Result := fIdentifierAttri;
    SYN_ATTR_KEYWORD    : Result := fKeyAttri;
  else
    Result := nil;
  end;
end;

function TSynEIScriptSyn.GetEol: Boolean;
begin
  Result := fTokenID = tkNull;
end;

function TSynEIScriptSyn.GetKeyWords: string;
begin
  Result := 
    'ActivateTrap,Add,AddLoot,AddMob,AddObject,AddRectToArea,AddRoundToAre' +
    'a,AddUnitToParty,AddUnitToServer,AddUnitUnderControl,AlarmPosX,AlarmPo' +
    'sY,AlarmTime,Any,AttachParticles,AttachParticleSource,Attack,BlockUnit' +
    ',Cast,CastSpellPoint,CastSpellUnit,ConsoleFloat,ConsoleString,CopyItem' +
    's,CopyLoot,CopyStats,Crawl,CreateFX,CreateFXSource,CreateLightning,Cre' +
    'ateParticleSource,CreateParty,CreatePointLight,CreateRandomizedFXSourc' +
    'e,DeclareScript,DeleteArea,DeleteFXSource,DeleteLightning,DeletePartic' +
    'leSource,DeletePointLight,DistanceUnitPoint,DistanceUnitUnit,Div,Enabl' +
    'eLever,EraseQuestItem,Every,FixItems,FixWorldTime,float,Follow,For,Get' +
    'AIClass,GetBSZValue,GetDiplomacy,GetFutureX,GetFutureY,GetLeader,GetLe' +
    'verState,GetLootItemsCount,GetMercsNumber,GetMoney,GetObject,GetObject' +
    'ByID,GetObjectByName,GetObjectID,GetPlayer,GetPlayerUnits,GetUnitOfPla' +
    'yer,GetWorldTime,GetX,GetY,GetZ,GetZValue,GiveDexterity,GiveIntelligen' +
    'ce,GiveItem,GiveMoney,GiveQuestItem,GiveSkill,GiveStrength,GiveUnitQue' +
    'stItem,GiveUnitSpell,GlobalVars,GodMode,group,GroupAdd,GroupCross,Grou' +
    'pHas,GroupSee,GroupSize,GroupSub,GSDelVar,GSGetVar,GSSetVar,GSSetVarMa' +
    'x,Guard,HaveItem,HideObject,HP,Idle,if,InflictDamage,InvokeAlarm,IsAla' +
    'rm,IsAlive,IsCameraPlaying,IsDead,IsEnemy,IsEqual,IsEqualString,IsGrea' +
    'ter,IsInArea,IsInSquare,IsLess,IsNight,IsPlayerInDanger,IsPlayerInSafe' +
    'ty,IsUnitBlocked,IsUnitInWater,IsUnitVisible,KillScript,KillUnit,Leave' +
    'ToZone,Lie,Mana,MaxHP,MaxMana,MoveParticleSource,MovePointLight,MoveTo' +
    'Object,MoveToPoint,Mul,Not,NULL,object,PlayAnimation,PlayCamera,Player' +
    'See,PlayFX,PlayMovie,PlayMusic,Qfinish,QObjArea,QObjGetItem,QObjKillGr' +
    'oup,QObjKillUnit,QObjSeeObject,QObjSeeUnit,QObjUse,QStart,QuestComplet' +
    'e,Random,RecalcMercBriefings,RedeployParty,RemoveObject,RemoveObjectFr' +
    'omServer,RemoveParty,RemoveQuestItem,RemoveUnitFromControl,RemoveUnitF' +
    'romParty,RemoveUnitFromServer,ResetTarget,Rest,RotateTo,Run,RunWorldTi' +
    'me,Script,SendEvent,SendStringEvent,Sentry,SetBackgroudColor,SetCamera' +
    'Orientation,SetCameraPosition,SetCP,SetCPFast,SetCurrentParty,SetDiplo' +
    'macy,SetDirectionToObject,SetEnemy,SetParticleSourceSize,SetPlayer,Set' +
    'PlayerAggression,SetScience,SetSpellAggression,SetSunLight,SetWaterLev' +
    'el,SetWind,ShowBitmap,ShowCredits,Sleep,SleepUntil,SleepUntilIdle,Stan' +
    'dt,StartAnimation,string,Sub,Sum,SwitchLeverState,SwitchLeverStateEx,t' +
    'hen,UMAg,UMAggression,UMClear,UMCorpseWatcher,UMFear,UMFollow,UMGuard,' +
    'UMGuardEx,UMPatrol,UMPatrolAddPoint,UMPatrolAddPointLook,UMPatrolClear' +
    ',UMPlayer,UMRevenge,UMSentry,UMStandard,UMSuspection,UnitInSquare,Unit' +
    'See,WaitEndAnimation,WaitSegment,Walk,WasLooted,WorldScript';
end;

function TSynEIScriptSyn.GetToken: String;
var
  Len: LongInt;
begin
  Len := Run - fTokenPos;
  SetString(Result, (FLine + fTokenPos), Len);
end;

function TSynEIScriptSyn.GetTokenID: TtkTokenKind;
begin
  Result := fTokenId;
end;

function TSynEIScriptSyn.GetTokenAttribute: TSynHighLighterAttributes;
begin
  case GetTokenID of
    tkComment: Result := fCommentAttri;
    tkDateTypes: Result := fDateTypesAttri;
    tkFunctions: Result := fFunctionsAttri;
    tkIdentifier: Result := fIdentifierAttri;
    tkKey: Result := fKeyAttri;
    tkNumber: Result := fNumberAttri;
    tkSkobki: Result := fSkobkiAttri;
    tkStringValues: Result := fStringValuesAttri;
    tkUnknown: Result := fIdentifierAttri;
  else
    Result := nil;
  end;
end;

function TSynEIScriptSyn.GetTokenKind: integer;
begin
  Result := Ord(fTokenId);
end;

function TSynEIScriptSyn.GetTokenPos: Integer;
begin
  Result := fTokenPos;
end;

function TSynEIScriptSyn.GetIdentChars: TSynIdentChars;
begin
  Result := ['_', 'a'..'z', 'A'..'Z'];
end;

function TSynEIScriptSyn.GetSampleSource: string;
begin
  Result := 'Sample source for: '#13#10 +
            'Evil Islands Script highlighter';
end;

function TSynEIScriptSyn.IsFilterStored: Boolean;
begin
  Result := fDefaultFilter <> SYNS_FilterEvilIslandsscript;
end;

{$IFNDEF SYN_CPPB_1} class {$ENDIF}
function TSynEIScriptSyn.GetLanguageName: string;
begin
  Result := SYNS_LangEvilIslandsscript;
end;

procedure TSynEIScriptSyn.ResetRange;
begin
  fRange := rsUnknown;
end;

procedure TSynEIScriptSyn.SetRange(Value: Pointer);
begin
  fRange := TRangeState(Value);
end;

function TSynEIScriptSyn.GetRange: Pointer;
begin
  Result := Pointer(fRange);
end;

initialization
  MakeIdentTable;
{$IFNDEF SYN_CPPB_1}
  RegisterPlaceableHighlighter(TSynEIScriptSyn);
{$ENDIF}
end.
