///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------


#pragma hdrstop

#include "initer.h"
#include "forms.hpp"
#include "MainForm.h"
#include "MySys.hpp"
#include "math.h"


//---------------------------------------------------------------------------

#pragma package(smart_init)

//-,     ini
//[Main]
bool UseTMobThreads;     //      TMob;
Integer SaveAttempts;    //     .
String WorkPath;         // .
bool MakeAutoBackups;    //  ...
String SearchStr;        //  ...
String RepStr;           //  ...
bool MakeReplace;     //    \.
//[MassChangeOpts]
bool MC_KR_Param_Name1CB_ini;
bool MC_KR_Param_Name2CB_ini;
bool MC_KR_Param_ScriptVariableNameCB_ini;
bool MC_KR_Param_Model3dCB_ini;
bool MC_KR_Param_FirstTextureCB_ini;
bool MC_KR_Param_SecondTextureCB_ini;
bool MC_KR_Param_PlayerNumberCB_ini;
bool MC_KR_Coords_PramouglCB_ini;
bool MC_KR_Coords_KrugCB_ini;
bool MC_KR_Type_UnitCB_ini;
bool MC_KR_Type_ObjectCB_ini;
bool MC_KR_Type_LeverCB_ini;
bool MC_KR_Type_TrapCB_ini;
bool MC_KR_Type_FlameCB_ini;
bool MC_KR_Type_Particle1CB_ini;
bool MC_KR_Type_Particle2CB_ini;
bool MC_KR_Type_Particle3CB_ini;
bool MC_AS_Obj_DelRB_ini;
bool MC_AS_Obj_CopyRB_ini;
bool MC_AS_Obj_MoveRB_ini;
bool MC_AS_Obj_ReplaceCB_ini;
bool MC_AS_Params_Name1CB_ini;
bool MC_AS_Params_Name2CB_ini;
bool MC_AS_Params_ScriptVariableNameCB_ini;
bool MC_AS_Params_Model3dCB_ini;
bool MC_AS_Params_FirstTextureCB_ini;
bool MC_AS_Params_SecondTextureCB_ini;
bool MC_AS_Params_OffsetCB_ini;
bool MC_AS_Params_PlayerNumberCB_ini;
bool MC_AS_Obj_OnlyParamsRB_ini;
String MC_KR_Param_Name1Ed_ini;
String MC_KR_Param_Name2Ed_ini;
String MC_KR_Param_ScriptVariableNameEd_ini;
String MC_KR_Param_Model3dEd_ini;
String MC_KR_Param_FirstTextureEd_ini;
String MC_KR_Param_SecondTextureEd_ini;
String MC_KR_Param_PlayerNumberEd_ini;
String MC_KR_Coords_Pramougl_X1Ed_ini;
String MC_KR_Coords_Pramougl_Y1Ed_ini;
String MC_KR_Coords_Pramougl_X2Ed_ini;
String MC_KR_Coords_Pramougl_Y2Ed_ini;
String MC_KR_Coords_Krug_XEd_ini;
String MC_KR_Coords_Krug_YEd_ini;
String MC_KR_Coords_Krug_RadEd_ini;
String MC_AS_Obj_TargetMobEd_ini;
String MC_AS_Params_Name1Ed_ini;
String MC_AS_Params_Name2Ed_ini;
String MC_AS_Params_ScriptVariableNameEd_ini;
String MC_AS_Params_Model3dEd_ini;
String MC_AS_Params_FirstTextureEd_ini;
String MC_AS_Params_SecondTextureEd_ini;
String MC_AS_Params_OffsetXEd_ini;
String MC_AS_Params_OffsetYEd_ini;
String MC_AS_Params_PlayerNumberEd_ini;

//  ...;
TVerInfoTxtFormat *VitInfo;
String ProgPath, MobFileName;
TMob *MobInMem1, *TargetMob;
bool MobLoaded, SearchDialCanceled, MakeSLBlockInterf, MobModified;
TIniFile *MainIni;

void AppInit()  //  RUN
{
  // -       :).
  //      .

  // ...
  MobLoaded = false;
  MobModified = false;
  MobFileName = "";
  MakeSLBlockInterf = true;

  //   ...
  VitInfo = new TVerInfoTxtFormat;
  VitInfo->Ver1 = MobSurgeon_Ver1;
  VitInfo->Ver2 = MobSurgeon_Ver2;
  VitInfo->Ver3 = MobSurgeon_Ver3;
  VitInfo->Ver4 = MobSurgeon_Ver4;
  VitInfo->Status = MobSurgeon_Status;
  VitInfo->RCNum = MobSurgeon_RCNum;

  //   ...
  ProgPath = ExtractFilePath(Application->ExeName);
  //ShowMessage(ProgPath);

  //   ini...
  MainIni = new TIniFile(ProgPath+IniFileName);  //      ...
  //      - .
  if (FileExists(ProgPath+IniFileName) == false)
  {
    SetStandProgSetts();
    SaveProgSetts();
  }
  else
  {
    //   -   :).
    LoadProgSetts();
  };

  //   .
  MobInMem1 = new TMob;

};

void AppDeInit()   //  RUN
{
  //   -      
  //-     .
  SaveProgSetts();  //     .

  // 
  delete VitInfo;
  delete MobInMem1;
  delete MainIni;
};

void SetStandProgSetts()
//      .
{
  //   -     ...
  //[Main]
  UseTMobThreads = StandUseTMobThreads;
  SaveAttempts = StandSaveAttempts;
  WorkPath = ProgPath;
  MakeAutoBackups = StandMakeAutoBackups;
  SearchStr = StandSearchStr;
  RepStr = StandRepStr;
  MakeReplace = StandMakeReplace;
  //[MassChangeOpts]
  MC_KR_Param_Name1CB_ini = Stand_MC_KR_Param_Name1CB_ini;
  MC_KR_Param_Name2CB_ini = Stand_MC_KR_Param_Name2CB_ini;
  MC_KR_Param_ScriptVariableNameCB_ini = Stand_MC_KR_Param_ScriptVariableNameCB_ini;
  MC_KR_Param_Model3dCB_ini = Stand_MC_KR_Param_Model3dCB_ini;
  MC_KR_Param_FirstTextureCB_ini = Stand_MC_KR_Param_FirstTextureCB_ini;
  MC_KR_Param_SecondTextureCB_ini = Stand_MC_KR_Param_SecondTextureCB_ini;
  MC_KR_Coords_PramouglCB_ini = Stand_MC_KR_Coords_PramouglCB_ini;
  MC_KR_Coords_KrugCB_ini = Stand_MC_KR_Coords_KrugCB_ini;
  MC_KR_Type_UnitCB_ini = Stand_MC_KR_Type_UnitCB_ini;
  MC_KR_Type_ObjectCB_ini = Stand_MC_KR_Type_ObjectCB_ini;
  MC_KR_Type_LeverCB_ini = Stand_MC_KR_Type_LeverCB_ini;
  MC_KR_Type_TrapCB_ini = Stand_MC_KR_Type_TrapCB_ini;
  MC_KR_Type_FlameCB_ini = Stand_MC_KR_Type_FlameCB_ini;
  MC_KR_Type_Particle1CB_ini = Stand_MC_KR_Type_Particle1CB_ini;
  MC_KR_Type_Particle2CB_ini = Stand_MC_KR_Type_Particle2CB_ini;
  MC_KR_Type_Particle3CB_ini = Stand_MC_KR_Type_Particle3CB_ini;
  MC_AS_Obj_DelRB_ini = Stand_MC_AS_Obj_DelRB_ini;
  MC_AS_Obj_CopyRB_ini = Stand_MC_AS_Obj_CopyRB_ini;
  MC_AS_Obj_MoveRB_ini = Stand_MC_AS_Obj_MoveRB_ini;
  MC_AS_Obj_ReplaceCB_ini = Stand_MC_AS_Obj_ReplaceCB_ini;
  MC_AS_Params_Name1CB_ini = Stand_MC_AS_Params_Name1CB_ini;
  MC_AS_Params_Name2CB_ini = Stand_MC_AS_Params_Name2CB_ini;
  MC_AS_Params_ScriptVariableNameCB_ini = Stand_MC_AS_Params_ScriptVariableNameCB_ini;
  MC_AS_Params_Model3dCB_ini = Stand_MC_AS_Params_Model3dCB_ini;
  MC_AS_Params_FirstTextureCB_ini = Stand_MC_AS_Params_FirstTextureCB_ini;
  MC_AS_Params_SecondTextureCB_ini = Stand_MC_AS_Params_SecondTextureCB_ini;
  MC_AS_Params_OffsetCB_ini = Stand_MC_AS_Params_OffsetCB_ini;
  MC_AS_Obj_OnlyParamsRB_ini = Stand_MC_AS_Obj_OnlyParamsRB_ini;
  MC_KR_Param_Name1Ed_ini = Stand_MC_KR_Param_Name1Ed_ini;
  MC_KR_Param_Name2Ed_ini = Stand_MC_KR_Param_Name2Ed_ini;
  MC_KR_Param_ScriptVariableNameEd_ini = Stand_MC_KR_Param_ScriptVariableNameEd_ini;
  MC_KR_Param_Model3dEd_ini = Stand_MC_KR_Param_Model3dEd_ini;
  MC_KR_Param_FirstTextureEd_ini = Stand_MC_KR_Param_FirstTextureEd_ini;
  MC_KR_Param_SecondTextureEd_ini = Stand_MC_KR_Param_SecondTextureEd_ini;
  MC_KR_Coords_Pramougl_X1Ed_ini = Stand_MC_KR_Coords_Pramougl_X1Ed_ini;
  MC_KR_Coords_Pramougl_Y1Ed_ini = Stand_MC_KR_Coords_Pramougl_Y1Ed_ini;
  MC_KR_Coords_Pramougl_X2Ed_ini = Stand_MC_KR_Coords_Pramougl_X2Ed_ini;
  MC_KR_Coords_Pramougl_Y2Ed_ini = Stand_MC_KR_Coords_Pramougl_Y2Ed_ini;
  MC_KR_Coords_Krug_XEd_ini = Stand_MC_KR_Coords_Krug_XEd_ini;
  MC_KR_Coords_Krug_YEd_ini = Stand_MC_KR_Coords_Krug_YEd_ini;
  MC_KR_Coords_Krug_RadEd_ini = Stand_MC_KR_Coords_Krug_RadEd_ini;
  MC_AS_Obj_TargetMobEd_ini = Stand_MC_AS_Obj_TargetMobEd_ini;
  MC_AS_Params_Name1Ed_ini = Stand_MC_AS_Params_Name1Ed_ini;
  MC_AS_Params_Name2Ed_ini = Stand_MC_AS_Params_Name2Ed_ini;
  MC_AS_Params_ScriptVariableNameEd_ini = Stand_MC_AS_Params_ScriptVariableNameEd_ini;
  MC_AS_Params_Model3dEd_ini = Stand_MC_AS_Params_Model3dEd_ini;
  MC_AS_Params_FirstTextureEd_ini = Stand_MC_AS_Params_FirstTextureEd_ini;
  MC_AS_Params_SecondTextureEd_ini = Stand_MC_AS_Params_SecondTextureEd_ini;
  MC_AS_Params_OffsetXEd_ini = Stand_MC_AS_Params_OffsetXEd_ini;
  MC_AS_Params_OffsetYEd_ini = Stand_MC_AS_Params_OffsetYEd_ini;
  
};

void LoadProgSetts()
//     .
{
  //    .
  Integer IniRealVer;
  IniRealVer = MainIni->ReadInteger("Main","IniFileVer",NULL);

  //   -       :).
  if (IniRealVer < IniFileVer)
  {
    //   .....  ...
    if (IniRealVer == 1)
    {
      MakeAutoBackups = StandMakeAutoBackups;
      MainIni->WriteBool("Main","MakeAutoBackups",MakeAutoBackups);

      MainIni->WriteInteger("Main","IniFileVer",2);
      IniRealVer = 2;
      MainIni->UpdateFile(); //    win9x.
    };

    if (IniRealVer == 2)
    {
      SearchStr = StandSearchStr;
      RepStr = StandRepStr;
      MakeReplace = StandMakeReplace;
      MainIni->WriteString("Main","SearchStr",SearchStr);
      MainIni->WriteString("Main","RepStr",RepStr);
      MainIni->WriteBool("Main","MakeReplace",MakeReplace);

      MainIni->WriteInteger("Main","IniFileVer",3);
      IniRealVer = 3;
      MainIni->UpdateFile(); //    win9x.
    };

    if (IniRealVer == 3)
    {
      //[MassChangeOpts]
      MC_KR_Param_Name1CB_ini = Stand_MC_KR_Param_Name1CB_ini;
      MC_KR_Param_Name2CB_ini = Stand_MC_KR_Param_Name2CB_ini;
      MC_KR_Param_ScriptVariableNameCB_ini = Stand_MC_KR_Param_ScriptVariableNameCB_ini;
      MC_KR_Param_Model3dCB_ini = Stand_MC_KR_Param_Model3dCB_ini;
      MC_KR_Param_FirstTextureCB_ini = Stand_MC_KR_Param_FirstTextureCB_ini;
      MC_KR_Param_SecondTextureCB_ini = Stand_MC_KR_Param_SecondTextureCB_ini;
      MC_KR_Coords_PramouglCB_ini = Stand_MC_KR_Coords_PramouglCB_ini;
      MC_KR_Coords_KrugCB_ini = Stand_MC_KR_Coords_KrugCB_ini;
      MC_KR_Type_UnitCB_ini = Stand_MC_KR_Type_UnitCB_ini;
      MC_KR_Type_ObjectCB_ini = Stand_MC_KR_Type_ObjectCB_ini;
      MC_KR_Type_LeverCB_ini = Stand_MC_KR_Type_LeverCB_ini;
      MC_KR_Type_TrapCB_ini = Stand_MC_KR_Type_TrapCB_ini;
      MC_KR_Type_FlameCB_ini = Stand_MC_KR_Type_FlameCB_ini;
      MC_KR_Type_Particle1CB_ini = Stand_MC_KR_Type_Particle1CB_ini;
      MC_KR_Type_Particle2CB_ini = Stand_MC_KR_Type_Particle2CB_ini;
      MC_KR_Type_Particle3CB_ini = Stand_MC_KR_Type_Particle3CB_ini;
      MC_AS_Obj_DelRB_ini = Stand_MC_AS_Obj_DelRB_ini;
      MC_AS_Obj_CopyRB_ini = Stand_MC_AS_Obj_CopyRB_ini;
      MC_AS_Obj_MoveRB_ini = Stand_MC_AS_Obj_MoveRB_ini;
      MC_AS_Obj_ReplaceCB_ini = Stand_MC_AS_Obj_ReplaceCB_ini;
      MC_AS_Params_Name1CB_ini = Stand_MC_AS_Params_Name1CB_ini;
      MC_AS_Params_Name2CB_ini = Stand_MC_AS_Params_Name2CB_ini;
      MC_AS_Params_ScriptVariableNameCB_ini = Stand_MC_AS_Params_ScriptVariableNameCB_ini;
      MC_AS_Params_Model3dCB_ini = Stand_MC_AS_Params_Model3dCB_ini;
      MC_AS_Params_FirstTextureCB_ini = Stand_MC_AS_Params_FirstTextureCB_ini;
      MC_AS_Params_SecondTextureCB_ini = Stand_MC_AS_Params_SecondTextureCB_ini;
      MC_AS_Params_OffsetCB_ini = Stand_MC_AS_Params_OffsetCB_ini;
      MC_KR_Param_Name1Ed_ini = Stand_MC_KR_Param_Name1Ed_ini;
      MC_KR_Param_Name2Ed_ini = Stand_MC_KR_Param_Name2Ed_ini;
      MC_KR_Param_ScriptVariableNameEd_ini = Stand_MC_KR_Param_ScriptVariableNameEd_ini;
      MC_KR_Param_Model3dEd_ini = Stand_MC_KR_Param_Model3dEd_ini;
      MC_KR_Param_FirstTextureEd_ini = Stand_MC_KR_Param_FirstTextureEd_ini;
      MC_KR_Param_SecondTextureEd_ini = Stand_MC_KR_Param_SecondTextureEd_ini;
      MC_KR_Coords_Pramougl_X1Ed_ini = Stand_MC_KR_Coords_Pramougl_X1Ed_ini;
      MC_KR_Coords_Pramougl_Y1Ed_ini = Stand_MC_KR_Coords_Pramougl_Y1Ed_ini;
      MC_KR_Coords_Pramougl_X2Ed_ini = Stand_MC_KR_Coords_Pramougl_X2Ed_ini;
      MC_KR_Coords_Pramougl_Y2Ed_ini = Stand_MC_KR_Coords_Pramougl_Y2Ed_ini;
      MC_KR_Coords_Krug_XEd_ini = Stand_MC_KR_Coords_Krug_XEd_ini;
      MC_KR_Coords_Krug_YEd_ini = Stand_MC_KR_Coords_Krug_YEd_ini;
      MC_KR_Coords_Krug_RadEd_ini = Stand_MC_KR_Coords_Krug_RadEd_ini;
      MC_AS_Obj_TargetMobEd_ini = Stand_MC_AS_Obj_TargetMobEd_ini;
      MC_AS_Params_Name1Ed_ini = Stand_MC_AS_Params_Name1Ed_ini;
      MC_AS_Params_Name2Ed_ini = Stand_MC_AS_Params_Name2Ed_ini;
      MC_AS_Params_ScriptVariableNameEd_ini = Stand_MC_AS_Params_ScriptVariableNameEd_ini;
      MC_AS_Params_Model3dEd_ini = Stand_MC_AS_Params_Model3dEd_ini;
      MC_AS_Params_FirstTextureEd_ini = Stand_MC_AS_Params_FirstTextureEd_ini;
      MC_AS_Params_SecondTextureEd_ini = Stand_MC_AS_Params_SecondTextureEd_ini;
      MC_AS_Params_OffsetXEd_ini = Stand_MC_AS_Params_OffsetXEd_ini;
      MC_AS_Params_OffsetYEd_ini = Stand_MC_AS_Params_OffsetYEd_ini;

      MainIni->WriteBool("MassChangeOpts","MC_KR_Param_Name1CB_ini",MC_KR_Param_Name1CB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Param_Name2CB_ini",MC_KR_Param_Name2CB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Param_ScriptVariableNameCB_ini",MC_KR_Param_ScriptVariableNameCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Param_Model3dCB_ini",MC_KR_Param_Model3dCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Param_FirstTextureCB_ini",MC_KR_Param_FirstTextureCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Param_SecondTextureCB_ini",MC_KR_Param_SecondTextureCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Coords_PramouglCB_ini",MC_KR_Coords_PramouglCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Coords_KrugCB_ini",MC_KR_Coords_KrugCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Type_UnitCB_ini",MC_KR_Type_UnitCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Type_ObjectCB_ini",MC_KR_Type_ObjectCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Type_LeverCB_ini",MC_KR_Type_LeverCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Type_TrapCB_ini",MC_KR_Type_TrapCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Type_FlameCB_ini",MC_KR_Type_FlameCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Type_Particle1CB_ini",MC_KR_Type_Particle1CB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Type_Particle2CB_ini",MC_KR_Type_Particle2CB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_KR_Type_Particle3CB_ini",MC_KR_Type_Particle3CB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_DelRB_ini",MC_AS_Obj_DelRB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_CopyRB_ini",MC_AS_Obj_CopyRB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_MoveRB_ini",MC_AS_Obj_MoveRB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_ReplaceCB_ini",MC_AS_Obj_ReplaceCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Params_Name1CB_ini",MC_AS_Params_Name1CB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Params_Name2CB_ini",MC_AS_Params_Name2CB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Params_ScriptVariableNameCB_ini",MC_AS_Params_ScriptVariableNameCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Params_Model3dCB_ini",MC_AS_Params_Model3dCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Params_FirstTextureCB_ini",MC_AS_Params_FirstTextureCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Params_SecondTextureCB_ini",MC_AS_Params_SecondTextureCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Params_OffsetCB_ini",MC_AS_Params_OffsetCB_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Param_Name1Ed_ini",MC_KR_Param_Name1Ed_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Param_Name2Ed_ini",MC_KR_Param_Name2Ed_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Param_ScriptVariableNameEd_ini",MC_KR_Param_ScriptVariableNameEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Param_Model3dEd_ini",MC_KR_Param_Model3dEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Param_FirstTextureEd_ini",MC_KR_Param_FirstTextureEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Param_SecondTextureEd_ini",MC_KR_Param_SecondTextureEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Pramougl_X1Ed_ini",MC_KR_Coords_Pramougl_X1Ed_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Pramougl_Y1Ed_ini",MC_KR_Coords_Pramougl_Y1Ed_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Pramougl_X2Ed_ini",MC_KR_Coords_Pramougl_X2Ed_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Pramougl_Y2Ed_ini",MC_KR_Coords_Pramougl_Y2Ed_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Krug_XEd_ini",MC_KR_Coords_Krug_XEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Krug_YEd_ini",MC_KR_Coords_Krug_YEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Krug_RadEd_ini",MC_KR_Coords_Krug_RadEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Obj_TargetMobEd_ini",MC_AS_Obj_TargetMobEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Params_Name1Ed_ini",MC_AS_Params_Name1Ed_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Params_Name2Ed_ini",MC_AS_Params_Name2Ed_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Params_ScriptVariableNameEd_ini",MC_AS_Params_ScriptVariableNameEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Params_Model3dEd_ini",MC_AS_Params_Model3dEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Params_FirstTextureEd_ini",MC_AS_Params_FirstTextureEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Params_SecondTextureEd_ini",MC_AS_Params_SecondTextureEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Params_OffsetXEd_ini",MC_AS_Params_OffsetXEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Params_OffsetYEd_ini",MC_AS_Params_OffsetYEd_ini);
      
      MainIni->WriteInteger("Main","IniFileVer",4);
      IniRealVer = 4;
      MainIni->UpdateFile(); //    win9x.
    };

    if (IniRealVer == 4)
    {
      //[MassChangeOpts]
      MC_AS_Obj_OnlyParamsRB_ini = Stand_MC_AS_Obj_OnlyParamsRB_ini;

      MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_OnlyParamsRB_ini",MC_AS_Obj_OnlyParamsRB_ini);

      MainIni->WriteInteger("Main","IniFileVer",5);
      IniRealVer = 5;
      MainIni->UpdateFile(); //    win9x.
    };

    if (IniRealVer == 5)
    {
      //[MassChangeOpts]
      MC_KR_Param_PlayerNumberCB_ini = Stand_MC_KR_Param_PlayerNumberCB_ini;
      MC_AS_Params_PlayerNumberCB_ini = Stand_MC_AS_Params_PlayerNumberCB_ini;
      MC_KR_Param_PlayerNumberEd_ini = Stand_MC_KR_Param_PlayerNumberEd_ini;
      MC_AS_Params_PlayerNumberEd_ini = Stand_MC_AS_Params_PlayerNumberEd_ini;

      MainIni->WriteBool("MassChangeOpts","MC_KR_Param_PlayerNumberCB_ini",MC_KR_Param_PlayerNumberCB_ini);
      MainIni->WriteBool("MassChangeOpts","MC_AS_Params_PlayerNumberCB_ini",MC_AS_Params_PlayerNumberCB_ini);
      MainIni->WriteString("MassChangeOpts","MC_KR_Param_PlayerNumberEd_ini",MC_KR_Param_PlayerNumberEd_ini);
      MainIni->WriteString("MassChangeOpts","MC_AS_Params_PlayerNumberEd_ini",MC_AS_Params_PlayerNumberEd_ini);

      MainIni->WriteInteger("Main","IniFileVer",6);
      IniRealVer = 6;
      MainIni->UpdateFile(); //    win9x.
    };

  };

  // -   :).
  //[Main]
  UseTMobThreads = MainIni->ReadBool("Main","UseTMobThreads",NULL);
  SaveAttempts = MainIni->ReadInteger("Main","SaveAttempts",NULL);
  WorkPath = MainIni->ReadString("Main","WorkPath",NULL);
  MakeAutoBackups = MainIni->ReadBool("Main","MakeAutoBackups",NULL);
  SearchStr = MainIni->ReadString("Main","SearchStr",NULL);
  RepStr = MainIni->ReadString("Main","RepStr",NULL);
  MakeReplace = MainIni->ReadBool("Main","MakeReplace",NULL);
  //[MassChangeOpts]
  MC_KR_Param_Name1CB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Param_Name1CB_ini",NULL);
  MC_KR_Param_Name2CB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Param_Name2CB_ini",NULL);
  MC_KR_Param_ScriptVariableNameCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Param_ScriptVariableNameCB_ini",NULL);
  MC_KR_Param_Model3dCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Param_Model3dCB_ini",NULL);
  MC_KR_Param_FirstTextureCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Param_FirstTextureCB_ini",NULL);
  MC_KR_Param_SecondTextureCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Param_SecondTextureCB_ini",NULL);
  MC_KR_Param_PlayerNumberCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Param_PlayerNumberCB_ini",NULL);
  MC_KR_Coords_PramouglCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Coords_PramouglCB_ini",NULL);
  MC_KR_Coords_KrugCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Coords_KrugCB_ini",NULL);
  MC_KR_Type_UnitCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Type_UnitCB_ini",NULL);
  MC_KR_Type_ObjectCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Type_ObjectCB_ini",NULL);
  MC_KR_Type_LeverCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Type_LeverCB_ini",NULL);
  MC_KR_Type_TrapCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Type_TrapCB_ini",NULL);
  MC_KR_Type_FlameCB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Type_FlameCB_ini",NULL);
  MC_KR_Type_Particle1CB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Type_Particle1CB_ini",NULL);
  MC_KR_Type_Particle2CB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Type_Particle2CB_ini",NULL);
  MC_KR_Type_Particle3CB_ini = MainIni->ReadBool("MassChangeOpts","MC_KR_Type_Particle3CB_ini",NULL);
  MC_AS_Obj_DelRB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Obj_DelRB_ini",NULL);
  MC_AS_Obj_CopyRB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Obj_CopyRB_ini",NULL);
  MC_AS_Obj_MoveRB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Obj_MoveRB_ini",NULL);
  MC_AS_Obj_ReplaceCB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Obj_ReplaceCB_ini",NULL);
  MC_AS_Params_Name1CB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Params_Name1CB_ini",NULL);
  MC_AS_Params_Name2CB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Params_Name2CB_ini",NULL);
  MC_AS_Params_ScriptVariableNameCB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Params_ScriptVariableNameCB_ini",NULL);
  MC_AS_Params_Model3dCB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Params_Model3dCB_ini",NULL);
  MC_AS_Params_FirstTextureCB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Params_FirstTextureCB_ini",NULL);
  MC_AS_Params_SecondTextureCB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Params_SecondTextureCB_ini",NULL);
  MC_AS_Params_PlayerNumberCB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Params_PlayerNumberCB_ini",NULL);
  MC_AS_Params_OffsetCB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Params_OffsetCB_ini",NULL);
  MC_AS_Obj_OnlyParamsRB_ini = MainIni->ReadBool("MassChangeOpts","MC_AS_Obj_OnlyParamsRB_ini",NULL);
  MC_KR_Param_Name1Ed_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Param_Name1Ed_ini",NULL);
  MC_KR_Param_Name2Ed_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Param_Name2Ed_ini",NULL);
  MC_KR_Param_ScriptVariableNameEd_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Param_ScriptVariableNameEd_ini",NULL);
  MC_KR_Param_Model3dEd_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Param_Model3dEd_ini",NULL);
  MC_KR_Param_FirstTextureEd_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Param_FirstTextureEd_ini",NULL);
  MC_KR_Param_SecondTextureEd_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Param_SecondTextureEd_ini",NULL);
  MC_KR_Param_PlayerNumberEd_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Param_PlayerNumberEd_ini",NULL);
  MC_KR_Coords_Pramougl_X1Ed_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Coords_Pramougl_X1Ed_ini",NULL);
  MC_KR_Coords_Pramougl_Y1Ed_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Coords_Pramougl_Y1Ed_ini",NULL);
  MC_KR_Coords_Pramougl_X2Ed_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Coords_Pramougl_X2Ed_ini",NULL);
  MC_KR_Coords_Pramougl_Y2Ed_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Coords_Pramougl_Y2Ed_ini",NULL);
  MC_KR_Coords_Krug_XEd_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Coords_Krug_XEd_ini",NULL);
  MC_KR_Coords_Krug_YEd_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Coords_Krug_YEd_ini",NULL);
  MC_KR_Coords_Krug_RadEd_ini = MainIni->ReadString("MassChangeOpts","MC_KR_Coords_Krug_RadEd_ini",NULL);
  MC_AS_Obj_TargetMobEd_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Obj_TargetMobEd_ini",NULL);
  MC_AS_Params_Name1Ed_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Params_Name1Ed_ini",NULL);
  MC_AS_Params_Name2Ed_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Params_Name2Ed_ini",NULL);
  MC_AS_Params_ScriptVariableNameEd_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Params_ScriptVariableNameEd_ini",NULL);
  MC_AS_Params_Model3dEd_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Params_Model3dEd_ini",NULL);
  MC_AS_Params_FirstTextureEd_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Params_FirstTextureEd_ini",NULL);
  MC_AS_Params_SecondTextureEd_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Params_SecondTextureEd_ini",NULL);
  MC_AS_Params_OffsetXEd_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Params_OffsetXEd_ini",NULL);
  MC_AS_Params_OffsetYEd_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Params_OffsetYEd_ini",NULL);
  MC_AS_Params_PlayerNumberEd_ini = MainIni->ReadString("MassChangeOpts","MC_AS_Params_PlayerNumberEd_ini",NULL);
};

void SaveProgSetts()
//     .
{
  //    :).
  //[Main]
  MainIni->WriteInteger("Main","IniFileVer",IniFileVer);
  MainIni->WriteString("Main","LastProgrVer",VitInfo->GenerateDotsVersionString());  //    "  "  .
  MainIni->WriteBool("Main","UseTMobThreads",UseTMobThreads);
  MainIni->WriteInteger("Main","SaveAttempts",SaveAttempts);
  MainIni->WriteString("Main","WorkPath",WorkPath);
  MainIni->WriteBool("Main","MakeAutoBackups",MakeAutoBackups);
  MainIni->WriteString("Main","SearchStr",SearchStr);
  MainIni->WriteString("Main","RepStr",RepStr);
  MainIni->WriteBool("Main","MakeReplace",MakeReplace);
  //[MassChangeOpts]
  MainIni->WriteBool("MassChangeOpts","MC_KR_Param_Name1CB_ini",MC_KR_Param_Name1CB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Param_Name2CB_ini",MC_KR_Param_Name2CB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Param_ScriptVariableNameCB_ini",MC_KR_Param_ScriptVariableNameCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Param_Model3dCB_ini",MC_KR_Param_Model3dCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Param_FirstTextureCB_ini",MC_KR_Param_FirstTextureCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Param_SecondTextureCB_ini",MC_KR_Param_SecondTextureCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Param_PlayerNumberCB_ini",MC_KR_Param_PlayerNumberCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Coords_PramouglCB_ini",MC_KR_Coords_PramouglCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Coords_KrugCB_ini",MC_KR_Coords_KrugCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Type_UnitCB_ini",MC_KR_Type_UnitCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Type_ObjectCB_ini",MC_KR_Type_ObjectCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Type_LeverCB_ini",MC_KR_Type_LeverCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Type_TrapCB_ini",MC_KR_Type_TrapCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Type_FlameCB_ini",MC_KR_Type_FlameCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Type_Particle1CB_ini",MC_KR_Type_Particle1CB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Type_Particle2CB_ini",MC_KR_Type_Particle2CB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_KR_Type_Particle3CB_ini",MC_KR_Type_Particle3CB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_DelRB_ini",MC_AS_Obj_DelRB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_CopyRB_ini",MC_AS_Obj_CopyRB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_MoveRB_ini",MC_AS_Obj_MoveRB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_ReplaceCB_ini",MC_AS_Obj_ReplaceCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Params_Name1CB_ini",MC_AS_Params_Name1CB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Params_Name2CB_ini",MC_AS_Params_Name2CB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Params_ScriptVariableNameCB_ini",MC_AS_Params_ScriptVariableNameCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Params_Model3dCB_ini",MC_AS_Params_Model3dCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Params_FirstTextureCB_ini",MC_AS_Params_FirstTextureCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Params_SecondTextureCB_ini",MC_AS_Params_SecondTextureCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Params_OffsetCB_ini",MC_AS_Params_OffsetCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Params_PlayerNumberCB_ini",MC_AS_Params_PlayerNumberCB_ini);
  MainIni->WriteBool("MassChangeOpts","MC_AS_Obj_OnlyParamsRB_ini",MC_AS_Obj_OnlyParamsRB_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Param_Name1Ed_ini",MC_KR_Param_Name1Ed_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Param_Name2Ed_ini",MC_KR_Param_Name2Ed_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Param_ScriptVariableNameEd_ini",MC_KR_Param_ScriptVariableNameEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Param_Model3dEd_ini",MC_KR_Param_Model3dEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Param_FirstTextureEd_ini",MC_KR_Param_FirstTextureEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Param_SecondTextureEd_ini",MC_KR_Param_SecondTextureEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Param_PlayerNumberEd_ini",MC_KR_Param_PlayerNumberEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Pramougl_X1Ed_ini",MC_KR_Coords_Pramougl_X1Ed_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Pramougl_Y1Ed_ini",MC_KR_Coords_Pramougl_Y1Ed_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Pramougl_X2Ed_ini",MC_KR_Coords_Pramougl_X2Ed_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Pramougl_Y2Ed_ini",MC_KR_Coords_Pramougl_Y2Ed_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Krug_XEd_ini",MC_KR_Coords_Krug_XEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Krug_YEd_ini",MC_KR_Coords_Krug_YEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_KR_Coords_Krug_RadEd_ini",MC_KR_Coords_Krug_RadEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Obj_TargetMobEd_ini",MC_AS_Obj_TargetMobEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Params_Name1Ed_ini",MC_AS_Params_Name1Ed_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Params_Name2Ed_ini",MC_AS_Params_Name2Ed_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Params_ScriptVariableNameEd_ini",MC_AS_Params_ScriptVariableNameEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Params_Model3dEd_ini",MC_AS_Params_Model3dEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Params_FirstTextureEd_ini",MC_AS_Params_FirstTextureEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Params_SecondTextureEd_ini",MC_AS_Params_SecondTextureEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Params_OffsetXEd_ini",MC_AS_Params_OffsetXEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Params_OffsetYEd_ini",MC_AS_Params_OffsetYEd_ini);
  MainIni->WriteString("MassChangeOpts","MC_AS_Params_PlayerNumberEd_ini",MC_AS_Params_PlayerNumberEd_ini);
  MainIni->UpdateFile(); //    win9x.
};

bool OpenMobComm(const AnsiString FileName)
//     .
{
  //
  bool LoadResult = false, MakeLoad = false, NodeFound = false;
  String FName;
  int i, CurrNodeID;
  TTreeNode *CurrNode;

  if (FileName != "NULL")
  {
    //     ...
    MakeLoad = true;
    FName = FileName;
  }
  else
  {
    //   ...
    //     ...
    MainF->OpenDialog1->InitialDir = WorkPath;
    if (MainF->OpenDialog1->Execute())
    {
      //   -   .
      FName = MainF->OpenDialog1->FileName;
      MakeLoad = true;
    };
  };

  if (MakeLoad == true)
  {
    //   -    :).

    //,    ...
    if ( FileExists(FName) != true )
    {
      //...     ?

      if (ExtractFileExt(FName) == "")
      {
        //,   - ....
        FName += ".mob";
      };

    };

    if ( FileExists(FName) == true )
    {
      //   -   .
      //  -    :).
      WorkPath = ExtractFilePath(FName);
      SaveProgSetts();

      //  .
      if (CloseMobComm() == true)
      {
        MobInMem1->UsingThread = UseTMobThreads;  //    .
        MobInMem1->LogEd = MainF->LogEd;

        //    ...
        if ((UseTMobThreads == true) && (MakeSLBlockInterf == true)) MainF->BlockInterf();
        LoadResult = MobInMem1->LoadMob(FName);
        if ((UseTMobThreads == true) && (MakeSLBlockInterf == true)) MainF->UnBlockInterf();

        if (MobInMem1->UsingThread == false)
        {
          //       .
          if (MainF->MainF_PK->ActivePage->Name == "LogSh")
          {
            MainF->LogEd->SetFocus();
          };
          MainF->LogEd->Lines->Add(MobInMem1->FullLogStr);
        };

        //   ,    ...
        if (LoadResult == true)
        {
          MobFileName = FName;
          MobLoaded = true;  //     .
          MobModified = false;   //       .

          //     ...

          //.
          MainF->ScriptEd->Lines->Clear();
          MainF->ScriptEd->Text = MobInMem1->ScriptText;

          //   ...
          MainF->MobObjectsChanged();
        }//if (LoadResult == true)
        else
        {
          //    -     .
          MainF->MainF_PK->ActivePage = MainF->LogSh;
        };
      };//if (CloseMobComm() == true)
    }//if ( FileExists(FName) == true )
    else
    {
      //   .
      //   ...
      MainF->LogEd->Lines->Add("");
      MainF->LogEd->Lines->Add("    "+FName);
      MainF->LogEd->Lines->Add(" ,   .");
      MainF->MainF_PK->ActivePage = MainF->LogSh;
    };

    //   :).
    MainF->UpdateMainInterf();

  };

  // 
  return LoadResult;
};

bool SaveMobComm()
//     .
{
  //
  bool Result = false;

  //   -        ...
  if (FileExists(MobFileName) == true)
  {
    //     .
    SaveInterfInfo();   //   ...
  
    MobInMem1->UsingThread = UseTMobThreads;  //    .
    MobInMem1->SaveAttempts = SaveAttempts;  //    ...
    MobInMem1->LogEd = MainF->LogEd;
    //    ...
    if ((UseTMobThreads == true) && (MakeSLBlockInterf == true)) MainF->BlockInterf();
    //    - ...
    if (MakeAutoBackups == true) MakeAutoBackup(MobFileName);
    Result = MobInMem1->SaveMob(MobFileName);
    if (Result == true)
    {
      //  -     .
      MainF->SetMobNotModified();
    }
    else
    {
      //    -     .
      MainF->MainF_PK->ActivePage = MainF->LogSh;
    };
    if ((UseTMobThreads == true) && (MakeSLBlockInterf == true)) MainF->UnBlockInterf();

    if (MobInMem1->UsingThread == false)
    {
      //       .
      if (MainF->MainF_PK->ActivePage->Name == "LogSh")
      {
        MainF->LogEd->SetFocus();
      };
      MainF->LogEd->Lines->Add(MobInMem1->FullLogStr);
    };
  }
  else
  {
    // -.   .     SaveAs.
    Result = SaveAsMobComm();
  };

  // .
  return Result;
};

bool SaveAsMobComm()
//         .
{

  bool ManipResult = false;
  bool AllOk = true;

  //  ...
  MainF->OpenDialog1->InitialDir = WorkPath;
  if (MainF->SaveDialog1->Execute())
  {
    //       .
    String FName = MainF->SaveDialog1->FileName;
    //   :).
    WorkPath = ExtractFilePath(FName);
    SaveProgSetts();

    //      ...
    if ( ExtractFileExt(FName) == "" )
    {
      //  -  ...
      FName += ".mob";
    };

    if (FileExists(FName) == true)
    {
      //  ,       ...
      if (MessageBox(Application->Handle,("   "+FName+"  .  ?").c_str(),MobSurgeon_AppName.c_str(),MB_YESNO|MB_ICONWARNING) == ID_YES)
      {
        //  .      -    :)
      }
      else
      {
        //   -  :
        AllOk = false;
      };
    };

    if (AllOk == true)
    {
      //    -  .
      SaveInterfInfo();   //   ...
      MobInMem1->UsingThread = UseTMobThreads;  //    .
      MobInMem1->SaveAttempts = SaveAttempts;  //    ...
      MobInMem1->LogEd = MainF->LogEd;
      //    ...
      if ((UseTMobThreads == true) && (MakeSLBlockInterf == true)) MainF->BlockInterf();
      //    - ...
      if (MakeAutoBackups == true) MakeAutoBackup(FName);
      ManipResult = MobInMem1->SaveMob(FName);
      if ((UseTMobThreads == true) && (MakeSLBlockInterf == true)) MainF->UnBlockInterf();

      if (ManipResult == true)
      {
        //    -    .
        MobFileName = FName;
        //       .
        MainF->SetMobNotModified();
      }
      else
      {
        //    -     .
        MainF->MainF_PK->ActivePage = MainF->LogSh;
      };

      if (MobInMem1->UsingThread == false)
      {
        //       .
        if (MainF->MainF_PK->ActivePage->Name == "LogSh")
        {
          MainF->LogEd->SetFocus();
        };
        MainF->LogEd->Lines->Add(MobInMem1->FullLogStr);
      };
      
    };

  };

  // 
  return ManipResult;
};

bool CloseMobComm()
//     .
{
  //
  int QuestionAnswer;
  bool AllOk = true, Result = false;

  if (MobLoaded == true)
  {
    //     ).
    if (MobModified == true)
    {
      //   -   .
      QuestionAnswer = MessageBox(Application->Handle,(" "+ExtractFileName(MobFileName)+"   .    ?").c_str(),MobSurgeon_AppName.c_str(),MB_YESNOCANCEL|MB_ICONQUESTION);
      //    ...
      if (QuestionAnswer == IDYES)
      {
        //  -  ...
        do
        {
          AllOk = SaveMobComm();
          if (AllOk == false)
          {
            // -      -   .
            QuestionAnswer = MessageBox(Application->Handle,(" "+ExtractFileName(MobFileName)+"   .  ?").c_str(),MobSurgeon_AppName.c_str(),MB_YESNOCANCEL|MB_ICONERROR);
            //  .
            //IDYES -    .. AllOk == false     1  .
            if (QuestionAnswer == IDNO)
            {
              //  .
              AllOk = true;
            }
            else if (QuestionAnswer == IDCANCEL)
            {
              //  .
              AllOk = true;
              Result = true;  //      -      false    ,    .
            };
          };
        } while (AllOk == false);

        if ((AllOk == true) && (Result == true))
        {
          //-   -    AllOk    false.
          //   .
          AllOk = false;
          Result = false;
        };
      }
      else if (QuestionAnswer == IDCANCEL)
      {
        //  -   .
        AllOk = false;
      };
    };//if (MobModified == true)

    // -     -  .
    if (AllOk == true)
    {
      // .
      MobInMem1->UnloadMob();
      MobLoaded = false;
      MobModified = false;
      MobFileName = "";
      //  ...
      MainF->ScriptEd->Lines->Clear();
      MainF->MobObjectsChanged();
      MainF->UpdateMainInterf();
      //Done.
      Result = true;
    };
  }//if (MobLoaded == true)
  else
  {
    //     -    true.
    Result = true;
  };

  // 
  return Result;
};

void SaveInterfInfo()
//        ...
{
  // ...
  MobInMem1->ScriptText = Win2UnixLBText(MainF->ScriptEd->Text);
};

AnsiString ExtractFileNameNoExt(const AnsiString FileName)
//    .
{
  AnsiString TempStr1, TempStr2, Result;
  TempStr1 = ExtractFileName(FileName);
  TempStr2 = ExtractFileExt(FileName);
  Result.SetLength(TempStr1.Length()-TempStr2.Length());
  memcpy(&Result[1],&TempStr1[1],TempStr1.Length()-TempStr2.Length());
  return Result;
};

void MakeUserBackup(const AnsiString FileName)
//  .
{
  AnsiString BackupFileName = "";
  bool AllowOverwrite = false, AllOk = true;

  //  -     .
  BackupFileName = FileName + ".bak.mob";

  //,     ...
  if (FileExists(BackupFileName) == true)
  {
    if (MessageBox(Application->Handle,(" "+BackupFileName+"  .  ?").c_str(),MobSurgeon_AppName.c_str(),MB_YESNO|MB_ICONWARNING) == ID_YES)
    {
      //  .
      AllowOverwrite = true;
    }

    else AllOk = false;
  };
  //       :).
  if (AllOk == true)
  {
    if (CopyFile(FileName.c_str(),BackupFileName.c_str(),!AllowOverwrite) == true)
    {
      //    -        :).
      MainF->LogEd->Lines->Add("------------------------------");
      MainF->LogEd->Lines->Add("     "+BackupFileName);
      MainF->LogEd->Lines->Add("");

    }
    else
    {
      //   -      ,      .
      MainF->LogEd->Lines->Add("------------------------------");
      MainF->LogEd->Lines->Add("    "+BackupFileName+"  !");
      MainF->LogEd->Lines->Add("");
      MainF->MainF_PK->ActivePage = MainF->LogSh;
    };
  }
  else
  {
    MainF->LogEd->Lines->Add("------------------------------");
    MainF->LogEd->Lines->Add("   "+BackupFileName+" !");
    MainF->LogEd->Lines->Add("");
  };
};

void MakeAutoBackup(const AnsiString FileName)
//  .
{
  AnsiString BackupFileName = "";

  //  -     .
  BackupFileName = FileName + ".auto.bak.mob";

  //   :).
  if (CopyFile(FileName.c_str(),BackupFileName.c_str(),false) == true)
  {
    //    -        :).
    MainF->LogEd->Lines->Add("------------------------------");
    MainF->LogEd->Lines->Add("     "+BackupFileName);
    MainF->LogEd->Lines->Add("");

  }
  else
  {
    //   -      ,      .
    MainF->LogEd->Lines->Add("------------------------------");
    MainF->LogEd->Lines->Add("    "+BackupFileName+"  !");
    MainF->LogEd->Lines->Add("");
    MainF->MainF_PK->ActivePage = MainF->LogSh;
  };
};


//////////////////////////////////////////
//                 //
//////////////////////////////////////////

AnsiString Win2UnixLBText(AnsiString& InputStr)
//          ...
{
  //
  AnsiString Result = "";
  __int64 i = 0, j = 0;

  if (InputStr.Length() != 0)
  {
    //     -    :).
    Result.SetLength(InputStr.Length());
    do
    {
      i = i+1;
      if (InputStr[i] != char(0x0D))
      {
        j = j+1;
        memcpy(&Result[j],&InputStr[i],1);
      };
    }
    while (i != InputStr.Length());
    Result.SetLength(j);
  };

  //     :).
  return Result;
};

bool CheckMCFormValues()
//    .
{
  const String RugVirazh=" ,    ?     ";
  //
  bool Result = true;

  //  ...
  if (MainF->MC_KR_Coords_PramouglCB->Checked == true)
  {
    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_KR_Coords_Pramougl_X1Ed->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_KR_Coords_Pramougl_X1Ed").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };  

    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_KR_Coords_Pramougl_Y1Ed->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_KR_Coords_Pramougl_Y1Ed").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };

    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_KR_Coords_Pramougl_X2Ed->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_KR_Coords_Pramougl_X2Ed").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };

    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_KR_Coords_Pramougl_Y2Ed->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_AS_Coords_Pramougl_Y2Ed").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };
  };

  //  
  if (MainF->MC_KR_Coords_KrugCB->Checked == true)
  {
    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_KR_Coords_Krug_XEd->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_KR_Coords_Krug_XEd").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };

    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_KR_Coords_Krug_YEd->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_KR_Coords_Krug_YEd").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };

    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_KR_Coords_Krug_RadEd->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_KR_Coords_Krug_RadEd").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };
  };

  //     ...
  if (MainF->MC_AS_Params_OffsetCB->Checked == true)
  {
    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_AS_Params_OffsetXEd->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_AS_Params_OffsetXEd").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };

    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_AS_Params_OffsetYEd->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_AS_Params_OffsetYEd").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };
  };

  // , ...
  if (MainF->MC_KR_Param_PlayerNumberCB->Checked == true)
  {
    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_KR_Param_PlayerNumberEd->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_KR_Params_PlayerNumberCB").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };
  };

  // , ...
  if (MainF->MC_AS_Params_PlayerNumberCB->Checked == true)
  {
    if (Result == true)
    {
      Result = CheckStrFloat(MainF->MC_AS_Params_PlayerNumberEd->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(RugVirazh+"MC_KR_Params_PlayerNumberEd").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };
  };

  //\  ...
  if ( (MainF->MC_AS_Obj_CopyRB->Checked == true) &&
  (MainF->MC_AS_Obj_MoveRB->Checked == true) )
  {
    if (Result == true)
    {
      Result = FileExists(MainF->MC_AS_Obj_TargetMobEd->Text);
      if (Result == false)
      {
        //   .  .
        MessageBox(Application->Handle,(" "+MainF->MC_AS_Obj_TargetMobEd->Text+"  !").c_str(),MobSurgeon_AppName.c_str(),MB_OK|MB_ICONERROR);
      };
    };
  };

  return Result;
};

void MakeMassChanges()
//  .
{
  //
  bool AllOk = true, TargetMobLoaded = false, CheckInd;
  int i;

  //    .
  MakeSLBlockInterf = false;  // -\   .
  if (UseTMobThreads == true) MainF->BlockInterf();

  //  -     ...
  MainF->LogEd->Lines->Add("---------------------------------------");
  MainF->LogEd->Lines->Add("  ...");
  AllOk = CheckMCFormValues();

  //     -    ...
  if (AllOk == true)
  {
    //  ...
    MainF->LogEd->Lines->Add("    .");

    // -  :).
    //     .
    MainF->LogEd->Lines->Add("  .");
    SaveMobComm();
    //  -      -  .
    if ( (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      MainF->LogEd->Lines->Add("  .");
      TargetMob = new TMob;
      TargetMob->UsingThread = UseTMobThreads;  //    .
      TargetMob->LogEd = MainF->LogEd;

      // ...
      AllOk = TargetMob->LoadMob(MainF->MC_AS_Obj_TargetMobEd->Text);
      TargetMobLoaded = AllOk;

      if (TargetMob->UsingThread == false)
      {
        //       .
        MainF->LogEd->Lines->Add(TargetMob->FullLogStr);
      };
    };


    // -         
    //.  -   -     
    //  .
    if (AllOk == true)
    {
      MainF->LogEd->Lines->Add("       ...");

      // -    .
      if (MainF->MC_KR_Type_UnitCB->Checked == true)
      {
        //.
        if (MobInMem1->UnitObjs.Length != 0)
        {
          //    .
          for (i = 0; i < MobInMem1->UnitObjs.Length; i++)
          {
            CheckInd = MakeMassChangeFilter(OB_Sgn_Unit,i);

            if (CheckInd == true)
            {
              //     .
              MakeMassChangeAction(OB_Sgn_Unit,i);
              //     
              //   - -  i 
              if ( ((MainF->MC_AS_Obj_DelRB->Checked == true) ||
              (MainF->MC_AS_Obj_MoveRB->Checked == true) ) &&
              (MobInMem1->UnitObjs.Length != 0) )
              {
                i = i-1;
              };
              //      -        :)
            };
          };
        };
      };

      if (MainF->MC_KR_Type_ObjectCB->Checked == true)
      {
        //.
        if (MobInMem1->ObjectObjs.Length != 0)
        {
          //    .
          for (i = 0; i < MobInMem1->ObjectObjs.Length; i++)
          {
            CheckInd = MakeMassChangeFilter(OB_Sgn_Object,i);

            if (CheckInd == true)
            {
              //     .
              MakeMassChangeAction(OB_Sgn_Object,i);
              //     
              //   - -  i 
              if ( ((MainF->MC_AS_Obj_DelRB->Checked == true) ||
              (MainF->MC_AS_Obj_MoveRB->Checked == true) ) &&
              (MobInMem1->ObjectObjs.Length != 0) )
              {
                i = i-1;
              };
              //      -        :)
            };
          };
        };
      };

      if (MainF->MC_KR_Type_LeverCB->Checked == true)
      {
        //.
        if (MobInMem1->LeverObjs.Length != 0)
        {
          //    .
          for (i = 0; i < MobInMem1->LeverObjs.Length; i++)
          {
            CheckInd = MakeMassChangeFilter(OB_Sgn_Lever,i);

            if (CheckInd == true)
            {
              //     .
              MakeMassChangeAction(OB_Sgn_Lever,i);
              //     
              //   - -  i 
              if ( ((MainF->MC_AS_Obj_DelRB->Checked == true) ||
              (MainF->MC_AS_Obj_MoveRB->Checked == true) ) &&
              (MobInMem1->LeverObjs.Length != 0) )
              {
                i = i-1;
              };
              //      -        :)
            };
          };
        };
      };

      if (MainF->MC_KR_Type_TrapCB->Checked == true)
      {
        //.
        if (MobInMem1->TrapObjs.Length != 0)
        {
          //    .
          for (i = 0; i < MobInMem1->TrapObjs.Length; i++)
          {
            CheckInd = MakeMassChangeFilter(OB_Sgn_Trap,i);

            if (CheckInd == true)
            {
              //     .
              MakeMassChangeAction(OB_Sgn_Trap,i);
              //     
              //   - -  i 
              if ( ((MainF->MC_AS_Obj_DelRB->Checked == true) ||
              (MainF->MC_AS_Obj_MoveRB->Checked == true) ) &&
              (MobInMem1->TrapObjs.Length != 0) )
              {
                i = i-1;
              };
              //      -        :)
            };
          };
        };
      };

      if (MainF->MC_KR_Type_FlameCB->Checked == true)
      {
        //.
        if (MobInMem1->FlameObjs.Length != 0)
        {
          //    .
          for (i = 0; i < MobInMem1->FlameObjs.Length; i++)
          {
            CheckInd = MakeMassChangeFilter(OB_Sgn_Flame,i);

            if (CheckInd == true)
            {
              //     .
              MakeMassChangeAction(OB_Sgn_Flame,i);
              //     
              //   - -  i 
              if ( ((MainF->MC_AS_Obj_DelRB->Checked == true) ||
              (MainF->MC_AS_Obj_MoveRB->Checked == true) ) &&
              (MobInMem1->FlameObjs.Length != 0) )
              {
                i = i-1;
              };
              //      -        :)
            };
          };
        };
      };

      if (MainF->MC_KR_Type_Particle1CB->Checked == true)
      {
        // 1- .
        if (MobInMem1->Particle1Objs.Length != 0)
        {
          //    .
          for (i = 0; i < MobInMem1->Particle1Objs.Length; i++)
          {
            CheckInd = MakeMassChangeFilter(OB_Sgn_Particle1,i);

            if (CheckInd == true)
            {
              //     .
              MakeMassChangeAction(OB_Sgn_Particle1,i);
              //     
              //   - -  i 
              if ( ((MainF->MC_AS_Obj_DelRB->Checked == true) ||
              (MainF->MC_AS_Obj_MoveRB->Checked == true) ) &&
              (MobInMem1->Particle1Objs.Length != 0) )
              {
                i = i-1;
              };
              //      -        :)
            };
          };
        };
      };

      if (MainF->MC_KR_Type_Particle2CB->Checked == true)
      {
        // 2- .
        if (MobInMem1->Particle2Objs.Length != 0)
        {
          //    .
          for (i = 0; i < MobInMem1->Particle2Objs.Length; i++)
          {
            CheckInd = MakeMassChangeFilter(OB_Sgn_Particle2,i);

            if (CheckInd == true)
            {
              //     .
              MakeMassChangeAction(OB_Sgn_Particle2,i);
              //     
              //   - -  i 
              if ( ((MainF->MC_AS_Obj_DelRB->Checked == true) ||
              (MainF->MC_AS_Obj_MoveRB->Checked == true) ) &&
              (MobInMem1->Particle2Objs.Length != 0) )
              {
                i = i-1;
              };
              //      -        :)
            };
          };
        };
      };

      if (MainF->MC_KR_Type_Particle3CB->Checked == true)
      {
        // 3- .
        if (MobInMem1->Particle3Objs.Length != 0)
        {
          //    .
          for (i = 0; i < MobInMem1->Particle3Objs.Length; i++)
          {
            CheckInd = MakeMassChangeFilter(OB_Sgn_Particle3,i);

            if (CheckInd == true)
            {
              //     .
              MakeMassChangeAction(OB_Sgn_Particle3,i);
              //     
              //   - -  i 
              if ( ((MainF->MC_AS_Obj_DelRB->Checked == true) ||
              (MainF->MC_AS_Obj_MoveRB->Checked == true) ) &&
              (MobInMem1->Particle3Objs.Length != 0) )
              {
                i = i-1;
              };
              //      -        :)
            };
          };
        };
      }; 
    };

    //  .
    //    -      .
    if ( (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      if (TargetMobLoaded == true)
      {
        MainF->LogEd->Lines->Add("  .");
        TargetMob->UsingThread = UseTMobThreads;  //    .
        TargetMob->SaveAttempts = SaveAttempts;  //    ...
        TargetMob->LogEd = MainF->LogEd;
        // ...
        //    - ...
        if (MakeAutoBackups == true) MakeAutoBackup(MainF->MC_AS_Obj_TargetMobEd->Text);
        AllOk = TargetMob->SaveMob(MainF->MC_AS_Obj_TargetMobEd->Text);
        if (MobInMem1->UsingThread == false)
        {
          //       .
          MainF->LogEd->Lines->Add(TargetMob->FullLogStr);
        };
      };
      delete TargetMob;
    };

    //    -   .
    //  -    - 
    //       .
    if (!(MainF->MC_AS_Obj_CopyRB->Checked == true))
    {
      SaveMobComm();
    };  
    OpenMobComm(MobFileName);
    //      .
    //MainF->UpdateMainInterf();
  }
  else
  {
    //.
    MainF->LogEd->Lines->Add("    .");
  };

  if (AllOk == true)
  {
    //    .
    MainF->LogEd->Lines->Add("   .");
  }
  else
  {
    //  .
    MainF->LogEd->Lines->Add("     -  :(.");
  };

  //    .
  if (UseTMobThreads == true) MainF->UnBlockInterf();
  MakeSLBlockInterf = true;  //  .

};

bool MakeMassChangeAction(const DWORD ObjType, DWORD ObjNumber)
// -   .
{
  //
  bool Result = false, AllOk, AllowKillObj;
  int i;
  DWORD CopyObjID;

  if (ObjType == OB_Sgn_Unit)
  {
    // .

    // .      .
    if ((MainF->MC_AS_Obj_OnlyParamsRB->Checked == true) ||
    (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {
      if (MainF->MC_AS_Params_Name1CB->Checked == true)
      {
        MobInMem1->UnitObjs[ObjNumber].Name1 = MainF->MC_AS_Params_Name1Ed->Text;
      };

      if (MainF->MC_AS_Params_Name2CB->Checked == true)
      {
        MobInMem1->UnitObjs[ObjNumber].Name2 = MainF->MC_AS_Params_Name2Ed->Text;
      };

      if (MainF->MC_AS_Params_ScriptVariableNameCB->Checked == true)
      {
        MobInMem1->UnitObjs[ObjNumber].ScriptVariableName = MainF->MC_AS_Params_ScriptVariableNameEd->Text;
      };

      if (MainF->MC_AS_Params_Model3dCB->Checked == true)
      {
        MobInMem1->UnitObjs[ObjNumber].ModelName = MainF->MC_AS_Params_Model3dEd->Text;
      };

      if (MainF->MC_AS_Params_FirstTextureCB->Checked == true)
      {
        MobInMem1->UnitObjs[ObjNumber].FirstTexture = MainF->MC_AS_Params_FirstTextureEd->Text;
      };

      if (MainF->MC_AS_Params_SecondTextureCB->Checked == true)
      {
        MobInMem1->UnitObjs[ObjNumber].SecondTexture = MainF->MC_AS_Params_SecondTextureEd->Text;
      };

      if (MainF->MC_AS_Params_PlayerNumberCB->Checked == true)
      {
        MobInMem1->UnitObjs[ObjNumber].PlayerNumber = StrToInt(MainF->MC_AS_Params_PlayerNumberEd->Text);
      };

      if (MainF->MC_AS_Params_OffsetCB->Checked == true)
      {
        MobInMem1->UnitObjs[ObjNumber].LoadX += StrToFloat(MainF->MC_AS_Params_OffsetXEd->Text);
        MobInMem1->UnitObjs[ObjNumber].LoadY += StrToFloat(MainF->MC_AS_Params_OffsetYEd->Text);
      };
    };

    // (    .)
    if ((MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {
      //  - ,    ID  -.
      //      ID -  .
      CopyObjID = MobInMem1->UnitObjs[ObjNumber].ObjectID;
      if (CopyObjID >= 1000000000)
      {
        //  .
        AllowKillObj = true;
      }
      else
      {
        //  -   .
        AllowKillObj = MainF->MC_AS_Obj_ReplaceCB->Checked;
      };
      AllOk = TargetMob->CheckIDExists(CopyObjID,AllowKillObj);
      if (AllOk == false)
      {
        // ID      -    ID.
        CopyObjID = TargetMob->FindCleanID(false);
        if (CopyObjID != 0)
        {
          //     ID -    .
          AllOk = true;
        };
      };

      if (AllOk == true)
      {
        //     -   :).
        TargetMob->UnitObjs.Length++;
        //   -       ,   -   .
        // ,         :)
        //        :).
        TargetMob->UnitObjs[TargetMob->UnitObjs.Length-1].ReadBlock(MobInMem1->UnitObjs[ObjNumber].GenBlock(NULL),MobInMem1->UnitObjs[ObjNumber].GetBlockSize(),false,NULL);
        //    .
        TargetMob->UnitObjs[TargetMob->UnitObjs.Length-1].ObjectID = CopyObjID;
      };
    };

    //.     .
    if ( (MainF->MC_AS_Obj_DelRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      //     ...      :).
      MobInMem1->KillUnit(ObjNumber);
    };
  };

  if (ObjType == OB_Sgn_Object)
  {
    // .

    // .      .
    if ((MainF->MC_AS_Obj_OnlyParamsRB->Checked == true) ||
    (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {

      if (MainF->MC_AS_Params_Name2CB->Checked == true)
      {
        MobInMem1->ObjectObjs[ObjNumber].Name2 = MainF->MC_AS_Params_Name2Ed->Text;
      };

      if (MainF->MC_AS_Params_ScriptVariableNameCB->Checked == true)
      {
        MobInMem1->ObjectObjs[ObjNumber].ScriptVariableName = MainF->MC_AS_Params_ScriptVariableNameEd->Text;
      };

      if (MainF->MC_AS_Params_Model3dCB->Checked == true)
      {
        MobInMem1->ObjectObjs[ObjNumber].ModelName = MainF->MC_AS_Params_Model3dEd->Text;
      };

      if (MainF->MC_AS_Params_FirstTextureCB->Checked == true)
      {
        MobInMem1->ObjectObjs[ObjNumber].FirstTexture = MainF->MC_AS_Params_FirstTextureEd->Text;
      };

      if (MainF->MC_AS_Params_SecondTextureCB->Checked == true)
      {
        MobInMem1->ObjectObjs[ObjNumber].SecondTexture = MainF->MC_AS_Params_SecondTextureEd->Text;
      };

      if (MainF->MC_AS_Params_PlayerNumberCB->Checked == true)
      {
        MobInMem1->ObjectObjs[ObjNumber].PlayerNumber = StrToInt(MainF->MC_AS_Params_PlayerNumberEd->Text);
      };

      if (MainF->MC_AS_Params_OffsetCB->Checked == true)
      {
        MobInMem1->ObjectObjs[ObjNumber].LoadX += StrToFloat(MainF->MC_AS_Params_OffsetXEd->Text);
        MobInMem1->ObjectObjs[ObjNumber].LoadY += StrToFloat(MainF->MC_AS_Params_OffsetYEd->Text);
      };
    };

    // (    .)
    if ((MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {
      //  - ,    ID  -.
      //      ID -  .
      CopyObjID = MobInMem1->ObjectObjs[ObjNumber].ObjectID;
      if (CopyObjID >= 1000000000)
      {
        //  .
        AllowKillObj = true;
      }
      else
      {
        //  -   .
        AllowKillObj = MainF->MC_AS_Obj_ReplaceCB->Checked;
      };
      AllOk = TargetMob->CheckIDExists(CopyObjID,AllowKillObj);
      if (AllOk == false)
      {
        // ID      -    ID.
        CopyObjID = TargetMob->FindCleanID(false);
        if (CopyObjID != 0)
        {
          //     ID -    .
          AllOk = true;
        };
      };

      if (AllOk == true)
      {
        //     -   :).
        TargetMob->ObjectObjs.Length++;
        //   -       ,   -   .
        // ,         :)
        //        :).
        TargetMob->ObjectObjs[TargetMob->ObjectObjs.Length-1].ReadBlock(MobInMem1->ObjectObjs[ObjNumber].GenBlock(NULL),MobInMem1->ObjectObjs[ObjNumber].GetBlockSize(),false,NULL);
        //    .
        TargetMob->ObjectObjs[TargetMob->ObjectObjs.Length-1].ObjectID = CopyObjID;
      };
    };

    //.     .
    if ( (MainF->MC_AS_Obj_DelRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      //     ...      :).
      MobInMem1->KillObject(ObjNumber);
    };
  };

  if (ObjType == OB_Sgn_Lever)
  {
    // .

    // .      .
    if ((MainF->MC_AS_Obj_OnlyParamsRB->Checked == true) ||
    (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {

      if (MainF->MC_AS_Params_Name2CB->Checked == true)
      {
        MobInMem1->LeverObjs[ObjNumber].Name2 = MainF->MC_AS_Params_Name2Ed->Text;
      };

      if (MainF->MC_AS_Params_ScriptVariableNameCB->Checked == true)
      {
        MobInMem1->LeverObjs[ObjNumber].ScriptVariableName = MainF->MC_AS_Params_ScriptVariableNameEd->Text;
      };

      if (MainF->MC_AS_Params_Model3dCB->Checked == true)
      {
        MobInMem1->LeverObjs[ObjNumber].ModelName = MainF->MC_AS_Params_Model3dEd->Text;
      };

      if (MainF->MC_AS_Params_FirstTextureCB->Checked == true)
      {
        MobInMem1->LeverObjs[ObjNumber].FirstTexture = MainF->MC_AS_Params_FirstTextureEd->Text;
      };

      if (MainF->MC_AS_Params_SecondTextureCB->Checked == true)
      {
        MobInMem1->LeverObjs[ObjNumber].SecondTexture = MainF->MC_AS_Params_SecondTextureEd->Text;
      };

      if (MainF->MC_AS_Params_PlayerNumberCB->Checked == true)
      {
        MobInMem1->LeverObjs[ObjNumber].PlayerNumber = StrToInt(MainF->MC_AS_Params_PlayerNumberEd->Text);
      };

      if (MainF->MC_AS_Params_OffsetCB->Checked == true)
      {
        MobInMem1->LeverObjs[ObjNumber].LoadX += StrToFloat(MainF->MC_AS_Params_OffsetXEd->Text);
        MobInMem1->LeverObjs[ObjNumber].LoadY += StrToFloat(MainF->MC_AS_Params_OffsetYEd->Text);
      };
    };

    // (    .)
    if ((MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {
      //  - ,    ID  -.
      //      ID -  .
      CopyObjID = MobInMem1->LeverObjs[ObjNumber].ObjectID;
      if (CopyObjID >= 1000000000)
      {
        //  .
        AllowKillObj = true;
      }
      else
      {
        //  -   .
        AllowKillObj = MainF->MC_AS_Obj_ReplaceCB->Checked;
      };
      AllOk = TargetMob->CheckIDExists(CopyObjID,AllowKillObj);
      if (AllOk == false)
      {
        // ID      -    ID.
        CopyObjID = TargetMob->FindCleanID(false);
        if (CopyObjID != 0)
        {
          //     ID -    .
          AllOk = true;
        };
      };

      if (AllOk == true)
      {
        //     -   :).
        TargetMob->LeverObjs.Length++;
        //   -       ,   -   .
        // ,         :)
        //        :).
        TargetMob->LeverObjs[TargetMob->LeverObjs.Length-1].ReadBlock(MobInMem1->LeverObjs[ObjNumber].GenBlock(NULL),MobInMem1->LeverObjs[ObjNumber].GetBlockSize(),false,NULL);
        //    .
        TargetMob->LeverObjs[TargetMob->LeverObjs.Length-1].ObjectID = CopyObjID;
      };
    };

    //.     .
    if ( (MainF->MC_AS_Obj_DelRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      //     ...      :).
      MobInMem1->KillLever(ObjNumber);
    };
  };

  if (ObjType == OB_Sgn_Trap)
  {
    // .

    // .      .
    if ((MainF->MC_AS_Obj_OnlyParamsRB->Checked == true) ||
    (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {

      if (MainF->MC_AS_Params_Name2CB->Checked == true)
      {
        MobInMem1->TrapObjs[ObjNumber].Name2 = MainF->MC_AS_Params_Name2Ed->Text;
      };

      if (MainF->MC_AS_Params_ScriptVariableNameCB->Checked == true)
      {
        MobInMem1->TrapObjs[ObjNumber].ScriptVariableName = MainF->MC_AS_Params_ScriptVariableNameEd->Text;
      };

      if (MainF->MC_AS_Params_Model3dCB->Checked == true)
      {
        MobInMem1->TrapObjs[ObjNumber].ModelName = MainF->MC_AS_Params_Model3dEd->Text;
      };

      if (MainF->MC_AS_Params_FirstTextureCB->Checked == true)
      {
        MobInMem1->TrapObjs[ObjNumber].FirstTexture = MainF->MC_AS_Params_FirstTextureEd->Text;
      };

      if (MainF->MC_AS_Params_SecondTextureCB->Checked == true)
      {
        MobInMem1->TrapObjs[ObjNumber].SecondTexture = MainF->MC_AS_Params_SecondTextureEd->Text;
      };

      if (MainF->MC_AS_Params_PlayerNumberCB->Checked == true)
      {
        MobInMem1->TrapObjs[ObjNumber].PlayerNumber = StrToInt(MainF->MC_AS_Params_PlayerNumberEd->Text);
      };

      if (MainF->MC_AS_Params_OffsetCB->Checked == true)
      {
        MobInMem1->TrapObjs[ObjNumber].LoadX += StrToFloat(MainF->MC_AS_Params_OffsetXEd->Text);
        MobInMem1->TrapObjs[ObjNumber].LoadY += StrToFloat(MainF->MC_AS_Params_OffsetYEd->Text);
      };
    };

    // (    .)
    if ((MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {
      //  - ,    ID  -.
      //      ID -  .
      CopyObjID = MobInMem1->TrapObjs[ObjNumber].ObjectID;
      if (CopyObjID >= 1000000000)
      {
        //  .
        AllowKillObj = true;
      }
      else
      {
        //  -   .
        AllowKillObj = MainF->MC_AS_Obj_ReplaceCB->Checked;
      };
      AllOk = TargetMob->CheckIDExists(CopyObjID,AllowKillObj);
      if (AllOk == false)
      {
        // ID      -    ID.
        CopyObjID = TargetMob->FindCleanID(false);
        if (CopyObjID != 0)
        {
          //     ID -    .
          AllOk = true;
        };
      };

      if (AllOk == true)
      {
        //     -   :).
        TargetMob->TrapObjs.Length++;
        //   -       ,   -   .
        // ,         :)
        //        :).
        TargetMob->TrapObjs[TargetMob->TrapObjs.Length-1].ReadBlock(MobInMem1->TrapObjs[ObjNumber].GenBlock(NULL),MobInMem1->TrapObjs[ObjNumber].GetBlockSize(),false,NULL);
        //    .
        TargetMob->TrapObjs[TargetMob->TrapObjs.Length-1].ObjectID = CopyObjID;
      };
    };

    //.     .
    if ( (MainF->MC_AS_Obj_DelRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      //     ...      :).
      MobInMem1->KillTrap(ObjNumber);
    };
  };

  if (ObjType == OB_Sgn_Flame)
  {
    // .

    // .      .
    if ((MainF->MC_AS_Obj_OnlyParamsRB->Checked == true) ||
    (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {

      if (MainF->MC_AS_Params_Name2CB->Checked == true)
      {
        MobInMem1->FlameObjs[ObjNumber].Name2 = MainF->MC_AS_Params_Name2Ed->Text;
      };

      if (MainF->MC_AS_Params_ScriptVariableNameCB->Checked == true)
      {
        MobInMem1->FlameObjs[ObjNumber].ScriptVariableName = MainF->MC_AS_Params_ScriptVariableNameEd->Text;
      };

      if (MainF->MC_AS_Params_Model3dCB->Checked == true)
      {
        MobInMem1->FlameObjs[ObjNumber].ModelName = MainF->MC_AS_Params_Model3dEd->Text;
      };

      if (MainF->MC_AS_Params_FirstTextureCB->Checked == true)
      {
        MobInMem1->FlameObjs[ObjNumber].FirstTexture = MainF->MC_AS_Params_FirstTextureEd->Text;
      };

      if (MainF->MC_AS_Params_SecondTextureCB->Checked == true)
      {
        MobInMem1->FlameObjs[ObjNumber].SecondTexture = MainF->MC_AS_Params_SecondTextureEd->Text;
      };

      if (MainF->MC_AS_Params_PlayerNumberCB->Checked == true)
      {
        MobInMem1->FlameObjs[ObjNumber].PlayerNumber = StrToInt(MainF->MC_AS_Params_PlayerNumberEd->Text);
      };

      if (MainF->MC_AS_Params_OffsetCB->Checked == true)
      {
        MobInMem1->FlameObjs[ObjNumber].LoadX += StrToFloat(MainF->MC_AS_Params_OffsetXEd->Text);
        MobInMem1->FlameObjs[ObjNumber].LoadY += StrToFloat(MainF->MC_AS_Params_OffsetYEd->Text);
      };
    };

    // (    .)
    if ((MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {
      //  - ,    ID  -.
      //      ID -  .
      CopyObjID = MobInMem1->FlameObjs[ObjNumber].ObjectID;
      if (CopyObjID >= 1000000000)
      {
        //  .
        AllowKillObj = true;
      }
      else
      {
        //  -   .
        AllowKillObj = MainF->MC_AS_Obj_ReplaceCB->Checked;
      };
      AllOk = TargetMob->CheckIDExists(CopyObjID,AllowKillObj);
      if (AllOk == false)
      {
        // ID      -    ID.
        CopyObjID = TargetMob->FindCleanID(false);
        if (CopyObjID != 0)
        {
          //     ID -    .
          AllOk = true;
        };
      };

      if (AllOk == true)
      {
        //     -   :).
        TargetMob->FlameObjs.Length++;
        //   -       ,   -   .
        // ,         :)
        //        :).
        TargetMob->FlameObjs[TargetMob->FlameObjs.Length-1].ReadBlock(MobInMem1->FlameObjs[ObjNumber].GenBlock(NULL),MobInMem1->FlameObjs[ObjNumber].GetBlockSize(),false,NULL);
        //    .
        TargetMob->FlameObjs[TargetMob->FlameObjs.Length-1].ObjectID = CopyObjID;
      };
    };

    //.     .
    if ( (MainF->MC_AS_Obj_DelRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      //     ...      :).
      MobInMem1->KillFlame(ObjNumber);
    };
  };

  if (ObjType == OB_Sgn_Particle1)
  {
    //  1- .

    // .      .
    if ((MainF->MC_AS_Obj_OnlyParamsRB->Checked == true) ||
    (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {

      if (MainF->MC_AS_Params_Name2CB->Checked == true)
      {
        MobInMem1->Particle1Objs[ObjNumber].NameStr = MainF->MC_AS_Params_Name2Ed->Text;
      };

      if (MainF->MC_AS_Params_OffsetCB->Checked == true)
      {
        MobInMem1->Particle1Objs[ObjNumber].CoordX += StrToFloat(MainF->MC_AS_Params_OffsetXEd->Text);
        MobInMem1->Particle1Objs[ObjNumber].CoordY += StrToFloat(MainF->MC_AS_Params_OffsetYEd->Text);
      };
    };

    // (    .)
    if ((MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {
      //  - ,    ID  -.
      //      ID -  .
      CopyObjID = MobInMem1->Particle1Objs[ObjNumber].ID;
      if (CopyObjID >= 1000000000)
      {
        //  .
        AllowKillObj = true;
      }
      else
      {
        //  -   .
        AllowKillObj = MainF->MC_AS_Obj_ReplaceCB->Checked;
      };
      AllOk = TargetMob->CheckIDExists(CopyObjID,AllowKillObj);
      if (AllOk == false)
      {
        // ID      -    ID.
        CopyObjID = TargetMob->FindCleanID(false);
        if (CopyObjID != 0)
        {
          //     ID -    .
          AllOk = true;
        };
      };

      if (AllOk == true)
      {
        //     -   :).
        TargetMob->Particle1Objs.Length++;
        //   -       ,   -   .
        // ,         :)
        //        :).
        TargetMob->Particle1Objs[TargetMob->Particle1Objs.Length-1].ReadBlock(MobInMem1->Particle1Objs[ObjNumber].GenBlock(NULL),MobInMem1->Particle1Objs[ObjNumber].GetBlockSize(),false,NULL);
        //    .
        TargetMob->Particle1Objs[TargetMob->Particle1Objs.Length-1].ID = CopyObjID;
      };
    };

    //.     .
    if ( (MainF->MC_AS_Obj_DelRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      //     ...      :).
      MobInMem1->KillParticle1(ObjNumber);
    };
  };

  if (ObjType == OB_Sgn_Particle2)
  {
    //  2- .

    // .      .
    if ((MainF->MC_AS_Obj_OnlyParamsRB->Checked == true) ||
    (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {

      if (MainF->MC_AS_Params_Name2CB->Checked == true)
      {
        MobInMem1->Particle2Objs[ObjNumber].NameStr = MainF->MC_AS_Params_Name2Ed->Text;
      };

      if (MainF->MC_AS_Params_OffsetCB->Checked == true)
      {
        MobInMem1->Particle2Objs[ObjNumber].CoordX += StrToFloat(MainF->MC_AS_Params_OffsetXEd->Text);
        MobInMem1->Particle2Objs[ObjNumber].CoordY += StrToFloat(MainF->MC_AS_Params_OffsetYEd->Text);
      };
    };

    // (    .)
    if ((MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {
      //  - ,    ID  -.
      //      ID -  .
      CopyObjID = MobInMem1->Particle2Objs[ObjNumber].ID;
      if (CopyObjID >= 1000000000)
      {
        //  .
        AllowKillObj = true;
      }
      else
      {
        //  -   .
        AllowKillObj = MainF->MC_AS_Obj_ReplaceCB->Checked;
      };
      AllOk = TargetMob->CheckIDExists(CopyObjID,AllowKillObj);
      if (AllOk == false)
      {
        // ID      -    ID.
        CopyObjID = TargetMob->FindCleanID(false);
        if (CopyObjID != 0)
        {
          //     ID -    .
          AllOk = true;
        };
      };

      if (AllOk == true)
      {
        //     -   :).
        TargetMob->Particle2Objs.Length++;
        //   -       ,   -   .
        // ,         :)
        //        :).
        TargetMob->Particle2Objs[TargetMob->Particle2Objs.Length-1].ReadBlock(MobInMem1->Particle2Objs[ObjNumber].GenBlock(NULL),MobInMem1->Particle2Objs[ObjNumber].GetBlockSize(),false,NULL);
        //    .
        TargetMob->Particle2Objs[TargetMob->Particle2Objs.Length-1].ID = CopyObjID;
      };
    };

    //.     .
    if ( (MainF->MC_AS_Obj_DelRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      //     ...      :).
      MobInMem1->KillParticle2(ObjNumber);
    };
  };

  if (ObjType == OB_Sgn_Particle3)
  {
    //  3- .

    // .      .
    if ((MainF->MC_AS_Obj_OnlyParamsRB->Checked == true) ||
    (MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {

      if (MainF->MC_AS_Params_Name2CB->Checked == true)
      {
        MobInMem1->Particle3Objs[ObjNumber].NameStr = MainF->MC_AS_Params_Name2Ed->Text;
      };

      if (MainF->MC_AS_Params_OffsetCB->Checked == true)
      {
        MobInMem1->Particle3Objs[ObjNumber].CoordX += StrToFloat(MainF->MC_AS_Params_OffsetXEd->Text);
        MobInMem1->Particle3Objs[ObjNumber].CoordY += StrToFloat(MainF->MC_AS_Params_OffsetYEd->Text);
      };
    };

    // (    .)
    if ((MainF->MC_AS_Obj_CopyRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true))
    {
      //  - ,    ID  -.
      //      ID -  .
      CopyObjID = MobInMem1->Particle3Objs[ObjNumber].ID;
      if (CopyObjID >= 1000000000)
      {
        //  .
        AllowKillObj = true;
      }
      else
      {
        //  -   .
        AllowKillObj = MainF->MC_AS_Obj_ReplaceCB->Checked;
      };
      AllOk = TargetMob->CheckIDExists(CopyObjID,AllowKillObj);
      if (AllOk == false)
      {
        // ID      -    ID.
        CopyObjID = TargetMob->FindCleanID(false);
        if (CopyObjID != 0)
        {
          //     ID -    .
          AllOk = true;
        };
      };

      if (AllOk == true)
      {
        //     -   :).
        TargetMob->Particle3Objs.Length++;
        //   -       ,   -   .
        // ,         :)
        //        :).
        TargetMob->Particle3Objs[TargetMob->Particle3Objs.Length-1].ReadBlock(MobInMem1->Particle3Objs[ObjNumber].GenBlock(NULL),MobInMem1->Particle3Objs[ObjNumber].GetBlockSize(),false,NULL);
        //    .
        TargetMob->Particle3Objs[TargetMob->Particle3Objs.Length-1].ID = CopyObjID;
      };
    };

    //.     .
    if ( (MainF->MC_AS_Obj_DelRB->Checked == true) ||
    (MainF->MC_AS_Obj_MoveRB->Checked == true) )
    {
      //     ...      :).
      MobInMem1->KillParticle3(ObjNumber);
    };
  };

  // .
  return Result;
};

bool MakeMassChangeFilter(const DWORD ObjType, DWORD ObjNumber)
// -   .
{
  //
  bool Result = false;
  float TempFloat1;

  if (ObjType == OB_Sgn_Unit)
  {
    //.
    Result = true;  //     -  .
                    //   false   true      .

    //Name1
    if ( (MobInMem1->UnitObjs[ObjNumber].Name1 != MainF->MC_KR_Param_Name1Ed->Text) && (MainF->MC_KR_Param_Name1CB->Checked == true) )
    {
      Result = false;  // .
    };

    //Name2
    if (Result == true)
    {
      if ( (MobInMem1->UnitObjs[ObjNumber].Name2 != MainF->MC_KR_Param_Name2Ed->Text) && (MainF->MC_KR_Param_Name2CB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ScriptVariableName
    if (Result == true)
    {
      if ( (MobInMem1->UnitObjs[ObjNumber].ScriptVariableName != MainF->MC_KR_Param_ScriptVariableNameEd->Text) && (MainF->MC_KR_Param_ScriptVariableNameCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ModelName
    if (Result == true)
    {
      if ( (MobInMem1->UnitObjs[ObjNumber].ModelName != MainF->MC_KR_Param_Model3dEd->Text) && (MainF->MC_KR_Param_Model3dCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //FirstTexture
    if (Result == true)
    {
      if ( (MobInMem1->UnitObjs[ObjNumber].FirstTexture != MainF->MC_KR_Param_FirstTextureEd->Text) && (MainF->MC_KR_Param_FirstTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //SecondTexture
    if (Result == true)
    {
      if ( (MobInMem1->UnitObjs[ObjNumber].SecondTexture != MainF->MC_KR_Param_SecondTextureEd->Text) && (MainF->MC_KR_Param_SecondTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //PlayerNumber
    if (Result == true)
    {
      if (MainF->MC_KR_Param_PlayerNumberCB->Checked == true)
      {
        if (MobInMem1->UnitObjs[ObjNumber].PlayerNumber != StrToInt(MainF->MC_KR_Param_PlayerNumberEd->Text))
        {
          Result = false;  // .
        };
      };
    };

    //
    if (Result == true)
    {
      if (MainF->MC_KR_Coords_PramouglCB->Checked == true)
      {
        if (!((MobInMem1->UnitObjs[ObjNumber].LoadX >= StrToFloat(MainF->MC_KR_Coords_Pramougl_X1Ed->Text)) &&
        (MobInMem1->UnitObjs[ObjNumber].LoadY <= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y1Ed->Text)) &&
        (MobInMem1->UnitObjs[ObjNumber].LoadX <= StrToFloat(MainF->MC_KR_Coords_Pramougl_X2Ed->Text)) &&
        (MobInMem1->UnitObjs[ObjNumber].LoadY >= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y2Ed->Text))))
        {
          Result = false;  // .
        };
      };  
    };

    //
    //   Y   X.
    //    - X   .
    if (MainF->MC_KR_Coords_KrugCB->Checked == true)
    {
      TempFloat1 = (pow(StrToFloat(MainF->MC_KR_Coords_Krug_RadEd->Text),2)-pow((MobInMem1->UnitObjs[ObjNumber].LoadX-StrToFloat(MainF->MC_KR_Coords_Krug_XEd->Text)),2));
      if (TempFloat1 < 0)
      {
        Result = false;  // .
      }
      else
      {
        //   Y.
        //  Y    -    .
        TempFloat1 = sqrt(TempFloat1);
        if (!( ((MobInMem1->UnitObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) <= TempFloat1) &&
        ((MobInMem1->UnitObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) >= -TempFloat1) ))
        {
          Result = false;  // .
        };
      };
    };

    //     .   
    //   -    true.
  };

  if (ObjType == OB_Sgn_Object)
  {
    //.
    Result = true;  //     -  .
                    //   false   true      .

    //Name2
    if (Result == true)
    {
      if ( (MobInMem1->ObjectObjs[ObjNumber].Name2 != MainF->MC_KR_Param_Name2Ed->Text) && (MainF->MC_KR_Param_Name2CB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ScriptVariableName
    if (Result == true)
    {
      if ( (MobInMem1->ObjectObjs[ObjNumber].ScriptVariableName != MainF->MC_KR_Param_ScriptVariableNameEd->Text) && (MainF->MC_KR_Param_ScriptVariableNameCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ModelName
    if (Result == true)
    {
      if ( (MobInMem1->ObjectObjs[ObjNumber].ModelName != MainF->MC_KR_Param_Model3dEd->Text) && (MainF->MC_KR_Param_Model3dCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //FirstTexture
    if (Result == true)
    {
      if ( (MobInMem1->ObjectObjs[ObjNumber].FirstTexture != MainF->MC_KR_Param_FirstTextureEd->Text) && (MainF->MC_KR_Param_FirstTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //SecondTexture
    if (Result == true)
    {
      if ( (MobInMem1->ObjectObjs[ObjNumber].SecondTexture != MainF->MC_KR_Param_SecondTextureEd->Text) && (MainF->MC_KR_Param_SecondTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //PlayerNumber
    if (Result == true)
    {
      if (MainF->MC_KR_Param_PlayerNumberCB->Checked == true)
      {
        if (MobInMem1->ObjectObjs[ObjNumber].PlayerNumber != StrToInt(MainF->MC_KR_Param_PlayerNumberEd->Text))
        {
          Result = false;  // .
        };
      };
    };

     //
    if (Result == true)
    {
      if (MainF->MC_KR_Coords_PramouglCB->Checked == true)
      {
        if (!((MobInMem1->ObjectObjs[ObjNumber].LoadX >= StrToFloat(MainF->MC_KR_Coords_Pramougl_X1Ed->Text)) &&
        (MobInMem1->ObjectObjs[ObjNumber].LoadY <= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y1Ed->Text)) &&
        (MobInMem1->ObjectObjs[ObjNumber].LoadX <= StrToFloat(MainF->MC_KR_Coords_Pramougl_X2Ed->Text)) &&
        (MobInMem1->ObjectObjs[ObjNumber].LoadY >= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y2Ed->Text))))
        {
          Result = false;  // .
        };
      };
    };

    //
    //   Y   X.
    //    - X   .
    if (MainF->MC_KR_Coords_KrugCB->Checked == true)
    {
      TempFloat1 = (pow(StrToFloat(MainF->MC_KR_Coords_Krug_RadEd->Text),2)-pow((MobInMem1->ObjectObjs[ObjNumber].LoadX-StrToFloat(MainF->MC_KR_Coords_Krug_XEd->Text)),2));
      if (TempFloat1 < 0)
      {
        Result = false;  // .
      }
      else
      {
        //   Y.
        //  Y    -    .
        TempFloat1 = sqrt(TempFloat1);
        if (!( ((MobInMem1->ObjectObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) <= TempFloat1) &&
        ((MobInMem1->ObjectObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) >= -TempFloat1) ))
        {
          Result = false;  // .
        };
      };
    };  

    //     .   
    //   -    true.
  };

  if (ObjType == OB_Sgn_Lever)
  {
    //.
    Result = true;  //     -  .
                    //   false   true      .
    //Name2
    if (Result == true)
    {
      if ( (MobInMem1->LeverObjs[ObjNumber].Name2 != MainF->MC_KR_Param_Name2Ed->Text) && (MainF->MC_KR_Param_Name2CB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ScriptVariableName
    if (Result == true)
    {
      if ( (MobInMem1->LeverObjs[ObjNumber].ScriptVariableName != MainF->MC_KR_Param_ScriptVariableNameEd->Text) && (MainF->MC_KR_Param_ScriptVariableNameCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ModelName
    if (Result == true)
    {
      if ( (MobInMem1->LeverObjs[ObjNumber].ModelName != MainF->MC_KR_Param_Model3dEd->Text) && (MainF->MC_KR_Param_Model3dCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //FirstTexture
    if (Result == true)
    {
      if ( (MobInMem1->LeverObjs[ObjNumber].FirstTexture != MainF->MC_KR_Param_FirstTextureEd->Text) && (MainF->MC_KR_Param_FirstTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //SecondTexture
    if (Result == true)
    {
      if ( (MobInMem1->LeverObjs[ObjNumber].SecondTexture != MainF->MC_KR_Param_SecondTextureEd->Text) && (MainF->MC_KR_Param_SecondTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //PlayerNumber
    if (Result == true)
    {
      if (MainF->MC_KR_Param_PlayerNumberCB->Checked == true)
      {
        if (MobInMem1->LeverObjs[ObjNumber].PlayerNumber != StrToInt(MainF->MC_KR_Param_PlayerNumberEd->Text))
        {
          Result = false;  // .
        };
      };
    };

    //
    if (Result == true)
    {
      if (MainF->MC_KR_Coords_PramouglCB->Checked == true)
      {
        if (!((MobInMem1->LeverObjs[ObjNumber].LoadX >= StrToFloat(MainF->MC_KR_Coords_Pramougl_X1Ed->Text)) &&
        (MobInMem1->LeverObjs[ObjNumber].LoadY <= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y1Ed->Text)) &&
        (MobInMem1->LeverObjs[ObjNumber].LoadX <= StrToFloat(MainF->MC_KR_Coords_Pramougl_X2Ed->Text)) &&
        (MobInMem1->LeverObjs[ObjNumber].LoadY >= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y2Ed->Text))))
        {
          Result = false;  // .
        };
      };  
    };

    //
    //   Y   X.
    //    - X   .
    if (MainF->MC_KR_Coords_KrugCB->Checked == true)
    {
      TempFloat1 = (pow(StrToFloat(MainF->MC_KR_Coords_Krug_RadEd->Text),2)-pow((MobInMem1->LeverObjs[ObjNumber].LoadX-StrToFloat(MainF->MC_KR_Coords_Krug_XEd->Text)),2));
      if (TempFloat1 < 0)
      {
        Result = false;  // .
      }
      else
      {
        //   Y.
        //  Y    -    .
        TempFloat1 = sqrt(TempFloat1);
        if (!( ((MobInMem1->LeverObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) <= TempFloat1) &&
        ((MobInMem1->LeverObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) >= -TempFloat1) ))
        {
          Result = false;  // .
        };
      };
    };

    //     .   
    //   -    true.
  };

  if (ObjType == OB_Sgn_Trap)
  {
    //.
    Result = true;  //     -  .
                    //   false   true      .
    //Name2
    if (Result == true)
    {
      if ( (MobInMem1->TrapObjs[ObjNumber].Name2 != MainF->MC_KR_Param_Name2Ed->Text) && (MainF->MC_KR_Param_Name2CB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ScriptVariableName
    if (Result == true)
    {
      if ( (MobInMem1->TrapObjs[ObjNumber].ScriptVariableName != MainF->MC_KR_Param_ScriptVariableNameEd->Text) && (MainF->MC_KR_Param_ScriptVariableNameCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ModelName
    if (Result == true)
    {
      if ( (MobInMem1->TrapObjs[ObjNumber].ModelName != MainF->MC_KR_Param_Model3dEd->Text) && (MainF->MC_KR_Param_Model3dCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //FirstTexture
    if (Result == true)
    {
      if ( (MobInMem1->TrapObjs[ObjNumber].FirstTexture != MainF->MC_KR_Param_FirstTextureEd->Text) && (MainF->MC_KR_Param_FirstTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //SecondTexture
    if (Result == true)
    {
      if ( (MobInMem1->TrapObjs[ObjNumber].SecondTexture != MainF->MC_KR_Param_SecondTextureEd->Text) && (MainF->MC_KR_Param_SecondTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //PlayerNumber
    if (Result == true)
    {
      if (MainF->MC_KR_Param_PlayerNumberCB->Checked == true)
      {
        if (MobInMem1->TrapObjs[ObjNumber].PlayerNumber != StrToInt(MainF->MC_KR_Param_PlayerNumberEd->Text))
        {
          Result = false;  // .
        };
      };
    };

    //
    if (Result == true)
    {
      if (MainF->MC_KR_Coords_PramouglCB->Checked == true)
      {
        if (!((MobInMem1->TrapObjs[ObjNumber].LoadX >= StrToFloat(MainF->MC_KR_Coords_Pramougl_X1Ed->Text)) &&
        (MobInMem1->TrapObjs[ObjNumber].LoadY <= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y1Ed->Text)) &&
        (MobInMem1->TrapObjs[ObjNumber].LoadX <= StrToFloat(MainF->MC_KR_Coords_Pramougl_X2Ed->Text)) &&
        (MobInMem1->TrapObjs[ObjNumber].LoadY >= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y2Ed->Text))))
        {
          Result = false;  // .
        };
      };  
    };

    //
    //   Y   X.
    //    - X   .
    if (MainF->MC_KR_Coords_KrugCB->Checked == true)
    {
      TempFloat1 = (pow(StrToFloat(MainF->MC_KR_Coords_Krug_RadEd->Text),2)-pow((MobInMem1->TrapObjs[ObjNumber].LoadX-StrToFloat(MainF->MC_KR_Coords_Krug_XEd->Text)),2));
      if (TempFloat1 < 0)
      {
        Result = false;  // .
      }
      else
      {
        //   Y.
        //  Y    -    .
        TempFloat1 = sqrt(TempFloat1);
        if (!( ((MobInMem1->TrapObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) <= TempFloat1) &&
        ((MobInMem1->TrapObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) >= -TempFloat1) ))
        {
          Result = false;  // .
        };
      };
    };  

    //     .   
    //   -    true.
  };

  if (ObjType == OB_Sgn_Flame)
  {
    //.
    Result = true;  //     -  .
                    //   false   true      .
    //Name2
    if (Result == true)
    {
      if ( (MobInMem1->FlameObjs[ObjNumber].Name2 != MainF->MC_KR_Param_Name2Ed->Text) && (MainF->MC_KR_Param_Name2CB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ScriptVariableName
    if (Result == true)
    {
      if ( (MobInMem1->FlameObjs[ObjNumber].ScriptVariableName != MainF->MC_KR_Param_ScriptVariableNameEd->Text) && (MainF->MC_KR_Param_ScriptVariableNameCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //ModelName
    if (Result == true)
    {
      if ( (MobInMem1->FlameObjs[ObjNumber].ModelName != MainF->MC_KR_Param_Model3dEd->Text) && (MainF->MC_KR_Param_Model3dCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //FirstTexture
    if (Result == true)
    {
      if ( (MobInMem1->FlameObjs[ObjNumber].FirstTexture != MainF->MC_KR_Param_FirstTextureEd->Text) && (MainF->MC_KR_Param_FirstTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //SecondTexture
    if (Result == true)
    {
      if ( (MobInMem1->FlameObjs[ObjNumber].SecondTexture != MainF->MC_KR_Param_SecondTextureEd->Text) && (MainF->MC_KR_Param_SecondTextureCB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //PlayerNumber
    if (Result == true)
    {
      if (MainF->MC_KR_Param_PlayerNumberCB->Checked == true)
      {
        if (MobInMem1->FlameObjs[ObjNumber].PlayerNumber != StrToInt(MainF->MC_KR_Param_PlayerNumberEd->Text))
        {
          Result = false;  // .
        };
      };
    };

    //
    if (Result == true)
    {
      if (MainF->MC_KR_Coords_PramouglCB->Checked == true)
      {
        if (!((MobInMem1->FlameObjs[ObjNumber].LoadX >= StrToFloat(MainF->MC_KR_Coords_Pramougl_X1Ed->Text)) &&
        (MobInMem1->FlameObjs[ObjNumber].LoadY <= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y1Ed->Text)) &&
        (MobInMem1->FlameObjs[ObjNumber].LoadX <= StrToFloat(MainF->MC_KR_Coords_Pramougl_X2Ed->Text)) &&
        (MobInMem1->FlameObjs[ObjNumber].LoadY >= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y2Ed->Text))))
        {
          Result = false;  // .
        };
      };  
    };

    //
    //   Y   X.
    //    - X   .
    if (MainF->MC_KR_Coords_KrugCB->Checked == true)
    {
      TempFloat1 = (pow(StrToFloat(MainF->MC_KR_Coords_Krug_RadEd->Text),2)-pow((MobInMem1->FlameObjs[ObjNumber].LoadX-StrToFloat(MainF->MC_KR_Coords_Krug_XEd->Text)),2));
      if (TempFloat1 < 0)
      {
        Result = false;  // .
      }
      else
      {
        //   Y.
        //  Y    -    .
        TempFloat1 = sqrt(TempFloat1);
        if (!( ((MobInMem1->FlameObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) <= TempFloat1) &&
        ((MobInMem1->FlameObjs[ObjNumber].LoadY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) >= -TempFloat1) ))
        {
          Result = false;  // .
        };
      };
    };  

    //     .   
    //   -    true.
  };

  if (ObjType == OB_Sgn_Particle1)
  {
    // 1- .
    Result = true;  //     -  .
                    //   false   true      .
    //Name2
    if (Result == true)
    {
      if ( (MobInMem1->Particle1Objs[ObjNumber].NameStr != MainF->MC_KR_Param_Name2Ed->Text) && (MainF->MC_KR_Param_Name2CB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //
    if (Result == true)
    {
      if (MainF->MC_KR_Coords_PramouglCB->Checked == true)
      {
        if (!((MobInMem1->Particle1Objs[ObjNumber].CoordX >= StrToFloat(MainF->MC_KR_Coords_Pramougl_X1Ed->Text)) &&
        (MobInMem1->Particle1Objs[ObjNumber].CoordY <= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y1Ed->Text)) &&
        (MobInMem1->Particle1Objs[ObjNumber].CoordX <= StrToFloat(MainF->MC_KR_Coords_Pramougl_X2Ed->Text)) &&
        (MobInMem1->Particle1Objs[ObjNumber].CoordY >= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y2Ed->Text))))
        {
          Result = false;  // .
        };
      };  
    };

    //
    //   Y   X.
    //    - X   .
    if (MainF->MC_KR_Coords_KrugCB->Checked == true)
    {
      TempFloat1 = (pow(StrToFloat(MainF->MC_KR_Coords_Krug_RadEd->Text),2)-pow((MobInMem1->Particle1Objs[ObjNumber].CoordX-StrToFloat(MainF->MC_KR_Coords_Krug_XEd->Text)),2));
      if (TempFloat1 < 0)
      {
        Result = false;  // .
      }
      else
      {
        //   Y.
        //  Y    -    .
        TempFloat1 = sqrt(TempFloat1);
        if (!( ((MobInMem1->Particle1Objs[ObjNumber].CoordY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) <= TempFloat1) &&
        ((MobInMem1->Particle1Objs[ObjNumber].CoordY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) >= -TempFloat1) ))
        {
          Result = false;  // .
        };
      };
    };

    //     .   
    //   -    true.
  };

  if (ObjType == OB_Sgn_Particle2)
  {
    // 2- .
    Result = true;  //     -  .
                    //   false   true      .
    //Name2
    if (Result == true)
    {
      if ( (MobInMem1->Particle2Objs[ObjNumber].NameStr != MainF->MC_KR_Param_Name2Ed->Text) && (MainF->MC_KR_Param_Name2CB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //
    if (Result == true)
    {
      if (MainF->MC_KR_Coords_PramouglCB->Checked == true)
      {
        if (!((MobInMem1->Particle2Objs[ObjNumber].CoordX >= StrToFloat(MainF->MC_KR_Coords_Pramougl_X1Ed->Text)) &&
        (MobInMem1->Particle2Objs[ObjNumber].CoordY <= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y1Ed->Text)) &&
        (MobInMem1->Particle2Objs[ObjNumber].CoordX <= StrToFloat(MainF->MC_KR_Coords_Pramougl_X2Ed->Text)) &&
        (MobInMem1->Particle2Objs[ObjNumber].CoordY >= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y2Ed->Text))))
        {
          Result = false;  // .
        };
      };  
    };

    //
    //   Y   X.
    //    - X   .
    if (MainF->MC_KR_Coords_KrugCB->Checked == true)
    {
      TempFloat1 = (pow(StrToFloat(MainF->MC_KR_Coords_Krug_RadEd->Text),2)-pow((MobInMem1->Particle2Objs[ObjNumber].CoordX-StrToFloat(MainF->MC_KR_Coords_Krug_XEd->Text)),2));
      if (TempFloat1 < 0)
      {
        Result = false;  // .
      }
      else
      {
        //   Y.
        //  Y    -    .
        TempFloat1 = sqrt(TempFloat1);
        if (!( ((MobInMem1->Particle2Objs[ObjNumber].CoordY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) <= TempFloat1) &&
        ((MobInMem1->Particle2Objs[ObjNumber].CoordY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) >= -TempFloat1) ))
        {
          Result = false;  // .
        };
      };
    };

    //     .   
    //   -    true.
  };

  if (ObjType == OB_Sgn_Particle3)
  {
    // 3- .
    Result = true;  //     -  .
                    //   false   true      .
    //Name2
    if (Result == true)
    {
      if ( (MobInMem1->Particle3Objs[ObjNumber].NameStr != MainF->MC_KR_Param_Name2Ed->Text) && (MainF->MC_KR_Param_Name2CB->Checked == true) )
      {
        Result = false;  // .
      };
    };

    //
    if (Result == true)
    {
      if (MainF->MC_KR_Coords_PramouglCB->Checked == true)
      {
        if (!((MobInMem1->Particle3Objs[ObjNumber].CoordX >= StrToFloat(MainF->MC_KR_Coords_Pramougl_X1Ed->Text)) &&
        (MobInMem1->Particle3Objs[ObjNumber].CoordY <= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y1Ed->Text)) &&
        (MobInMem1->Particle3Objs[ObjNumber].CoordX <= StrToFloat(MainF->MC_KR_Coords_Pramougl_X2Ed->Text)) &&
        (MobInMem1->Particle3Objs[ObjNumber].CoordY >= StrToFloat(MainF->MC_KR_Coords_Pramougl_Y2Ed->Text))))
        {
          Result = false;  // .
        };
      };  
    };

    //
    //   Y   X.
    //    - X   .
    if (MainF->MC_KR_Coords_KrugCB->Checked == true)
    {
      TempFloat1 = (pow(StrToFloat(MainF->MC_KR_Coords_Krug_RadEd->Text),2)-pow((MobInMem1->Particle3Objs[ObjNumber].CoordX-StrToFloat(MainF->MC_KR_Coords_Krug_XEd->Text)),2));
      if (TempFloat1 < 0)
      {
        Result = false;  // .
      }
      else
      {
        //   Y.
        //  Y    -    .
        TempFloat1 = sqrt(TempFloat1);
        if (!( ((MobInMem1->Particle3Objs[ObjNumber].CoordY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) <= TempFloat1) &&
        ((MobInMem1->Particle3Objs[ObjNumber].CoordY-StrToFloat(MainF->MC_KR_Coords_Krug_YEd->Text)) >= -TempFloat1) ))
        {
          Result = false;  // .
        };
      };
    };

    //     .   
    //   -    true.
  };

  // .
  return Result;
};

AnsiString StrArray2StrCommaList(DynamicArray <String> *StrArray)
//      ,  - .
{
  //
  AnsiString Result = "";
  int i;

  // , ...
  for (i = 0; i < StrArray->get_length(); i++)
  {
    //   %).
    if (Result.Length() > 0)
    {
      Result = Result+",";
    };
    Result = Result+(*StrArray)[i];
  };

  // ...
  return Result;
};

AnsiString Norm_StrCommaList(AnsiString& Str)
//""  -    ...
{
  //
  AnsiString Result = "", Str2;
  int i,j, ProbelsPassed;
  bool LastIsComma;

  //Result.SetLength(1);

  if ( Str.Length() != 0 )
  {
    //      %)

    //1)   ...
    //,  %).
    j = -1;
    LastIsComma = false;
    ProbelsPassed = 0;
    for (i = 1; i <= Str.Length(); i++)
    {
      if ( !((LastIsComma == true)&&(Str[i] == ' ')) )
      {
        //          -    %).
        //   ...

        // ..
        if (Str[i] == ' ')
        {
          //   ...
          ProbelsPassed = ProbelsPassed + 1;
        }
        else
        {
          //   ...
          if (Str[i] != ',')
          {
            //    ...
            ProbelsPassed = 0;
          };
        };

        // ...
        if (Str[i] == ',')
        {
          LastIsComma = true;
          j = (j-ProbelsPassed+1);
          Result.SetLength(j);
          Result = Result + Str[i];  //,  ...
        }
        else
        {
          LastIsComma = false;
          Result = Result + Str[i];  //  ...
          j = j+1;
        };
      };
    };

  };

  // ...
  return Result;
};

bool Check_StrCommaList(AnsiString& Str)
//   ...
{
  //
  bool Result = true;

  // ...
  //   ...

  // ...
  return Result;
};

void StrCommaList2StrArray(AnsiString InputStr, DynamicArray <String> *OutputArray)
//     ...
{
  //...
  int i, j;

  //,   %).
  
  // -  ...
  OutputArray->set_length(0);

  //     ...
  if (InputStr.Length() != 0)
  {
    //      - ...

    j = 0;
    OutputArray->set_length(j+1);
    //    ...
    for (i = 1; i <= InputStr.Length(); i++)
    {
      if (InputStr[i] != ',')
      {
        //   -     ...
        (*OutputArray)[j] = (*OutputArray)[j]+InputStr[i];
      }
      else
      {
        // -       ...
        j = j+1;
        OutputArray->set_length(j+1);
      };
    };

  };        
};
